/**
 * vis-network
 * https://visjs.github.io/vis-network/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 7.3.3
 * @date    2020-02-02T17:06:54.847Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("vis-util"),require("keycharm"),require("vis-data")):"function"==typeof define&&define.amd?define(["exports","vis-util","keycharm","vis-data"],t):t((e=e||self).vis=e.vis||{},e.vis,e.keycharm,e.vis)}(this,(function(e,t,i,o){"use strict";var n="default"in t?t.default:t;i=i&&i.hasOwnProperty("default")?i.default:i;var s="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(e,t){return e(t={exports:{}},t.exports),t.exports}function a(e){return e&&e.default||e}var h=function(e){return e&&e.Math==Math&&e},d=h("object"==typeof globalThis&&globalThis)||h("object"==typeof window&&window)||h("object"==typeof self&&self)||h("object"==typeof s&&s)||Function("return this")(),l=function(e){try{return!!e()}catch(e){return!0}},c=!l((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),u={}.propertyIsEnumerable,p=Object.getOwnPropertyDescriptor,f={f:p&&!u.call({1:2},1)?function(e){var t=p(this,e);return!!t&&t.enumerable}:u},v=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}},g={}.toString,y=function(e){return g.call(e).slice(8,-1)},m="".split,b=l((function(){return!Object("z").propertyIsEnumerable(0)}))?function(e){return"String"==y(e)?m.call(e,""):Object(e)}:Object,w=function(e){if(null==e)throw TypeError("Can't call method on "+e);return e},k=function(e){return b(w(e))},_=function(e){return"object"==typeof e?null!==e:"function"==typeof e},x=function(e,t){if(!_(e))return e;var i,o;if(t&&"function"==typeof(i=e.toString)&&!_(o=i.call(e)))return o;if("function"==typeof(i=e.valueOf)&&!_(o=i.call(e)))return o;if(!t&&"function"==typeof(i=e.toString)&&!_(o=i.call(e)))return o;throw TypeError("Can't convert object to primitive value")},E={}.hasOwnProperty,O=function(e,t){return E.call(e,t)},C=d.document,T=_(C)&&_(C.createElement),S=function(e){return T?C.createElement(e):{}},M=!c&&!l((function(){return 7!=Object.defineProperty(S("div"),"a",{get:function(){return 7}}).a})),D=Object.getOwnPropertyDescriptor,I={f:c?D:function(e,t){if(e=k(e),t=x(t,!0),M)try{return D(e,t)}catch(e){}if(O(e,t))return v(!f.f.call(e,t),e[t])}},P=/#|\.prototype\./,F=function(e,t){var i=z[B(e)];return i==A||i!=N&&("function"==typeof t?l(t):!!t)},B=F.normalize=function(e){return String(e).replace(P,".").toLowerCase()},z=F.data={},N=F.NATIVE="N",A=F.POLYFILL="P",R=F,L={},j=function(e){if("function"!=typeof e)throw TypeError(String(e)+" is not a function");return e},H=function(e,t,i){if(j(e),void 0===t)return e;switch(i){case 0:return function(){return e.call(t)};case 1:return function(i){return e.call(t,i)};case 2:return function(i,o){return e.call(t,i,o)};case 3:return function(i,o,n){return e.call(t,i,o,n)}}return function(){return e.apply(t,arguments)}},W=function(e){if(!_(e))throw TypeError(String(e)+" is not an object");return e},V=Object.defineProperty,q={f:c?V:function(e,t,i){if(W(e),t=x(t,!0),W(i),M)try{return V(e,t,i)}catch(e){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(e[t]=i.value),e}},U=c?function(e,t,i){return q.f(e,t,v(1,i))}:function(e,t,i){return e[t]=i,e},Y=I.f,X=function(e){var t=function(t,i,o){if(this instanceof e){switch(arguments.length){case 0:return new e;case 1:return new e(t);case 2:return new e(t,i)}return new e(t,i,o)}return e.apply(this,arguments)};return t.prototype=e.prototype,t},G=function(e,t){var i,o,n,s,r,a,h,l,c=e.target,u=e.global,p=e.stat,f=e.proto,v=u?d:p?d[c]:(d[c]||{}).prototype,g=u?L:L[c]||(L[c]={}),y=g.prototype;for(n in t)i=!R(u?n:c+(p?".":"#")+n,e.forced)&&v&&O(v,n),r=g[n],i&&(a=e.noTargetGet?(l=Y(v,n))&&l.value:v[n]),s=i&&a?a:t[n],i&&typeof r==typeof s||(h=e.bind&&i?H(s,d):e.wrap&&i?X(s):f&&"function"==typeof s?H(Function.call,s):s,(e.sham||s&&s.sham||r&&r.sham)&&U(h,"sham",!0),g[n]=h,f&&(O(L,o=c+"Prototype")||U(L,o,{}),L[o][n]=s,e.real&&y&&!y[n]&&U(y,n,s)))},K=[].slice,Z={},$=function(e,t,i){if(!(t in Z)){for(var o=[],n=0;n<t;n++)o[n]="a["+n+"]";Z[t]=Function("C,a","return new C("+o.join(",")+")")}return Z[t](e,i)},J=Function.bind||function(e){var t=j(this),i=K.call(arguments,1),o=function(){var n=i.concat(K.call(arguments));return this instanceof o?$(t,n.length,n):t.apply(e,n)};return _(t.prototype)&&(o.prototype=t.prototype),o};G({target:"Function",proto:!0},{bind:J});var Q=function(e){return L[e+"Prototype"]},ee=Q("Function").bind,te=Function.prototype,ie=function(e){var t=e.bind;return e===te||e instanceof Function&&t===te.bind?ee:t};function oe(e,t,i,o){e.beginPath(),e.arc(t,i,o,0,2*Math.PI,!1),e.closePath()}function ne(e,t,i,o,n,s){var r=Math.PI/180;o-2*s<0&&(s=o/2),n-2*s<0&&(s=n/2),e.beginPath(),e.moveTo(t+s,i),e.lineTo(t+o-s,i),e.arc(t+o-s,i+s,s,270*r,360*r,!1),e.lineTo(t+o,i+n-s),e.arc(t+o-s,i+n-s,s,0,90*r,!1),e.lineTo(t+s,i+n),e.arc(t+s,i+n-s,s,90*r,180*r,!1),e.lineTo(t,i+s),e.arc(t+s,i+s,s,180*r,270*r,!1),e.closePath()}function se(e,t,i,o,n){var s=o/2*.5522848,r=n/2*.5522848,a=t+o,h=i+n,d=t+o/2,l=i+n/2;e.beginPath(),e.moveTo(t,l),e.bezierCurveTo(t,l-r,d-s,i,d,i),e.bezierCurveTo(d+s,i,a,l-r,a,l),e.bezierCurveTo(a,l+r,d+s,h,d,h),e.bezierCurveTo(d-s,h,t,l+r,t,l),e.closePath()}function re(e,t,i,o,n){var s=n*(1/3),r=o/2*.5522848,a=s/2*.5522848,h=t+o,d=i+s,l=t+o/2,c=i+s/2,u=i+(n-s/2),p=i+n;e.beginPath(),e.moveTo(h,c),e.bezierCurveTo(h,c+a,l+r,d,l,d),e.bezierCurveTo(l-r,d,t,c+a,t,c),e.bezierCurveTo(t,c-a,l-r,i,l,i),e.bezierCurveTo(l+r,i,h,c-a,h,c),e.lineTo(h,u),e.bezierCurveTo(h,u+a,l+r,p,l,p),e.bezierCurveTo(l-r,p,t,u+a,t,u),e.lineTo(t,c)}function ae(e,t,i,o,n,s){e.beginPath(),e.moveTo(t,i);for(var r=s.length,a=o-t,h=n-i,d=h/a,l=Math.sqrt(a*a+h*h),c=0,u=!0,p=0,f=+s[0];l>=.1;)(f=+s[c++%r])>l&&(f=l),p=Math.sqrt(f*f/(1+d*d)),t+=p=a<0?-p:p,i+=d*p,!0===u?e.lineTo(t,i):e.moveTo(t,i),l-=f,u=!u}var he={circle:oe,dashedLine:ae,database:re,diamond:function(e,t,i,o){e.beginPath(),e.lineTo(t,i+o),e.lineTo(t+o,i),e.lineTo(t,i-o),e.lineTo(t-o,i),e.closePath()},ellipse:se,ellipse_vis:se,hexagon:function(e,t,i,o){e.beginPath();var n=2*Math.PI/6;e.moveTo(t+o,i);for(var s=1;s<6;s++)e.lineTo(t+o*Math.cos(n*s),i+o*Math.sin(n*s));e.closePath()},roundRect:ne,square:function(e,t,i,o){e.beginPath(),e.rect(t-o,i-o,2*o,2*o),e.closePath()},star:function(e,t,i,o){e.beginPath(),i+=.1*(o*=.82);for(var n=0;n<10;n++){var s=n%2==0?1.3*o:.5*o;e.lineTo(t+s*Math.sin(2*n*Math.PI/10),i-s*Math.cos(2*n*Math.PI/10))}e.closePath()},triangle:function(e,t,i,o){e.beginPath(),i+=.275*(o*=1.15);var n=2*o,s=n/2,r=Math.sqrt(3)/6*n,a=Math.sqrt(n*n-s*s);e.moveTo(t,i-(a-r)),e.lineTo(t+s,i+r),e.lineTo(t-s,i+r),e.lineTo(t,i-(a-r)),e.closePath()},triangleDown:function(e,t,i,o){e.beginPath(),i-=.275*(o*=1.15);var n=2*o,s=n/2,r=Math.sqrt(3)/6*n,a=Math.sqrt(n*n-s*s);e.moveTo(t,i+(a-r)),e.lineTo(t+s,i-r),e.lineTo(t-s,i-r),e.lineTo(t,i+(a-r)),e.closePath()}};var de=r((function(e){function t(e){if(e)return function(e){for(var i in t.prototype)e[i]=t.prototype[i];return e}(e)}e.exports=t,t.prototype.on=t.prototype.addEventListener=function(e,t){return this._callbacks=this._callbacks||{},(this._callbacks["$"+e]=this._callbacks["$"+e]||[]).push(t),this},t.prototype.once=function(e,t){function i(){this.off(e,i),t.apply(this,arguments)}return i.fn=t,this.on(e,i),this},t.prototype.off=t.prototype.removeListener=t.prototype.removeAllListeners=t.prototype.removeEventListener=function(e,t){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,o=this._callbacks["$"+e];if(!o)return this;if(1==arguments.length)return delete this._callbacks["$"+e],this;for(var n=0;n<o.length;n++)if((i=o[n])===t||i.fn===t){o.splice(n,1);break}return 0===o.length&&delete this._callbacks["$"+e],this},t.prototype.emit=function(e){this._callbacks=this._callbacks||{};for(var t=new Array(arguments.length-1),i=this._callbacks["$"+e],o=1;o<arguments.length;o++)t[o-1]=arguments[o];if(i){o=0;for(var n=(i=i.slice(0)).length;o<n;++o)i[o].apply(this,t)}return this},t.prototype.listeners=function(e){return this._callbacks=this._callbacks||{},this._callbacks["$"+e]||[]},t.prototype.hasListeners=function(e){return!!this.listeners(e).length}})),le={},ce=d["__core-js_shared__"]||function(e,t){try{U(d,e,t)}catch(i){d[e]=t}return t}("__core-js_shared__",{}),ue=Function.toString;"function"!=typeof ce.inspectSource&&(ce.inspectSource=function(e){return ue.call(e)});var pe,fe,ve,ge=ce.inspectSource,ye=d.WeakMap,me="function"==typeof ye&&/native code/.test(ge(ye)),be=r((function(e){(e.exports=function(e,t){return ce[e]||(ce[e]=void 0!==t?t:{})})("versions",[]).push({version:"3.6.3",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),we=0,ke=Math.random(),_e=function(e){return"Symbol("+String(void 0===e?"":e)+")_"+(++we+ke).toString(36)},xe=be("keys"),Ee=function(e){return xe[e]||(xe[e]=_e(e))},Oe={},Ce=d.WeakMap;if(me){var Te=new Ce,Se=Te.get,Me=Te.has,De=Te.set;pe=function(e,t){return De.call(Te,e,t),t},fe=function(e){return Se.call(Te,e)||{}},ve=function(e){return Me.call(Te,e)}}else{var Ie=Ee("state");Oe[Ie]=!0,pe=function(e,t){return U(e,Ie,t),t},fe=function(e){return O(e,Ie)?e[Ie]:{}},ve=function(e){return O(e,Ie)}}var Pe,Fe,Be,ze={set:pe,get:fe,has:ve,enforce:function(e){return ve(e)?fe(e):pe(e,{})},getterFor:function(e){return function(t){var i;if(!_(t)||(i=fe(t)).type!==e)throw TypeError("Incompatible receiver, "+e+" required");return i}}},Ne=function(e){return Object(w(e))},Ae=!l((function(){function e(){}return e.prototype.constructor=null,Object.getPrototypeOf(new e)!==e.prototype})),Re=Ee("IE_PROTO"),Le=Object.prototype,je=Ae?Object.getPrototypeOf:function(e){return e=Ne(e),O(e,Re)?e[Re]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?Le:null},He=!!Object.getOwnPropertySymbols&&!l((function(){return!String(Symbol())})),We=He&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Ve=be("wks"),qe=d.Symbol,Ue=We?qe:qe&&qe.withoutSetter||_e,Ye=function(e){return O(Ve,e)||(He&&O(qe,e)?Ve[e]=qe[e]:Ve[e]=Ue("Symbol."+e)),Ve[e]},Xe=(Ye("iterator"),!1);[].keys&&("next"in(Be=[].keys())?(Fe=je(je(Be)))!==Object.prototype&&(Pe=Fe):Xe=!0),null==Pe&&(Pe={});var Ge,Ke={IteratorPrototype:Pe,BUGGY_SAFARI_ITERATORS:Xe},Ze=Math.ceil,$e=Math.floor,Je=function(e){return isNaN(e=+e)?0:(e>0?$e:Ze)(e)},Qe=Math.min,et=function(e){return e>0?Qe(Je(e),9007199254740991):0},tt=Math.max,it=Math.min,ot=function(e,t){var i=Je(e);return i<0?tt(i+t,0):it(i,t)},nt=function(e){return function(t,i,o){var n,s=k(t),r=et(s.length),a=ot(o,r);if(e&&i!=i){for(;r>a;)if((n=s[a++])!=n)return!0}else for(;r>a;a++)if((e||a in s)&&s[a]===i)return e||a||0;return!e&&-1}},st={includes:nt(!0),indexOf:nt(!1)},rt=st.indexOf,at=function(e,t){var i,o=k(e),n=0,s=[];for(i in o)!O(Oe,i)&&O(o,i)&&s.push(i);for(;t.length>n;)O(o,i=t[n++])&&(~rt(s,i)||s.push(i));return s},ht=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],dt=Object.keys||function(e){return at(e,ht)},lt=c?Object.defineProperties:function(e,t){W(e);for(var i,o=dt(t),n=o.length,s=0;n>s;)q.f(e,i=o[s++],t[i]);return e},ct=function(e){return"function"==typeof e?e:void 0},ut=function(e,t){return arguments.length<2?ct(L[e])||ct(d[e]):L[e]&&L[e][t]||d[e]&&d[e][t]},pt=ut("document","documentElement"),ft=Ee("IE_PROTO"),vt=function(){},gt=function(e){return"<script>"+e+"<\/script>"},yt=function(){try{Ge=document.domain&&new ActiveXObject("htmlfile")}catch(e){}var e,t;yt=Ge?function(e){e.write(gt("")),e.close();var t=e.parentWindow.Object;return e=null,t}(Ge):((t=S("iframe")).style.display="none",pt.appendChild(t),t.src=String("javascript:"),(e=t.contentWindow.document).open(),e.write(gt("document.F=Object")),e.close(),e.F);for(var i=ht.length;i--;)delete yt.prototype[ht[i]];return yt()};Oe[ft]=!0;var mt=Object.create||function(e,t){var i;return null!==e?(vt.prototype=W(e),i=new vt,vt.prototype=null,i[ft]=e):i=yt(),void 0===t?i:lt(i,t)},bt={};bt[Ye("toStringTag")]="z";var wt="[object z]"===String(bt),kt=Ye("toStringTag"),_t="Arguments"==y(function(){return arguments}()),xt=wt?y:function(e){var t,i,o;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(i=function(e,t){try{return e[t]}catch(e){}}(t=Object(e),kt))?i:_t?y(t):"Object"==(o=y(t))&&"function"==typeof t.callee?"Arguments":o},Et=wt?{}.toString:function(){return"[object "+xt(this)+"]"},Ot=q.f,Ct=Ye("toStringTag"),Tt=function(e,t,i,o){if(e){var n=i?e:e.prototype;O(n,Ct)||Ot(n,Ct,{configurable:!0,value:t}),o&&!wt&&U(n,"toString",Et)}},St=Ke.IteratorPrototype,Mt=function(){return this},Dt=Object.setPrototypeOf||("__proto__"in{}?function(){var e,t=!1,i={};try{(e=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),t=i instanceof Array}catch(e){}return function(i,o){return W(i),function(e){if(!_(e)&&null!==e)throw TypeError("Can't set "+String(e)+" as a prototype")}(o),t?e.call(i,o):i.__proto__=o,i}}():void 0),It=function(e,t,i,o){o&&o.enumerable?e[t]=i:U(e,t,i)},Pt=Ke.IteratorPrototype,Ft=Ke.BUGGY_SAFARI_ITERATORS,Bt=Ye("iterator"),zt=function(){return this},Nt=function(e,t,i,o,n,s,r){!function(e,t,i){var o=t+" Iterator";e.prototype=mt(St,{next:v(1,i)}),Tt(e,o,!1,!0),le[o]=Mt}(i,t,o);var a,h,d,l=function(e){if(e===n&&g)return g;if(!Ft&&e in p)return p[e];switch(e){case"keys":case"values":case"entries":return function(){return new i(this,e)}}return function(){return new i(this)}},c=t+" Iterator",u=!1,p=e.prototype,f=p[Bt]||p["@@iterator"]||n&&p[n],g=!Ft&&f||l(n),y="Array"==t&&p.entries||f;if(y&&(a=je(y.call(new e)),Pt!==Object.prototype&&a.next&&(Tt(a,c,!0,!0),le[c]=zt)),"values"==n&&f&&"values"!==f.name&&(u=!0,g=function(){return f.call(this)}),r&&p[Bt]!==g&&U(p,Bt,g),le[t]=g,n)if(h={values:l("values"),keys:s?g:l("keys"),entries:l("entries")},r)for(d in h)!Ft&&!u&&d in p||It(p,d,h[d]);else G({target:t,proto:!0,forced:Ft||u},h);return h},At=ze.set,Rt=ze.getterFor("Array Iterator");Nt(Array,"Array",(function(e,t){At(this,{type:"Array Iterator",target:k(e),index:0,kind:t})}),(function(){var e=Rt(this),t=e.target,i=e.kind,o=e.index++;return!t||o>=t.length?(e.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:o,done:!1}:"values"==i?{value:t[o],done:!1}:{value:[o,t[o]],done:!1}}),"values");le.Arguments=le.Array;var Lt=Ye("toStringTag");for(var jt in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Ht=d[jt],Wt=Ht&&Ht.prototype;Wt&&xt(Wt)!==Lt&&U(Wt,Lt,jt),le[jt]=le.Array}var Vt=Array.isArray||function(e){return"Array"==y(e)},qt=Ye("species"),Ut=function(e,t){var i;return Vt(e)&&("function"!=typeof(i=e.constructor)||i!==Array&&!Vt(i.prototype)?_(i)&&null===(i=i[qt])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===t?0:t)},Yt=[].push,Xt=function(e){var t=1==e,i=2==e,o=3==e,n=4==e,s=6==e,r=5==e||s;return function(a,h,d,l){for(var c,u,p=Ne(a),f=b(p),v=H(h,d,3),g=et(f.length),y=0,m=l||Ut,w=t?m(a,g):i?m(a,0):void 0;g>y;y++)if((r||y in f)&&(u=v(c=f[y],y,p),e))if(t)w[y]=u;else if(u)switch(e){case 3:return!0;case 5:return c;case 6:return y;case 2:Yt.call(w,c)}else if(n)return!1;return s?-1:o||n?n:w}},Gt={forEach:Xt(0),map:Xt(1),filter:Xt(2),some:Xt(3),every:Xt(4),find:Xt(5),findIndex:Xt(6)},Kt=function(e,t){var i=[][e];return!!i&&l((function(){i.call(null,t||function(){throw 1},1)}))},Zt=Object.defineProperty,$t=function(e){throw e},Jt=function(e,t){t||(t={});var i=[][e],o=!!O(t,"ACCESSORS")&&t.ACCESSORS,n=O(t,0)?t[0]:$t,s=O(t,1)?t[1]:void 0;return!!i&&!l((function(){if(o&&!c)return!0;var e={length:-1},t=function(t){o?Zt(e,t,{enumerable:!0,get:$t}):e[t]=1};t(1),t(2147483646),t(4294967294),i.call(e,n,s)}))},Qt=Gt.forEach,ei=Kt("forEach"),ti=Jt("forEach"),ii=ei&&ti?[].forEach:function(e){return Qt(this,e,arguments.length>1?arguments[1]:void 0)};G({target:"Array",proto:!0,forced:[].forEach!=ii},{forEach:ii});var oi=Q("Array").forEach,ni=Array.prototype,si={DOMTokenList:!0,NodeList:!0},ri=function(e){var t=e.forEach;return e===ni||e instanceof Array&&t===ni.forEach||si.hasOwnProperty(xt(e))?oi:t};G({target:"Array",stat:!0},{isArray:Vt});var ai,hi,di=L.Array.isArray,li=di,ci=function(e,t,i){var o=x(t);o in e?q.f(e,o,v(0,i)):e[o]=i},ui=ut("navigator","userAgent")||"",pi=d.process,fi=pi&&pi.versions,vi=fi&&fi.v8;vi?hi=(ai=vi.split("."))[0]+ai[1]:ui&&(!(ai=ui.match(/Edge\/(\d+)/))||ai[1]>=74)&&(ai=ui.match(/Chrome\/(\d+)/))&&(hi=ai[1]);var gi=hi&&+hi,yi=Ye("species"),mi=function(e){return gi>=51||!l((function(){var t=[];return(t.constructor={})[yi]=function(){return{foo:1}},1!==t[e](Boolean).foo}))},bi=mi("splice"),wi=Jt("splice",{ACCESSORS:!0,0:0,1:2}),ki=Math.max,_i=Math.min;G({target:"Array",proto:!0,forced:!bi||!wi},{splice:function(e,t){var i,o,n,s,r,a,h=Ne(this),d=et(h.length),l=ot(e,d),c=arguments.length;if(0===c?i=o=0:1===c?(i=0,o=d-l):(i=c-2,o=_i(ki(Je(t),0),d-l)),d+i-o>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(n=Ut(h,o),s=0;s<o;s++)(r=l+s)in h&&ci(n,s,h[r]);if(n.length=o,i<o){for(s=l;s<d-o;s++)a=s+i,(r=s+o)in h?h[a]=h[r]:delete h[a];for(s=d;s>d-o+i;s--)delete h[s-1]}else if(i>o)for(s=d-o;s>l;s--)a=s+i-1,(r=s+o-1)in h?h[a]=h[r]:delete h[a];for(s=0;s<i;s++)h[s+l]=arguments[s+2];return h.length=d-o+i,n}});var xi=Q("Array").splice,Ei=Array.prototype,Oi=function(e){var t=e.splice;return e===Ei||e instanceof Array&&t===Ei.splice?xi:t},Ci=st.includes,Ti=Jt("indexOf",{ACCESSORS:!0,1:0});G({target:"Array",proto:!0,forced:!Ti},{includes:function(e){return Ci(this,e,arguments.length>1?arguments[1]:void 0)}});var Si=Q("Array").includes,Mi=Ye("match"),Di=function(e){if(function(e){var t;return _(e)&&(void 0!==(t=e[Mi])?!!t:"RegExp"==y(e))}(e))throw TypeError("The method doesn't accept regular expressions");return e},Ii=Ye("match");G({target:"String",proto:!0,forced:!function(e){var t=/./;try{"/./"[e](t)}catch(i){try{return t[Ii]=!1,"/./"[e](t)}catch(e){}}return!1}("includes")},{includes:function(e){return!!~String(w(this)).indexOf(Di(e),arguments.length>1?arguments[1]:void 0)}});var Pi=Q("String").includes,Fi=Array.prototype,Bi=String.prototype,zi=function(e){var t=e.includes;return e===Fi||e instanceof Array&&t===Fi.includes?Si:"string"==typeof e||e===Bi||e instanceof String&&t===Bi.includes?Pi:t},Ni=st.indexOf,Ai=[].indexOf,Ri=!!Ai&&1/[1].indexOf(1,-0)<0,Li=Kt("indexOf"),ji=Jt("indexOf",{ACCESSORS:!0,1:0});G({target:"Array",proto:!0,forced:Ri||!Li||!ji},{indexOf:function(e){return Ri?Ai.apply(this,arguments)||0:Ni(this,e,arguments.length>1?arguments[1]:void 0)}});var Hi=Q("Array").indexOf,Wi=Array.prototype,Vi=function(e){var t=e.indexOf;return e===Wi||e instanceof Array&&t===Wi.indexOf?Hi:t};G({target:"Object",stat:!0,sham:!c},{create:mt});var qi=L.Object,Ui=function(e,t){return qi.create(e,t)},Yi=Ui;function Xi(e){return Ji=e,function(){var e={};Qi=0,void(eo=Ji.charAt(0)),po(),"strict"===to&&(e.strict=!0,po());"graph"!==to&&"digraph"!==to||(e.type=to,po());io===Zi.IDENTIFIER&&(e.id=to,po());if("{"!=to)throw bo("Angle bracket { expected");if(po(),fo(e),"}"!=to)throw bo("Angle bracket } expected");if(po(),""!==to)throw bo("End of file expected");return po(),delete e.node,delete e.edge,delete e.graph,e}()}var Gi={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},Ki=Yi(Gi);Ki.color="color.color",Ki.style="dashes";var Zi={NULL:0,DELIMITER:1,IDENTIFIER:2,UNKNOWN:3},$i={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},Ji="",Qi=0,eo="",to="",io=Zi.NULL;function oo(){Qi++,eo=Ji.charAt(Qi)}function no(){return Ji.charAt(Qi+1)}var so=/[a-zA-Z_0-9.:#]/;function ro(e){return so.test(e)}function ao(e,t){if(e||(e={}),t)for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);return e}function ho(e,t,i){for(var o=t.split("."),n=e;o.length;){var s=o.shift();o.length?(n[s]||(n[s]={}),n=n[s]):n[s]=i}}function lo(e,t){for(var i,o,n=null,s=[e],r=e;r.parent;)s.push(r.parent),r=r.parent;if(r.nodes)for(i=0,o=r.nodes.length;i<o;i++)if(t.id===r.nodes[i].id){n=r.nodes[i];break}for(n||(n={id:t.id},e.node&&(n.attr=ao(n.attr,e.node))),i=s.length-1;i>=0;i--){var a,h=s[i];h.nodes||(h.nodes=[]),-1===Vi(a=h.nodes).call(a,n)&&h.nodes.push(n)}t.attr&&(n.attr=ao(n.attr,t.attr))}function co(e,t){if(e.edges||(e.edges=[]),e.edges.push(t),e.edge){var i=ao({},e.edge);t.attr=ao(i,t.attr)}}function uo(e,t,i,o,n){var s={from:t,to:i,type:o};return e.edge&&(s.attr=ao({},e.edge)),s.attr=ao(s.attr||{},n),null!=n&&n.hasOwnProperty("arrows")&&null!=n.arrows&&(s.arrows={to:{enabled:!0,type:n.arrows.type}},n.arrows=null),s}function po(){for(io=Zi.NULL,to="";" "===eo||"\t"===eo||"\n"===eo||"\r"===eo;)oo();do{var e=!1;if("#"===eo){for(var t=Qi-1;" "===Ji.charAt(t)||"\t"===Ji.charAt(t);)t--;if("\n"===Ji.charAt(t)||""===Ji.charAt(t)){for(;""!=eo&&"\n"!=eo;)oo();e=!0}}if("/"===eo&&"/"===no()){for(;""!=eo&&"\n"!=eo;)oo();e=!0}if("/"===eo&&"*"===no()){for(;""!=eo;){if("*"===eo&&"/"===no()){oo(),oo();break}oo()}e=!0}for(;" "===eo||"\t"===eo||"\n"===eo||"\r"===eo;)oo()}while(e);if(""!==eo){var i=eo+no();if($i[i])return io=Zi.DELIMITER,to=i,oo(),void oo();if($i[eo])return io=Zi.DELIMITER,to=eo,void oo();if(ro(eo)||"-"===eo){for(to+=eo,oo();ro(eo);)to+=eo,oo();return"false"===to?to=!1:"true"===to?to=!0:isNaN(Number(to))||(to=Number(to)),void(io=Zi.IDENTIFIER)}if('"'===eo){for(oo();""!=eo&&('"'!=eo||'"'===eo&&'"'===no());)'"'===eo?(to+=eo,oo()):"\\"===eo&&"n"===no()?(to+="\n",oo()):to+=eo,oo();if('"'!=eo)throw bo('End of string " expected');return oo(),void(io=Zi.IDENTIFIER)}for(io=Zi.UNKNOWN;""!=eo;)to+=eo,oo();throw new SyntaxError('Syntax error in part "'+wo(to,30)+'"')}io=Zi.DELIMITER}function fo(e){for(;""!==to&&"}"!=to;)vo(e),";"===to&&po()}function vo(e){var t=go(e);if(t)yo(e,t);else if(!function(e){if("node"===to)return po(),e.node=mo(),"node";if("edge"===to)return po(),e.edge=mo(),"edge";if("graph"===to)return po(),e.graph=mo(),"graph";return null}(e)){if(io!=Zi.IDENTIFIER)throw bo("Identifier expected");var i=to;if(po(),"="===to){if(po(),io!=Zi.IDENTIFIER)throw bo("Identifier expected");e[i]=to,po()}else!function(e,t){var i={id:t},o=mo();o&&(i.attr=o);lo(e,i),yo(e,t)}(e,i)}}function go(e){var t=null;if("subgraph"===to&&((t={}).type="subgraph",po(),io===Zi.IDENTIFIER&&(t.id=to,po())),"{"===to){if(po(),t||(t={}),t.parent=e,t.node=e.node,t.edge=e.edge,t.graph=e.graph,fo(t),"}"!=to)throw bo("Angle bracket } expected");po(),delete t.node,delete t.edge,delete t.graph,delete t.parent,e.subgraphs||(e.subgraphs=[]),e.subgraphs.push(t)}return t}function yo(e,t){for(;"->"===to||"--"===to;){var i,o=to;po();var n=go(e);if(n)i=n;else{if(io!=Zi.IDENTIFIER)throw bo("Identifier or subgraph expected");lo(e,{id:i=to}),po()}co(e,uo(e,t,i,o,mo())),t=i}}function mo(){for(var e,t,i=null,o={dashed:!0,solid:!1,dotted:[1,5]},n={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},s=new Array,r=new Array;"["===to;){for(po(),i={};""!==to&&"]"!=to;){if(io!=Zi.IDENTIFIER)throw bo("Attribute name expected");var a=to;if(po(),"="!=to)throw bo("Equal sign = expected");if(po(),io!=Zi.IDENTIFIER)throw bo("Attribute value expected");var h=to;"style"===a&&(h=o[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:n[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:n[h]}}),s.push({attr:i,name:a,value:h}),r.push(a),po(),","==to&&po()}if("]"!=to)throw bo("Bracket ] expected");po()}if(zi(r).call(r,"dir")){var d={arrows:{}};for(e=0;e<s.length;e++)if("arrows"===s[e].name)if(null!=s[e].value.to)d.arrows.to=e;else{if(null==s[e].value.from)throw bo("Invalid value of arrows");d.arrows.from=e}else"dir"===s[e].name&&(d.dir=e);var l,c,u=s[d.dir].value;if(!zi(r).call(r,"arrows"))if("both"===u)s.push({attr:s[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=s.length-1,s.push({attr:s[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=s.length-1;else if("forward"===u)s.push({attr:s[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=s.length-1;else if("back"===u)s.push({attr:s[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=s.length-1;else{if("none"!==u)throw bo('Invalid dir type "'+u+'"');s.push({attr:s[d.dir].attr,name:"arrows",value:""}),d.arrows.to=s.length-1}if("both"===u)d.arrows.to&&d.arrows.from?(c=s[d.arrows.to].value.to.type,l=s[d.arrows.from].value.from.type,s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}},Oi(s).call(s,d.arrows.from,1)):d.arrows.to?(c=s[d.arrows.to].value.to.type,l="arrow",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="arrow",l=s[d.arrows.from].value.from.type,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}});else if("back"===u)d.arrows.to&&d.arrows.from?(c="",l=s[d.arrows.from].value.from.type,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.to?(c="",l="arrow",d.arrows.from=d.arrows.to,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="",l=s[d.arrows.from].value.from.type,s[d.arrows.to]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}),s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{from:{enabled:!0,type:s[d.arrows.from].value.from.type}}};else if("none"===u){var p;s[p=d.arrows.to?d.arrows.to:d.arrows.from]={attr:s[p].attr,name:s[p].name,value:""}}else{if("forward"!==u)throw bo('Invalid dir type "'+u+'"');d.arrows.to&&d.arrows.from?(c=s[d.arrows.to].value.to.type,l="",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.to?(c=s[d.arrows.to].value.to.type,l="",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="arrow",l="",d.arrows.to=d.arrows.from,s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}),s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:s[d.arrows.to].value.to.type}}}}Oi(s).call(s,d.dir,1)}if(zi(r).call(r,"penwidth")){var f=[];for(t=s.length,e=0;e<t;e++)"width"!==s[e].name&&("penwidth"===s[e].name&&(s[e].name="width"),f.push(s[e]));s=f}for(t=s.length,e=0;e<t;e++)ho(s[e].attr,s[e].name,s[e].value);return i}function bo(e){return new SyntaxError(e+', got "'+wo(to,30)+'" (char '+Qi+")")}function wo(e,t){return e.length<=t?e:e.substr(0,27)+"..."}function ko(e,t,i){for(var o=t.split("."),n=o.pop(),s=e,r=0;r<o.length;r++){var a=o[r];a in s||(s[a]={}),s=s[a]}return s[n]=i,e}function _o(e,t){var i={};for(var o in e)if(e.hasOwnProperty(o)){var n=t[o];li(n)?ri(n).call(n,(function(t){ko(i,t,e[o])})):ko(i,"string"==typeof n?n:o,e[o])}return i}var xo=Xi,Eo=function(e){var t,i=Xi(e),o={nodes:[],edges:[],options:{}};if(i.nodes&&ri(t=i.nodes).call(t,(function(e){var t={id:e.id,label:String(e.label||e.id)};ao(t,_o(e.attr,Gi)),t.image&&(t.shape="image"),o.nodes.push(t)})),i.edges){var n,s=function(e){var t={from:e.from,to:e.to};return ao(t,_o(e.attr,Ki)),null==t.arrows&&"->"===e.type&&(t.arrows="to"),t};ri(n=i.edges).call(n,(function(e){var t,i,n,r,a,h,d;(t=e.from instanceof Object?e.from.nodes:{id:e.from},i=e.to instanceof Object?e.to.nodes:{id:e.to},e.from instanceof Object&&e.from.edges)&&ri(n=e.from.edges).call(n,(function(e){var t=s(e);o.edges.push(t)}));(a=i,h=function(t,i){var n=uo(o,t.id,i.id,e.type,e.attr),r=s(n);o.edges.push(r)},li(r=t)?ri(r).call(r,(function(e){li(a)?ri(a).call(a,(function(t){h(e,t)})):h(e,a)})):li(a)?ri(a).call(a,(function(e){h(r,e)})):h(r,a),e.to instanceof Object&&e.to.edges)&&ri(d=e.to.edges).call(d,(function(e){var t=s(e);o.edges.push(t)}))}))}return i.attr&&(o.options=i.attr),o},Oo={parseDOT:xo,DOTToGraph:Eo},Co=Object.freeze({__proto__:null,default:Oo,__moduleExports:Oo,parseDOT:xo,DOTToGraph:Eo}),To=Gt.map,So=mi("map"),Mo=Jt("map");G({target:"Array",proto:!0,forced:!So||!Mo},{map:function(e){return To(this,e,arguments.length>1?arguments[1]:void 0)}});var Do=Q("Array").map,Io=Array.prototype,Po=function(e){var t=e.map;return e===Io||e instanceof Array&&t===Io.map?Do:t};function Fo(e,t){var i,o={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=t&&(null!=t.fixed&&(o.nodes.fixed=t.fixed),null!=t.parseColor&&(o.nodes.parseColor=t.parseColor),null!=t.inheritColor&&(o.edges.inheritColor=t.inheritColor));var n=e.edges,s=Po(n).call(n,(function(e){var t={from:e.source,id:e.id,to:e.target};return null!=e.attributes&&(t.attributes=e.attributes),null!=e.label&&(t.label=e.label),null!=e.attributes&&null!=e.attributes.title&&(t.title=e.attributes.title),"Directed"===e.type&&(t.arrows="to"),e.color&&!1===o.edges.inheritColor&&(t.color=e.color),t}));return{nodes:Po(i=e.nodes).call(i,(function(e){var t={id:e.id,fixed:o.nodes.fixed&&null!=e.x&&null!=e.y};return null!=e.attributes&&(t.attributes=e.attributes),null!=e.label&&(t.label=e.label),null!=e.size&&(t.size=e.size),null!=e.attributes&&null!=e.attributes.title&&(t.title=e.attributes.title),null!=e.title&&(t.title=e.title),null!=e.x&&(t.x=e.x),null!=e.y&&(t.y=e.y),null!=e.color&&(!0===o.nodes.parseColor?t.color=e.color:t.color={background:e.color,border:e.color,highlight:{background:e.color,border:e.color},hover:{background:e.color,border:e.color}}),t})),edges:s}}var Bo=Object.freeze({__proto__:null,parseGephi:Fo}),zo=Object.freeze({__proto__:null,default:void 0});function No(){return(No=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var i=arguments[t];for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&(e[o]=i[o])}return e}).apply(this,arguments)}function Ao(e,t){e.prototype=Object.create(t.prototype),e.prototype.constructor=e,e.__proto__=t}function Ro(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}var Lo,jo="function"!=typeof Object.assign?function(e){if(null==e)throw new TypeError("Cannot convert undefined or null to object");for(var t=Object(e),i=1;i<arguments.length;i++){var o=arguments[i];if(null!=o)for(var n in o)o.hasOwnProperty(n)&&(t[n]=o[n])}return t}:Object.assign,Ho=["","webkit","Moz","MS","ms","o"],Wo="undefined"==typeof document?{style:{}}:document.createElement("div"),Vo="function",qo=Math.round,Uo=Math.abs,Yo=Date.now;function Xo(e,t){for(var i,o,n=t[0].toUpperCase()+t.slice(1),s=0;s<Ho.length;){if((o=(i=Ho[s])?i+n:t)in e)return o;s++}}Lo="undefined"==typeof window?{}:window;var Go=Xo(Wo.style,"touchAction"),Ko=void 0!==Go;var Zo="auto",$o="manipulation",Jo="none",Qo="pan-x",en="pan-y",tn=function(){if(!Ko)return!1;var e={},t=Lo.CSS&&Lo.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return e[i]=!t||Lo.CSS.supports("touch-action",i)})),e}(),on="ontouchstart"in Lo,nn=void 0!==Xo(Lo,"PointerEvent"),sn=on&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),rn="touch",an="mouse",hn=25,dn=1,ln=2,cn=4,un=8,pn=1,fn=2,vn=4,gn=8,yn=16,mn=fn|vn,bn=gn|yn,wn=mn|bn,kn=["x","y"],_n=["clientX","clientY"];function xn(e,t,i){var o;if(e)if(e.forEach)e.forEach(t,i);else if(void 0!==e.length)for(o=0;o<e.length;)t.call(i,e[o],o,e),o++;else for(o in e)e.hasOwnProperty(o)&&t.call(i,e[o],o,e)}function En(e,t){return typeof e===Vo?e.apply(t&&t[0]||void 0,t):e}function On(e,t){return e.indexOf(t)>-1}var Cn=function(){function e(e,t){this.manager=e,this.set(t)}var t=e.prototype;return t.set=function(e){"compute"===e&&(e=this.compute()),Ko&&this.manager.element.style&&tn[e]&&(this.manager.element.style[Go]=e),this.actions=e.toLowerCase().trim()},t.update=function(){this.set(this.manager.options.touchAction)},t.compute=function(){var e=[];return xn(this.manager.recognizers,(function(t){En(t.options.enable,[t])&&(e=e.concat(t.getTouchAction()))})),function(e){if(On(e,Jo))return Jo;var t=On(e,Qo),i=On(e,en);return t&&i?Jo:t||i?t?Qo:en:On(e,$o)?$o:Zo}(e.join(" "))},t.preventDefaults=function(e){var t=e.srcEvent,i=e.offsetDirection;if(this.manager.session.prevented)t.preventDefault();else{var o=this.actions,n=On(o,Jo)&&!tn[Jo],s=On(o,en)&&!tn[en],r=On(o,Qo)&&!tn[Qo];if(n){var a=1===e.pointers.length,h=e.distance<2,d=e.deltaTime<250;if(a&&h&&d)return}if(!r||!s)return n||s&&i&mn||r&&i&bn?this.preventSrc(t):void 0}},t.preventSrc=function(e){this.manager.session.prevented=!0,e.preventDefault()},e}();function Tn(e,t){for(;e;){if(e===t)return!0;e=e.parentNode}return!1}function Sn(e){var t=e.length;if(1===t)return{x:qo(e[0].clientX),y:qo(e[0].clientY)};for(var i=0,o=0,n=0;n<t;)i+=e[n].clientX,o+=e[n].clientY,n++;return{x:qo(i/t),y:qo(o/t)}}function Mn(e){for(var t=[],i=0;i<e.pointers.length;)t[i]={clientX:qo(e.pointers[i].clientX),clientY:qo(e.pointers[i].clientY)},i++;return{timeStamp:Yo(),pointers:t,center:Sn(t),deltaX:e.deltaX,deltaY:e.deltaY}}function Dn(e,t,i){i||(i=kn);var o=t[i[0]]-e[i[0]],n=t[i[1]]-e[i[1]];return Math.sqrt(o*o+n*n)}function In(e,t,i){i||(i=kn);var o=t[i[0]]-e[i[0]],n=t[i[1]]-e[i[1]];return 180*Math.atan2(n,o)/Math.PI}function Pn(e,t){return e===t?pn:Uo(e)>=Uo(t)?e<0?fn:vn:t<0?gn:yn}function Fn(e,t,i){return{x:t/e||0,y:i/e||0}}function Bn(e,t){var i=e.session,o=t.pointers,n=o.length;i.firstInput||(i.firstInput=Mn(t)),n>1&&!i.firstMultiple?i.firstMultiple=Mn(t):1===n&&(i.firstMultiple=!1);var s=i.firstInput,r=i.firstMultiple,a=r?r.center:s.center,h=t.center=Sn(o);t.timeStamp=Yo(),t.deltaTime=t.timeStamp-s.timeStamp,t.angle=In(a,h),t.distance=Dn(a,h),function(e,t){var i=t.center,o=e.offsetDelta||{},n=e.prevDelta||{},s=e.prevInput||{};t.eventType!==dn&&s.eventType!==cn||(n=e.prevDelta={x:s.deltaX||0,y:s.deltaY||0},o=e.offsetDelta={x:i.x,y:i.y}),t.deltaX=n.x+(i.x-o.x),t.deltaY=n.y+(i.y-o.y)}(i,t),t.offsetDirection=Pn(t.deltaX,t.deltaY);var d,l,c=Fn(t.deltaTime,t.deltaX,t.deltaY);t.overallVelocityX=c.x,t.overallVelocityY=c.y,t.overallVelocity=Uo(c.x)>Uo(c.y)?c.x:c.y,t.scale=r?(d=r.pointers,Dn((l=o)[0],l[1],_n)/Dn(d[0],d[1],_n)):1,t.rotation=r?function(e,t){return In(t[1],t[0],_n)+In(e[1],e[0],_n)}(r.pointers,o):0,t.maxPointers=i.prevInput?t.pointers.length>i.prevInput.maxPointers?t.pointers.length:i.prevInput.maxPointers:t.pointers.length,function(e,t){var i,o,n,s,r=e.lastInterval||t,a=t.timeStamp-r.timeStamp;if(t.eventType!==un&&(a>hn||void 0===r.velocity)){var h=t.deltaX-r.deltaX,d=t.deltaY-r.deltaY,l=Fn(a,h,d);o=l.x,n=l.y,i=Uo(l.x)>Uo(l.y)?l.x:l.y,s=Pn(h,d),e.lastInterval=t}else i=r.velocity,o=r.velocityX,n=r.velocityY,s=r.direction;t.velocity=i,t.velocityX=o,t.velocityY=n,t.direction=s}(i,t);var u,p=e.element,f=t.srcEvent;Tn(u=f.composedPath?f.composedPath()[0]:f.path?f.path[0]:f.target,p)&&(p=u),t.target=p}function zn(e,t,i){var o=i.pointers.length,n=i.changedPointers.length,s=t&dn&&o-n==0,r=t&(cn|un)&&o-n==0;i.isFirst=!!s,i.isFinal=!!r,s&&(e.session={}),i.eventType=t,Bn(e,i),e.emit("hammer.input",i),e.recognize(i),e.session.prevInput=i}function Nn(e){return e.trim().split(/\s+/g)}function An(e,t,i){xn(Nn(t),(function(t){e.addEventListener(t,i,!1)}))}function Rn(e,t,i){xn(Nn(t),(function(t){e.removeEventListener(t,i,!1)}))}function Ln(e){var t=e.ownerDocument||e;return t.defaultView||t.parentWindow||window}var jn=function(){function e(e,t){var i=this;this.manager=e,this.callback=t,this.element=e.element,this.target=e.options.inputTarget,this.domHandler=function(t){En(e.options.enable,[e])&&i.handler(t)},this.init()}var t=e.prototype;return t.handler=function(){},t.init=function(){this.evEl&&An(this.element,this.evEl,this.domHandler),this.evTarget&&An(this.target,this.evTarget,this.domHandler),this.evWin&&An(Ln(this.element),this.evWin,this.domHandler)},t.destroy=function(){this.evEl&&Rn(this.element,this.evEl,this.domHandler),this.evTarget&&Rn(this.target,this.evTarget,this.domHandler),this.evWin&&Rn(Ln(this.element),this.evWin,this.domHandler)},e}();function Hn(e,t,i){if(e.indexOf&&!i)return e.indexOf(t);for(var o=0;o<e.length;){if(i&&e[o][i]==t||!i&&e[o]===t)return o;o++}return-1}var Wn={pointerdown:dn,pointermove:ln,pointerup:cn,pointercancel:un,pointerout:un},Vn={2:rn,3:"pen",4:an,5:"kinect"},qn="pointerdown",Un="pointermove pointerup pointercancel";Lo.MSPointerEvent&&!Lo.PointerEvent&&(qn="MSPointerDown",Un="MSPointerMove MSPointerUp MSPointerCancel");var Yn=function(e){function t(){var i,o=t.prototype;return o.evEl=qn,o.evWin=Un,(i=e.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return Ao(t,e),t.prototype.handler=function(e){var t=this.store,i=!1,o=e.type.toLowerCase().replace("ms",""),n=Wn[o],s=Vn[e.pointerType]||e.pointerType,r=s===rn,a=Hn(t,e.pointerId,"pointerId");n&dn&&(0===e.button||r)?a<0&&(t.push(e),a=t.length-1):n&(cn|un)&&(i=!0),a<0||(t[a]=e,this.callback(this.manager,n,{pointers:t,changedPointers:[e],pointerType:s,srcEvent:e}),i&&t.splice(a,1))},t}(jn);function Xn(e){return Array.prototype.slice.call(e,0)}function Gn(e,t,i){for(var o=[],n=[],s=0;s<e.length;){var r=t?e[s][t]:e[s];Hn(n,r)<0&&o.push(e[s]),n[s]=r,s++}return i&&(o=t?o.sort((function(e,i){return e[t]>i[t]})):o.sort()),o}var Kn={touchstart:dn,touchmove:ln,touchend:cn,touchcancel:un},Zn="touchstart touchmove touchend touchcancel",$n=function(e){function t(){var i;return t.prototype.evTarget=Zn,(i=e.apply(this,arguments)||this).targetIds={},i}return Ao(t,e),t.prototype.handler=function(e){var t=Kn[e.type],i=Jn.call(this,e,t);i&&this.callback(this.manager,t,{pointers:i[0],changedPointers:i[1],pointerType:rn,srcEvent:e})},t}(jn);function Jn(e,t){var i,o,n=Xn(e.touches),s=this.targetIds;if(t&(dn|ln)&&1===n.length)return s[n[0].identifier]=!0,[n,n];var r=Xn(e.changedTouches),a=[],h=this.target;if(o=n.filter((function(e){return Tn(e.target,h)})),t===dn)for(i=0;i<o.length;)s[o[i].identifier]=!0,i++;for(i=0;i<r.length;)s[r[i].identifier]&&a.push(r[i]),t&(cn|un)&&delete s[r[i].identifier],i++;return a.length?[Gn(o.concat(a),"identifier",!0),a]:void 0}var Qn={mousedown:dn,mousemove:ln,mouseup:cn},es="mousedown",ts="mousemove mouseup",is=function(e){function t(){var i,o=t.prototype;return o.evEl=es,o.evWin=ts,(i=e.apply(this,arguments)||this).pressed=!1,i}return Ao(t,e),t.prototype.handler=function(e){var t=Qn[e.type];t&dn&&0===e.button&&(this.pressed=!0),t&ln&&1!==e.which&&(t=cn),this.pressed&&(t&cn&&(this.pressed=!1),this.callback(this.manager,t,{pointers:[e],changedPointers:[e],pointerType:an,srcEvent:e}))},t}(jn),os=2500,ns=25;function ss(e){var t=e.changedPointers[0];if(t.identifier===this.primaryTouch){var i={x:t.clientX,y:t.clientY},o=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var e=o.indexOf(i);e>-1&&o.splice(e,1)}),os)}}function rs(e,t){e&dn?(this.primaryTouch=t.changedPointers[0].identifier,ss.call(this,t)):e&(cn|un)&&ss.call(this,t)}function as(e){for(var t=e.srcEvent.clientX,i=e.srcEvent.clientY,o=0;o<this.lastTouches.length;o++){var n=this.lastTouches[o],s=Math.abs(t-n.x),r=Math.abs(i-n.y);if(s<=ns&&r<=ns)return!0}return!1}var hs=function(){return function(e){function t(t,i){var o;return(o=e.call(this,t,i)||this).handler=function(e,t,i){var n=i.pointerType===rn,s=i.pointerType===an;if(!(s&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(n)rs.call(Ro(Ro(o)),t,i);else if(s&&as.call(Ro(Ro(o)),i))return;o.callback(e,t,i)}},o.touch=new $n(o.manager,o.handler),o.mouse=new is(o.manager,o.handler),o.primaryTouch=null,o.lastTouches=[],o}return Ao(t,e),t.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},t}(jn)}();function ds(e,t,i){return!!Array.isArray(e)&&(xn(e,i[t],i),!0)}var ls=1,cs=2,us=4,ps=8,fs=ps,vs=16,gs=1;function ys(e,t){var i=t.manager;return i?i.get(e):e}function ms(e){return e&vs?"cancel":e&ps?"end":e&us?"move":e&cs?"start":""}var bs=function(){function e(e){void 0===e&&(e={}),this.options=No({enable:!0},e),this.id=gs++,this.manager=null,this.state=ls,this.simultaneous={},this.requireFail=[]}var t=e.prototype;return t.set=function(e){return jo(this.options,e),this.manager&&this.manager.touchAction.update(),this},t.recognizeWith=function(e){if(ds(e,"recognizeWith",this))return this;var t=this.simultaneous;return t[(e=ys(e,this)).id]||(t[e.id]=e,e.recognizeWith(this)),this},t.dropRecognizeWith=function(e){return ds(e,"dropRecognizeWith",this)?this:(e=ys(e,this),delete this.simultaneous[e.id],this)},t.requireFailure=function(e){if(ds(e,"requireFailure",this))return this;var t=this.requireFail;return-1===Hn(t,e=ys(e,this))&&(t.push(e),e.requireFailure(this)),this},t.dropRequireFailure=function(e){if(ds(e,"dropRequireFailure",this))return this;e=ys(e,this);var t=Hn(this.requireFail,e);return t>-1&&this.requireFail.splice(t,1),this},t.hasRequireFailures=function(){return this.requireFail.length>0},t.canRecognizeWith=function(e){return!!this.simultaneous[e.id]},t.emit=function(e){var t=this,i=this.state;function o(i){t.manager.emit(i,e)}i<ps&&o(t.options.event+ms(i)),o(t.options.event),e.additionalEvent&&o(e.additionalEvent),i>=ps&&o(t.options.event+ms(i))},t.tryEmit=function(e){if(this.canEmit())return this.emit(e);this.state=32},t.canEmit=function(){for(var e=0;e<this.requireFail.length;){if(!(this.requireFail[e].state&(32|ls)))return!1;e++}return!0},t.recognize=function(e){var t=jo({},e);if(!En(this.options.enable,[this,t]))return this.reset(),void(this.state=32);this.state&(fs|vs|32)&&(this.state=ls),this.state=this.process(t),this.state&(cs|us|ps|vs)&&this.tryEmit(t)},t.process=function(e){},t.getTouchAction=function(){},t.reset=function(){},e}(),ws=function(e){function t(t){var i;return void 0===t&&(t={}),(i=e.call(this,No({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},t))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}Ao(t,e);var i=t.prototype;return i.getTouchAction=function(){return[$o]},i.process=function(e){var t=this,i=this.options,o=e.pointers.length===i.pointers,n=e.distance<i.threshold,s=e.deltaTime<i.time;if(this.reset(),e.eventType&dn&&0===this.count)return this.failTimeout();if(n&&s&&o){if(e.eventType!==cn)return this.failTimeout();var r=!this.pTime||e.timeStamp-this.pTime<i.interval,a=!this.pCenter||Dn(this.pCenter,e.center)<i.posThreshold;if(this.pTime=e.timeStamp,this.pCenter=e.center,a&&r?this.count+=1:this.count=1,this._input=e,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){t.state=fs,t.tryEmit()}),i.interval),cs):fs}return 32},i.failTimeout=function(){var e=this;return this._timer=setTimeout((function(){e.state=32}),this.options.interval),32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===fs&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},t}(bs),ks=function(e){function t(t){return void 0===t&&(t={}),e.call(this,No({pointers:1},t))||this}Ao(t,e);var i=t.prototype;return i.attrTest=function(e){var t=this.options.pointers;return 0===t||e.pointers.length===t},i.process=function(e){var t=this.state,i=e.eventType,o=t&(cs|us),n=this.attrTest(e);return o&&(i&un||!n)?t|vs:o||n?i&cn?t|ps:t&cs?t|us:cs:32},t}(bs);function _s(e){return e===yn?"down":e===gn?"up":e===fn?"left":e===vn?"right":""}var xs=function(e){function t(t){var i;return void 0===t&&(t={}),(i=e.call(this,No({event:"pan",threshold:10,pointers:1,direction:wn},t))||this).pX=null,i.pY=null,i}Ao(t,e);var i=t.prototype;return i.getTouchAction=function(){var e=this.options.direction,t=[];return e&mn&&t.push(en),e&bn&&t.push(Qo),t},i.directionTest=function(e){var t=this.options,i=!0,o=e.distance,n=e.direction,s=e.deltaX,r=e.deltaY;return n&t.direction||(t.direction&mn?(n=0===s?pn:s<0?fn:vn,i=s!==this.pX,o=Math.abs(e.deltaX)):(n=0===r?pn:r<0?gn:yn,i=r!==this.pY,o=Math.abs(e.deltaY))),e.direction=n,i&&o>t.threshold&&n&t.direction},i.attrTest=function(e){return ks.prototype.attrTest.call(this,e)&&(this.state&cs||!(this.state&cs)&&this.directionTest(e))},i.emit=function(t){this.pX=t.deltaX,this.pY=t.deltaY;var i=_s(t.direction);i&&(t.additionalEvent=this.options.event+i),e.prototype.emit.call(this,t)},t}(ks),Es=function(e){function t(t){return void 0===t&&(t={}),e.call(this,No({event:"swipe",threshold:10,velocity:.3,direction:mn|bn,pointers:1},t))||this}Ao(t,e);var i=t.prototype;return i.getTouchAction=function(){return xs.prototype.getTouchAction.call(this)},i.attrTest=function(t){var i,o=this.options.direction;return o&(mn|bn)?i=t.overallVelocity:o&mn?i=t.overallVelocityX:o&bn&&(i=t.overallVelocityY),e.prototype.attrTest.call(this,t)&&o&t.offsetDirection&&t.distance>this.options.threshold&&t.maxPointers===this.options.pointers&&Uo(i)>this.options.velocity&&t.eventType&cn},i.emit=function(e){var t=_s(e.offsetDirection);t&&this.manager.emit(this.options.event+t,e),this.manager.emit(this.options.event,e)},t}(ks),Os=function(e){function t(t){return void 0===t&&(t={}),e.call(this,No({event:"pinch",threshold:0,pointers:2},t))||this}Ao(t,e);var i=t.prototype;return i.getTouchAction=function(){return[Jo]},i.attrTest=function(t){return e.prototype.attrTest.call(this,t)&&(Math.abs(t.scale-1)>this.options.threshold||this.state&cs)},i.emit=function(t){if(1!==t.scale){var i=t.scale<1?"in":"out";t.additionalEvent=this.options.event+i}e.prototype.emit.call(this,t)},t}(ks),Cs=function(e){function t(t){return void 0===t&&(t={}),e.call(this,No({event:"rotate",threshold:0,pointers:2},t))||this}Ao(t,e);var i=t.prototype;return i.getTouchAction=function(){return[Jo]},i.attrTest=function(t){return e.prototype.attrTest.call(this,t)&&(Math.abs(t.rotation)>this.options.threshold||this.state&cs)},t}(ks),Ts=function(e){function t(t){var i;return void 0===t&&(t={}),(i=e.call(this,No({event:"press",pointers:1,time:251,threshold:9},t))||this)._timer=null,i._input=null,i}Ao(t,e);var i=t.prototype;return i.getTouchAction=function(){return[Zo]},i.process=function(e){var t=this,i=this.options,o=e.pointers.length===i.pointers,n=e.distance<i.threshold,s=e.deltaTime>i.time;if(this._input=e,!n||!o||e.eventType&(cn|un)&&!s)this.reset();else if(e.eventType&dn)this.reset(),this._timer=setTimeout((function(){t.state=fs,t.tryEmit()}),i.time);else if(e.eventType&cn)return fs;return 32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(e){this.state===fs&&(e&&e.eventType&cn?this.manager.emit(this.options.event+"up",e):(this._input.timeStamp=Yo(),this.manager.emit(this.options.event,this._input)))},t}(bs),Ss={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Ms=[[Cs,{enable:!1}],[Os,{enable:!1},["rotate"]],[Es,{direction:mn}],[xs,{direction:mn},["swipe"]],[ws],[ws,{event:"doubletap",taps:2},["tap"]],[Ts]];function Ds(e,t){var i,o=e.element;o.style&&(xn(e.options.cssProps,(function(n,s){i=Xo(o.style,s),t?(e.oldCssProps[i]=o.style[i],o.style[i]=n):o.style[i]=e.oldCssProps[i]||""})),t||(e.oldCssProps={}))}var Is=function(){function e(e,t){var i,o=this;this.options=jo({},Ss,t||{}),this.options.inputTarget=this.options.inputTarget||e,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=e,this.input=new((i=this).options.inputClass||(nn?Yn:sn?$n:on?hs:is))(i,zn),this.touchAction=new Cn(this,this.options.touchAction),Ds(this,!0),xn(this.options.recognizers,(function(e){var t=o.add(new e[0](e[1]));e[2]&&t.recognizeWith(e[2]),e[3]&&t.requireFailure(e[3])}),this)}var t=e.prototype;return t.set=function(e){return jo(this.options,e),e.touchAction&&this.touchAction.update(),e.inputTarget&&(this.input.destroy(),this.input.target=e.inputTarget,this.input.init()),this},t.stop=function(e){this.session.stopped=e?2:1},t.recognize=function(e){var t=this.session;if(!t.stopped){var i;this.touchAction.preventDefaults(e);var o=this.recognizers,n=t.curRecognizer;(!n||n&&n.state&fs)&&(t.curRecognizer=null,n=null);for(var s=0;s<o.length;)i=o[s],2===t.stopped||n&&i!==n&&!i.canRecognizeWith(n)?i.reset():i.recognize(e),!n&&i.state&(cs|us|ps)&&(t.curRecognizer=i,n=i),s++}},t.get=function(e){if(e instanceof bs)return e;for(var t=this.recognizers,i=0;i<t.length;i++)if(t[i].options.event===e)return t[i];return null},t.add=function(e){if(ds(e,"add",this))return this;var t=this.get(e.options.event);return t&&this.remove(t),this.recognizers.push(e),e.manager=this,this.touchAction.update(),e},t.remove=function(e){if(ds(e,"remove",this))return this;var t=this.get(e);if(e){var i=this.recognizers,o=Hn(i,t);-1!==o&&(i.splice(o,1),this.touchAction.update())}return this},t.on=function(e,t){if(void 0===e||void 0===t)return this;var i=this.handlers;return xn(Nn(e),(function(e){i[e]=i[e]||[],i[e].push(t)})),this},t.off=function(e,t){if(void 0===e)return this;var i=this.handlers;return xn(Nn(e),(function(e){t?i[e]&&i[e].splice(Hn(i[e],t),1):delete i[e]})),this},t.emit=function(e,t){this.options.domEvents&&function(e,t){var i=document.createEvent("Event");i.initEvent(e,!0,!0),i.gesture=t,t.target.dispatchEvent(i)}(e,t);var i=this.handlers[e]&&this.handlers[e].slice();if(i&&i.length){t.type=e,t.preventDefault=function(){t.srcEvent.preventDefault()};for(var o=0;o<i.length;)i[o](t),o++}},t.destroy=function(){this.element&&Ds(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},e}(),Ps={touchstart:dn,touchmove:ln,touchend:cn,touchcancel:un},Fs="touchstart",Bs="touchstart touchmove touchend touchcancel",zs=function(e){function t(){var i,o=t.prototype;return o.evTarget=Fs,o.evWin=Bs,(i=e.apply(this,arguments)||this).started=!1,i}return Ao(t,e),t.prototype.handler=function(e){var t=Ps[e.type];if(t===dn&&(this.started=!0),this.started){var i=Ns.call(this,e,t);t&(cn|un)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,t,{pointers:i[0],changedPointers:i[1],pointerType:rn,srcEvent:e})}},t}(jn);function Ns(e,t){var i=Xn(e.touches),o=Xn(e.changedTouches);return t&(cn|un)&&(i=Gn(i.concat(o),"identifier",!0)),[i,o]}function As(e,t,i){var o="DEPRECATED METHOD: "+t+"\n"+i+" AT \n";return function(){var t=new Error("get-stack-trace"),i=t&&t.stack?t.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",n=window.console&&(window.console.warn||window.console.log);return n&&n.call(window.console,o,i),e.apply(this,arguments)}}var Rs=As((function(e,t,i){for(var o=Object.keys(t),n=0;n<o.length;)(!i||i&&void 0===e[o[n]])&&(e[o[n]]=t[o[n]]),n++;return e}),"extend","Use `assign`."),Ls=As((function(e,t){return Rs(e,t,!0)}),"merge","Use `assign`.");function js(e,t,i){var o,n=t.prototype;(o=e.prototype=Object.create(n)).constructor=e,o._super=n,i&&jo(o,i)}function Hs(e,t){return function(){return e.apply(t,arguments)}}var Ws=function(){var e=function(e,t){return void 0===t&&(t={}),new Is(e,No({recognizers:Ms.concat()},t))};return e.VERSION="2.0.17-rc",e.DIRECTION_ALL=wn,e.DIRECTION_DOWN=yn,e.DIRECTION_LEFT=fn,e.DIRECTION_RIGHT=vn,e.DIRECTION_UP=gn,e.DIRECTION_HORIZONTAL=mn,e.DIRECTION_VERTICAL=bn,e.DIRECTION_NONE=pn,e.DIRECTION_DOWN=yn,e.INPUT_START=dn,e.INPUT_MOVE=ln,e.INPUT_END=cn,e.INPUT_CANCEL=un,e.STATE_POSSIBLE=ls,e.STATE_BEGAN=cs,e.STATE_CHANGED=us,e.STATE_ENDED=ps,e.STATE_RECOGNIZED=fs,e.STATE_CANCELLED=vs,e.STATE_FAILED=32,e.Manager=Is,e.Input=jn,e.TouchAction=Cn,e.TouchInput=$n,e.MouseInput=is,e.PointerEventInput=Yn,e.TouchMouseInput=hs,e.SingleTouchInput=zs,e.Recognizer=bs,e.AttrRecognizer=ks,e.Tap=ws,e.Pan=xs,e.Swipe=Es,e.Pinch=Os,e.Rotate=Cs,e.Press=Ts,e.on=An,e.off=Rn,e.each=xn,e.merge=Ls,e.extend=Rs,e.bindFn=Hs,e.assign=jo,e.inherit=js,e.bindFn=Hs,e.prefixed=Xo,e.toArray=Xn,e.inArray=Hn,e.uniqueArray=Gn,e.splitStr=Nn,e.boolOrFn=En,e.hasParent=Tn,e.addEventListeners=An,e.removeEventListeners=Rn,e.defaults=jo({},Ss,{preset:Ms}),e}(),Vs=Ws.defaults,qs=a(Object.freeze({__proto__:null,default:Ws,INPUT_START:dn,INPUT_MOVE:ln,INPUT_END:cn,INPUT_CANCEL:un,STATE_POSSIBLE:ls,STATE_BEGAN:cs,STATE_CHANGED:us,STATE_ENDED:ps,STATE_RECOGNIZED:fs,STATE_CANCELLED:vs,STATE_FAILED:32,DIRECTION_NONE:pn,DIRECTION_LEFT:fn,DIRECTION_RIGHT:vn,DIRECTION_UP:gn,DIRECTION_DOWN:yn,DIRECTION_HORIZONTAL:mn,DIRECTION_VERTICAL:bn,DIRECTION_ALL:wn,Manager:Is,Input:jn,TouchAction:Cn,TouchInput:$n,MouseInput:is,PointerEventInput:Yn,TouchMouseInput:hs,SingleTouchInput:zs,Recognizer:bs,AttrRecognizer:ks,Tap:ws,Pan:xs,Swipe:Es,Pinch:Os,Rotate:Cs,Press:Ts,on:An,off:Rn,each:xn,merge:Ls,extend:Rs,assign:jo,inherit:js,bindFn:Hs,prefixed:Xo,toArray:Xn,inArray:Hn,uniqueArray:Gn,splitStr:Nn,boolOrFn:En,hasParent:Tn,addEventListeners:An,removeEventListeners:Rn,defaults:Vs})),Us=r((function(e){if("undefined"!=typeof window){var t=window.Hammer||qs;e.exports=t}else e.exports=function(){return{on:e=function(){},off:e,destroy:e,emit:e,get:function(t){return{set:e}}};var e}}));function Ys(e){var t,o,n=this;this.active=!1,this.dom={container:e},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=Us(this.dom.overlay),this.hammer.on("tap",ie(t=this._onTapOverlay).call(t,this));var s=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];ri(s).call(s,(function(e){n.hammer.on(e,(function(e){e.srcEvent.stopPropagation()}))})),document&&document.body&&(this.onClick=function(t){(function(e,t){for(;e;){if(e===t)return!0;e=e.parentNode}return!1})(t.target,e)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=i(),this.escListener=ie(o=this.deactivate).call(o,this)}a(zo),de(Ys.prototype),Ys.current=null,Ys.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},Ys.prototype.activate=function(){var e;Ys.current&&Ys.current.deactivate(),Ys.current=this,this.active=!0,this.dom.overlay.style.display="none",n.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),ie(e=this.keycharm).call(e,"esc",this.escListener)},Ys.prototype.deactivate=function(){this.active=!1,this.dom.overlay.style.display="block",n.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},Ys.prototype._onTapOverlay=function(e){this.activate(),e.srcEvent.stopPropagation()};var Xs=Ys,Gs=r((function(e,t){t.en={edit:"Edit",del:"Delete selected",back:"Back",addNode:"Add Node",addEdge:"Add Edge",editNode:"Edit Node",editEdge:"Edit Edge",addDescription:"Click in an empty space to place a new node.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",createEdgeError:"Cannot link edges to a cluster.",deleteClusterError:"Clusters cannot be deleted.",editClusterError:"Clusters cannot be edited."},t.en_EN=t.en,t.en_US=t.en,t.de={edit:"Editieren",del:"Lösche Auswahl",back:"Zurück",addNode:"Knoten hinzufügen",addEdge:"Kante hinzufügen",editNode:"Knoten editieren",editEdge:"Kante editieren",addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",deleteClusterError:"Cluster können nicht gelöscht werden.",editClusterError:"Cluster können nicht editiert werden."},t.de_DE=t.de,t.es={edit:"Editar",del:"Eliminar selección",back:"Atrás",addNode:"Añadir nodo",addEdge:"Añadir arista",editNode:"Editar nodo",editEdge:"Editar arista",addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",createEdgeError:"No se puede conectar una arista a un grupo.",deleteClusterError:"No es posible eliminar grupos.",editClusterError:"No es posible editar grupos."},t.es_ES=t.es,t.it={edit:"Modifica",del:"Cancella la selezione",back:"Indietro",addNode:"Aggiungi un nodo",addEdge:"Aggiungi un vertice",editNode:"Modifica il nodo",editEdge:"Modifica il vertice",addDescription:"Clicca per aggiungere un nuovo nodo",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",createEdgeError:"Non si possono collegare vertici ad un cluster",deleteClusterError:"I cluster non possono essere cancellati",editClusterError:"I clusters non possono essere modificati."},t.it_IT=t.it,t.nl={edit:"Wijzigen",del:"Selectie verwijderen",back:"Terug",addNode:"Node toevoegen",addEdge:"Link toevoegen",editNode:"Node wijzigen",editEdge:"Link wijzigen",addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",createEdgeError:"Kan geen link maken naar een cluster.",deleteClusterError:"Clusters kunnen niet worden verwijderd.",editClusterError:"Clusters kunnen niet worden aangepast."},t.nl_NL=t.nl,t.nl_BE=t.nl,t["pt-br"]={edit:"Editar",del:"Remover selecionado",back:"Voltar",addNode:"Adicionar nó",addEdge:"Adicionar aresta",editNode:"Editar nó",editEdge:"Editar aresta",addDescription:"Clique em um espaço em branco para adicionar um novo nó",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",createEdgeError:"Não foi possível linkar arestas a um cluster.",deleteClusterError:"Clusters não puderam ser removidos.",editClusterError:"Clusters não puderam ser editados."},t["pt-BR"]=t["pt-br"],t.pt_BR=t["pt-br"],t.pt_br=t["pt-br"],t.ru={edit:"Редактировать",del:"Удалить выбранное",back:"Назад",addNode:"Добавить узел",addEdge:"Добавить ребро",editNode:"Редактировать узел",editEdge:"Редактировать ребро",addDescription:"Кликните в свободное место, чтобы добавить новый узел.",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",createEdgeError:"Невозможно соединить ребра в кластер.",deleteClusterError:"Кластеры не могут быть удалены",editClusterError:"Кластеры недоступны для редактирования."},t.ru_RU=t.ru,t.cn={edit:"编辑",del:"删除选定",back:"返回",addNode:"添加节点",addEdge:"添加连接线",editNode:"编辑节点",editEdge:"编辑连接线",addDescription:"单击空白处放置新节点。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",createEdgeError:"无法将连接线连接到群集。",deleteClusterError:"无法删除群集。",editClusterError:"无法编辑群集。"},t.zh_CN=t.cn,t.uk={edit:"Редагувати",del:"Видалити обране",back:"Назад",addNode:"Додати вузол",addEdge:"Додати край",editNode:"Редагувати вузол",editEdge:"Редагувати край",addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",createEdgeError:"Не можливо об'єднати краї в групу.",deleteClusterError:"Групи не можуть бути видалені.",editClusterError:"Групи недоступні для редагування."},t.uk_UA=t.uk,t.fr={edit:"Editer",del:"Effacer la selection",back:"Retour",addNode:"Ajouter un noeud",addEdge:"Ajouter un lien",editNode:"Editer le noeud",editEdge:"Editer le lien",addDescription:"Cliquez dans un endroit vide pour placer un noeud.",edgeDescription:"Cliquez sur un noeud et glissez le lien vers un autre noeud pour les connecter.",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un noeud.",createEdgeError:"Impossible de créer un lien vers un cluster.",deleteClusterError:"Les clusters ne peuvent pas être éffacés.",editClusterError:"Les clusters ne peuvent pas être édites."},t.fr_FR=t.fr,t.cs={edit:"Upravit",del:"Smazat výběr",back:"Zpět",addNode:"Přidat vrchol",addEdge:"Přidat hranu",editNode:"Upravit vrchol",editEdge:"Upravit hranu",addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",createEdgeError:"Nelze připojit hranu ke shluku.",deleteClusterError:"Nelze mazat shluky.",editClusterError:"Nelze upravovat shluky."},t.cs_CZ=t.cs}));var Ks=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")};G({target:"Object",stat:!0,forced:!c,sham:!c},{defineProperty:q.f});var Zs=r((function(e){var t=L.Object,i=e.exports=function(e,i,o){return t.defineProperty(e,i,o)};t.defineProperty.sham&&(i.sham=!0)})),$s=Zs;function Js(e,t){for(var i=0;i<t.length;i++){var o=t[i];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),$s(e,o.key,o)}}var Qs=function(e,t,i){return t&&Js(e.prototype,t),i&&Js(e,i),e},er=function(){function e(){Ks(this,e),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return Qs(e,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var e=this.image.width,t=this.image.height;this.width=e,this.height=t;var i=Math.floor(t/2),o=Math.floor(t/4),n=Math.floor(t/8),s=Math.floor(t/16),r=Math.floor(e/2),a=Math.floor(e/4),h=Math.floor(e/8),d=Math.floor(e/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,r,i],[r,0,a,o],[r,o,h,n],[5*h,o,d,s]],this._fillMipMap()}}},{key:"initialized",value:function(){return void 0!==this.coordinates}},{key:"_fillMipMap",value:function(){var e=this.canvas.getContext("2d"),t=this.coordinates[0];e.drawImage(this.image,t[0],t[1],t[2],t[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var o=this.coordinates[i-1],n=this.coordinates[i];e.drawImage(this.canvas,o[0],o[1],o[2],o[3],n[0],n[1],n[2],n[3])}}},{key:"drawImageAtPosition",value:function(e,t,i,o,n,s){if(this.initialized())if(t>2){t*=.5;for(var r=0;t>2&&r<this.NUM_ITERATIONS;)t*=.5,r+=1;r>=this.NUM_ITERATIONS&&(r=this.NUM_ITERATIONS-1);var a=this.coordinates[r];e.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,o,n,s)}else e.drawImage(this.image,i,o,n,s)}}]),e}(),tr=function(){function e(t){Ks(this,e),this.images={},this.imageBroken={},this.callback=t}return Qs(e,[{key:"_tryloadBrokenUrl",value:function(e,t,i){void 0!==e&&void 0!==i&&(void 0!==t?(i.image.onerror=function(){console.error("Could not load brokenImage:",t)},i.image.src=t):console.warn("No broken url image defined"))}},{key:"_redrawWithImage",value:function(e){this.callback&&this.callback(e)}},{key:"load",value:function(e,t){var i=this,o=this.images[e];if(o)return o;var n=new er;return this.images[e]=n,n.image.onload=function(){i._fixImageCoordinates(n.image),n.init(),i._redrawWithImage(n)},n.image.onerror=function(){console.error("Could not load image:",e),i._tryloadBrokenUrl(e,t,n)},n.image.src=e,n}},{key:"_fixImageCoordinates",value:function(e){0===e.width&&(document.body.appendChild(e),e.width=e.offsetWidth,e.height=e.offsetHeight,document.body.removeChild(e))}}]),e}(),ir=function(){function e(){Ks(this,e),this.clear(),this.defaultIndex=0,this.groupsArray=[],this.groupIndex=0,this.defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},t.extend(this.options,this.defaultOptions)}return Qs(e,[{key:"setOptions",value:function(e){var t=["useDefaultGroups"];if(void 0!==e)for(var i in e)if(e.hasOwnProperty(i)&&-1===Vi(t).call(t,i)){var o=e[i];this.add(i,o)}}},{key:"clear",value:function(){this.groups={},this.groupsArray=[]}},{key:"get",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.groups[e];if(void 0===i&&t)if(!1===this.options.useDefaultGroups&&this.groupsArray.length>0){var o=this.groupIndex%this.groupsArray.length;this.groupIndex++,(i={}).color=this.groups[this.groupsArray[o]],this.groups[e]=i}else{var n=this.defaultIndex%this.defaultGroups.length;this.defaultIndex++,(i={}).color=this.defaultGroups[n],this.groups[e]=i}return i}},{key:"add",value:function(e,t){return this.groups[e]=t,this.groupsArray.push(e),t}}]),e}(),or=[].slice,nr=/MSIE .\./.test(ui),sr=function(e){return function(t,i){var o=arguments.length>2,n=o?or.call(arguments,2):void 0;return e(o?function(){("function"==typeof t?t:Function(t)).apply(this,n)}:t,i)}};G({global:!0,bind:!0,forced:nr},{setTimeout:sr(d.setTimeout),setInterval:sr(d.setInterval)});var rr=L.setTimeout,ar=function(e){return function(t,i){var o,n,s=String(w(t)),r=Je(i),a=s.length;return r<0||r>=a?e?"":void 0:(o=s.charCodeAt(r))<55296||o>56319||r+1===a||(n=s.charCodeAt(r+1))<56320||n>57343?e?s.charAt(r):o:e?s.slice(r,r+2):n-56320+(o-55296<<10)+65536}},hr={codeAt:ar(!1),charAt:ar(!0)}.charAt,dr=ze.set,lr=ze.getterFor("String Iterator");Nt(String,"String",(function(e){dr(this,{type:"String Iterator",string:String(e),index:0})}),(function(){var e,t=lr(this),i=t.string,o=t.index;return o>=i.length?{value:void 0,done:!0}:(e=hr(i,o),t.index+=e.length,{value:e,done:!1})}));var cr=Ye("iterator"),ur=function(e){if(null!=e)return e[cr]||e["@@iterator"]||le[xt(e)]},pr=function(e){var t=ur(e);if("function"!=typeof t)throw TypeError(String(e)+" is not iterable");return W(t.call(e))},fr=Gt.some,vr=Kt("some"),gr=Jt("some");G({target:"Array",proto:!0,forced:!vr||!gr},{some:function(e){return fr(this,e,arguments.length>1?arguments[1]:void 0)}});var yr=Q("Array").some,mr=Array.prototype,br=function(e){var t=e.some;return e===mr||e instanceof Array&&t===mr.some?yr:t},wr=l((function(){dt(1)}));G({target:"Object",stat:!0,forced:wr},{keys:function(e){return dt(Ne(e))}});var kr=L.Object.keys,_r=Zs;G({target:"Object",stat:!0,forced:!c,sham:!c},{defineProperties:lt});var xr=r((function(e){var t=L.Object,i=e.exports=function(e,i){return t.defineProperties(e,i)};t.defineProperties.sham&&(i.sham=!0)})),Er=ht.concat("length","prototype"),Or={f:Object.getOwnPropertyNames||function(e){return at(e,Er)}},Cr={f:Object.getOwnPropertySymbols},Tr=ut("Reflect","ownKeys")||function(e){var t=Or.f(W(e)),i=Cr.f;return i?t.concat(i(e)):t};G({target:"Object",stat:!0,sham:!c},{getOwnPropertyDescriptors:function(e){for(var t,i,o=k(e),n=I.f,s=Tr(o),r={},a=0;s.length>a;)void 0!==(i=n(o,t=s[a++]))&&ci(r,t,i);return r}});var Sr=L.Object.getOwnPropertyDescriptors,Mr=I.f,Dr=l((function(){Mr(1)}));G({target:"Object",stat:!0,forced:!c||Dr,sham:!c},{getOwnPropertyDescriptor:function(e,t){return Mr(k(e),t)}});var Ir=r((function(e){var t=L.Object,i=e.exports=function(e,i){return t.getOwnPropertyDescriptor(e,i)};t.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),Pr=Ir,Fr=Gt.filter,Br=mi("filter"),zr=Jt("filter");G({target:"Array",proto:!0,forced:!Br||!zr},{filter:function(e){return Fr(this,e,arguments.length>1?arguments[1]:void 0)}});var Nr=Q("Array").filter,Ar=Array.prototype,Rr=function(e){var t=e.filter;return e===Ar||e instanceof Array&&t===Ar.filter?Nr:t},Lr=Or.f,jr={}.toString,Hr="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Wr={f:function(e){return Hr&&"[object Window]"==jr.call(e)?function(e){try{return Lr(e)}catch(e){return Hr.slice()}}(e):Lr(k(e))}},Vr={f:Ye},qr=q.f,Ur=function(e){var t=L.Symbol||(L.Symbol={});O(t,e)||qr(t,e,{value:Vr.f(e)})},Yr=Gt.forEach,Xr=Ee("hidden"),Gr=Ye("toPrimitive"),Kr=ze.set,Zr=ze.getterFor("Symbol"),$r=Object.prototype,Jr=d.Symbol,Qr=ut("JSON","stringify"),ea=I.f,ta=q.f,ia=Wr.f,oa=f.f,na=be("symbols"),sa=be("op-symbols"),ra=be("string-to-symbol-registry"),aa=be("symbol-to-string-registry"),ha=be("wks"),da=d.QObject,la=!da||!da.prototype||!da.prototype.findChild,ca=c&&l((function(){return 7!=mt(ta({},"a",{get:function(){return ta(this,"a",{value:7}).a}})).a}))?function(e,t,i){var o=ea($r,t);o&&delete $r[t],ta(e,t,i),o&&e!==$r&&ta($r,t,o)}:ta,ua=function(e,t){var i=na[e]=mt(Jr.prototype);return Kr(i,{type:"Symbol",tag:e,description:t}),c||(i.description=t),i},pa=We?function(e){return"symbol"==typeof e}:function(e){return Object(e)instanceof Jr},fa=function(e,t,i){e===$r&&fa(sa,t,i),W(e);var o=x(t,!0);return W(i),O(na,o)?(i.enumerable?(O(e,Xr)&&e[Xr][o]&&(e[Xr][o]=!1),i=mt(i,{enumerable:v(0,!1)})):(O(e,Xr)||ta(e,Xr,v(1,{})),e[Xr][o]=!0),ca(e,o,i)):ta(e,o,i)},va=function(e,t){W(e);var i=k(t),o=dt(i).concat(ba(i));return Yr(o,(function(t){c&&!ga.call(i,t)||fa(e,t,i[t])})),e},ga=function(e){var t=x(e,!0),i=oa.call(this,t);return!(this===$r&&O(na,t)&&!O(sa,t))&&(!(i||!O(this,t)||!O(na,t)||O(this,Xr)&&this[Xr][t])||i)},ya=function(e,t){var i=k(e),o=x(t,!0);if(i!==$r||!O(na,o)||O(sa,o)){var n=ea(i,o);return!n||!O(na,o)||O(i,Xr)&&i[Xr][o]||(n.enumerable=!0),n}},ma=function(e){var t=ia(k(e)),i=[];return Yr(t,(function(e){O(na,e)||O(Oe,e)||i.push(e)})),i},ba=function(e){var t=e===$r,i=ia(t?sa:k(e)),o=[];return Yr(i,(function(e){!O(na,e)||t&&!O($r,e)||o.push(na[e])})),o};if(He||(It((Jr=function(){if(this instanceof Jr)throw TypeError("Symbol is not a constructor");var e=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,t=_e(e),i=function(e){this===$r&&i.call(sa,e),O(this,Xr)&&O(this[Xr],t)&&(this[Xr][t]=!1),ca(this,t,v(1,e))};return c&&la&&ca($r,t,{configurable:!0,set:i}),ua(t,e)}).prototype,"toString",(function(){return Zr(this).tag})),It(Jr,"withoutSetter",(function(e){return ua(_e(e),e)})),f.f=ga,q.f=fa,I.f=ya,Or.f=Wr.f=ma,Cr.f=ba,Vr.f=function(e){return ua(Ye(e),e)},c&&ta(Jr.prototype,"description",{configurable:!0,get:function(){return Zr(this).description}})),G({global:!0,wrap:!0,forced:!He,sham:!He},{Symbol:Jr}),Yr(dt(ha),(function(e){Ur(e)})),G({target:"Symbol",stat:!0,forced:!He},{for:function(e){var t=String(e);if(O(ra,t))return ra[t];var i=Jr(t);return ra[t]=i,aa[i]=t,i},keyFor:function(e){if(!pa(e))throw TypeError(e+" is not a symbol");if(O(aa,e))return aa[e]},useSetter:function(){la=!0},useSimple:function(){la=!1}}),G({target:"Object",stat:!0,forced:!He,sham:!c},{create:function(e,t){return void 0===t?mt(e):va(mt(e),t)},defineProperty:fa,defineProperties:va,getOwnPropertyDescriptor:ya}),G({target:"Object",stat:!0,forced:!He},{getOwnPropertyNames:ma,getOwnPropertySymbols:ba}),G({target:"Object",stat:!0,forced:l((function(){Cr.f(1)}))},{getOwnPropertySymbols:function(e){return Cr.f(Ne(e))}}),Qr){var wa=!He||l((function(){var e=Jr();return"[null]"!=Qr([e])||"{}"!=Qr({a:e})||"{}"!=Qr(Object(e))}));G({target:"JSON",stat:!0,forced:wa},{stringify:function(e,t,i){for(var o,n=[e],s=1;arguments.length>s;)n.push(arguments[s++]);if(o=t,(_(t)||void 0!==e)&&!pa(e))return Vt(t)||(t=function(e,t){if("function"==typeof o&&(t=o.call(this,e,t)),!pa(t))return t}),n[1]=t,Qr.apply(null,n)}})}Jr.prototype[Gr]||U(Jr.prototype,Gr,Jr.prototype.valueOf),Tt(Jr,"Symbol"),Oe[Xr]=!0;var ka=L.Object.getOwnPropertySymbols;var _a=function(e,t,i){return t in e?$s(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e},xa="\t\n\v\f\r                　\u2028\u2029\ufeff",Ea="["+xa+"]",Oa=RegExp("^"+Ea+Ea+"*"),Ca=RegExp(Ea+Ea+"*$"),Ta=function(e){return function(t){var i=String(w(t));return 1&e&&(i=i.replace(Oa,"")),2&e&&(i=i.replace(Ca,"")),i}},Sa={start:Ta(1),end:Ta(2),trim:Ta(3)},Ma=Sa.trim,Da=d.parseFloat,Ia=1/Da(xa+"-0")!=-1/0?function(e){var t=Ma(String(e)),i=Da(t);return 0===i&&"-"==t.charAt(0)?-0:i}:Da;G({global:!0,forced:parseFloat!=Ia},{parseFloat:Ia});var Pa=L.parseFloat,Fa=Sa.trim,Ba=d.parseInt,za=/^[+-]?0[Xx]/,Na=8!==Ba(xa+"08")||22!==Ba(xa+"0x16")?function(e,t){var i=Fa(String(e));return Ba(i,t>>>0||(za.test(i)?16:10))}:Ba;G({global:!0,forced:parseInt!=Na},{parseInt:Na});var Aa=L.parseInt,Ra=di;var La=function(e){if(Ra(e))return e},ja=Ye("iterator"),Ha=function(e){var t=Object(e);return void 0!==t[ja]||"@@iterator"in t||le.hasOwnProperty(xt(t))};var Wa=function(e,t){if(Ha(Object(e))||"[object Arguments]"===Object.prototype.toString.call(e)){var i=[],o=!0,n=!1,s=void 0;try{for(var r,a=pr(e);!(o=(r=a.next()).done)&&(i.push(r.value),!t||i.length!==t);o=!0);}catch(e){n=!0,s=e}finally{try{o||null==a.return||a.return()}finally{if(n)throw s}}return i}};var Va=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")};var qa=function(e,t){return La(e)||Wa(e,t)||Va()};Ur("iterator");var Ua=Vr.f("iterator"),Ya=Ye("isConcatSpreadable"),Xa=gi>=51||!l((function(){var e=[];return e[Ya]=!1,e.concat()[0]!==e})),Ga=mi("concat"),Ka=function(e){if(!_(e))return!1;var t=e[Ya];return void 0!==t?!!t:Vt(e)};G({target:"Array",proto:!0,forced:!Xa||!Ga},{concat:function(e){var t,i,o,n,s,r=Ne(this),a=Ut(r,0),h=0;for(t=-1,o=arguments.length;t<o;t++)if(s=-1===t?r:arguments[t],Ka(s)){if(h+(n=et(s.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<n;i++,h++)i in s&&ci(a,h,s[i])}else{if(h>=9007199254740991)throw TypeError("Maximum allowed index exceeded");ci(a,h++,s)}return a.length=h,a}});var Za=Object.freeze({__proto__:null});Ur("asyncIterator");var $a=Object.freeze({__proto__:null});Ur("hasInstance"),Ur("isConcatSpreadable"),Ur("match"),Ur("matchAll"),Ur("replace"),Ur("search"),Ur("species"),Ur("split"),Ur("toPrimitive"),Ur("toStringTag"),Ur("unscopables"),Tt(Math,"Math",!0),Tt(d.JSON,"JSON",!0),a(Za),a($a);var Ja=L.Symbol;Ur("asyncDispose"),Ur("dispose"),Ur("observable"),Ur("patternMatch"),Ur("replaceAll");var Qa=Ja,eh=r((function(e){function t(i){return e.exports=t="function"==typeof Qa&&"symbol"==typeof Ua?function(e){return typeof e}:function(e){return e&&"function"==typeof Qa&&e.constructor===Qa&&e!==Qa.prototype?"symbol":typeof e},t(i)}e.exports=t})),th=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"choosify",value:function(e,i){var o=["node","edge","label"],n=!0,s=t.topMost(i,"chosen");if("boolean"==typeof s)n=s;else if("object"===eh(s)){if(-1===Vi(o).call(o,e))throw new Error("choosify: subOption '"+e+"' should be one of '"+o.join("', '")+"'");var r=t.topMost(i,["chosen",e]);"boolean"!=typeof r&&"function"!=typeof r||(n=r)}return n}},{key:"pointInRect",value:function(e,t,i){if(e.width<=0||e.height<=0)return!1;if(void 0!==i){var o={x:t.x-i.x,y:t.y-i.y};if(0!==i.angle){var n=-i.angle;t={x:Math.cos(n)*o.x-Math.sin(n)*o.y,y:Math.sin(n)*o.x+Math.cos(n)*o.y}}else t=o}var s=e.x+e.width,r=e.y+e.width;return e.left<t.x&&s>t.x&&e.top<t.y&&r>t.y}},{key:"isValidLabel",value:function(e){return"string"==typeof e&&""!==e}},{key:"getSelfRefCoordinates",value:function(e,t,i,o){var n=o.x,s=o.y;if("function"==typeof o.distanceToBorder){var r=o.distanceToBorder(e,t),a=Math.sin(t)*r,h=Math.cos(t)*r;h===r?(n+=r,s=o.y):a===r?(n=o.x,s-=r):(n+=h,s-=a)}else o.shape.width>o.shape.height?(n=o.x+.5*o.shape.width,s=o.y-i):(n=o.x+i,s=o.y-.5*o.shape.height);return{x:n,y:s}}}]),e}(),ih=mi("slice"),oh=Jt("slice",{ACCESSORS:!0,0:0,1:2}),nh=Ye("species"),sh=[].slice,rh=Math.max;G({target:"Array",proto:!0,forced:!ih||!oh},{slice:function(e,t){var i,o,n,s=k(this),r=et(s.length),a=ot(e,r),h=ot(void 0===t?r:t,r);if(Vt(s)&&("function"!=typeof(i=s.constructor)||i!==Array&&!Vt(i.prototype)?_(i)&&null===(i=i[nh])&&(i=void 0):i=void 0,i===Array||void 0===i))return sh.call(s,a,h);for(o=new(void 0===i?Array:i)(rh(h-a,0)),n=0;a<h;a++,n++)a in s&&ci(o,n,s[a]);return o.length=n,o}});var ah=Q("Array").slice,hh=Array.prototype,dh=function(e){var t=e.slice;return e===hh||e instanceof Array&&t===hh.slice?ah:t},lh=Q("Array").values,ch=Array.prototype,uh={DOMTokenList:!0,NodeList:!0},ph=function(e){var t=e.values;return e===ch||e instanceof Array&&t===ch.values||uh.hasOwnProperty(xt(e))?lh:t},fh=Object.assign,vh=Object.defineProperty,gh=!fh||l((function(){if(c&&1!==fh({b:1},fh(vh({},"a",{enumerable:!0,get:function(){vh(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var e={},t={},i=Symbol();return e[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(e){t[e]=e})),7!=fh({},e)[i]||"abcdefghijklmnopqrst"!=dt(fh({},t)).join("")}))?function(e,t){for(var i=Ne(e),o=arguments.length,n=1,s=Cr.f,r=f.f;o>n;)for(var a,h=b(arguments[n++]),d=s?dt(h).concat(s(h)):dt(h),l=d.length,u=0;l>u;)a=d[u++],c&&!r.call(h,a)||(i[a]=h[a]);return i}:fh;G({target:"Object",stat:!0,forced:Object.assign!==gh},{assign:gh});var yh=L.Object.assign,mh=function(){function e(t){Ks(this,e),this.measureText=t,this.current=0,this.width=0,this.height=0,this.lines=[]}return Qs(e,[{key:"_add",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"normal";void 0===this.lines[e]&&(this.lines[e]={width:0,height:0,blocks:[]});var o=t;void 0!==t&&""!==t||(o=" ");var n=this.measureText(o,i),s=yh({},ph(n));s.text=t,s.width=n.width,s.mod=i,void 0!==t&&""!==t||(s.width=0),this.lines[e].blocks.push(s),this.lines[e].width+=s.width}},{key:"curWidth",value:function(){var e=this.lines[this.current];return void 0===e?0:e.width}},{key:"append",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,e,t)}},{key:"newLine",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,e,t),this.current++}},{key:"determineLineHeights",value:function(){for(var e=0;e<this.lines.length;e++){var t=this.lines[e],i=0;if(void 0!==t.blocks)for(var o=0;o<t.blocks.length;o++){var n=t.blocks[o];i<n.height&&(i=n.height)}t.height=i}}},{key:"determineLabelSize",value:function(){for(var e=0,t=0,i=0;i<this.lines.length;i++){var o=this.lines[i];o.width>e&&(e=o.width),t+=o.height}this.width=e,this.height=t}},{key:"removeEmptyBlocks",value:function(){for(var e=[],t=0;t<this.lines.length;t++){var i=this.lines[t];if(0!==i.blocks.length&&(t!==this.lines.length-1||0!==i.width)){var o={};yh(o,i),o.blocks=[];for(var n=void 0,s=[],r=0;r<i.blocks.length;r++){var a=i.blocks[r];0!==a.width?s.push(a):void 0===n&&(n=a)}0===s.length&&void 0!==n&&s.push(n),o.blocks=s,e.push(o)}}return e}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var e=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:e}}}]),e}(),bh={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/\_/,"`":/`/,afterBold:/[^\*]/,afterItal:/[^_]/,afterMono:/[^`]/},wh=function(){function e(t){Ks(this,e),this.text=t,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return Qs(e,[{key:"mod",value:function(){return 0===this.modStack.length?"normal":this.modStack[0]}},{key:"modName",value:function(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(e){" "===e&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=e&&(this.buffer+=e)}},{key:"parseWS",value:function(e){return!!/[ \t]/.test(e)&&(this.mono?this.add(e):this.spacing=!0,!0)}},{key:"setTag",value:function(e){this.emitBlock(),this[e]=!0,this.modStack.unshift(e)}},{key:"unsetTag",value:function(e){this.emitBlock(),this[e]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(e,t){return!(this.mono||this[e]||!this.match(t))&&(this.setTag(e),!0)}},{key:"match",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.prepareRegExp(e),o=qa(i,2),n=o[0],s=o[1],r=n.test(this.text.substr(this.position,s));return r&&t&&(this.position+=s-1),r}},{key:"parseEndTag",value:function(e,t,i){var o=this.mod()===e;return!(!(o="mono"===e?o&&this.mono:o&&!this.mono)||!this.match(t))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(e):this.unsetTag(e),!0)}},{key:"replace",value:function(e,t){return!!this.match(e)&&(this.add(t),this.position+=length-1,!0)}},{key:"prepareRegExp",value:function(e){var t,i;if(e instanceof RegExp)i=e,t=1;else{var o=bh[e];i=void 0!==o?o:new RegExp(e),t=e.length}return[i,t]}}]),e}(),kh=function(){function e(t,i,o,n){var s=this;Ks(this,e),this.ctx=t,this.parent=i,this.selected=o,this.hover=n;this.lines=new mh((function(e,i){if(void 0===e)return 0;var r=s.parent.getFormattingValues(t,o,n,i),a=0;""!==e&&(a=s.ctx.measureText(e).width);return{width:a,values:r}}))}return Qs(e,[{key:"process",value:function(e){if(!th.isValidLabel(e))return this.lines.finalize();var t=this.parent.fontOptions;e=(e=e.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");var i=String(e).split("\n"),o=i.length;if(t.multi)for(var n=0;n<o;n++){var s=this.splitBlocks(i[n],t.multi);if(void 0!==s)if(0!==s.length){if(t.maxWdt>0)for(var r=0;r<s.length;r++){var a=s[r].mod,h=s[r].text;this.splitStringIntoLines(h,a,!0)}else for(var d=0;d<s.length;d++){var l=s[d].mod,c=s[d].text;this.lines.append(c,l)}this.lines.newLine()}else this.lines.newLine("")}else if(t.maxWdt>0)for(var u=0;u<o;u++)this.splitStringIntoLines(i[u]);else for(var p=0;p<o;p++)this.lines.newLine(i[p]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(e){var t="none";return"markdown"===e||"md"===e?t="markdown":!0!==e&&"html"!==e||(t="html"),t}},{key:"splitHtmlBlocks",value:function(e){for(var t=new wh(e),i=function(e){return!!/&/.test(e)&&(t.replace(t.text,"&lt;","<")||t.replace(t.text,"&amp;","&")||t.add("&"),!0)};t.position<t.text.length;){var o=t.text.charAt(t.position);t.parseWS(o)||/</.test(o)&&(t.parseStartTag("bold","<b>")||t.parseStartTag("ital","<i>")||t.parseStartTag("mono","<code>")||t.parseEndTag("bold","</b>")||t.parseEndTag("ital","</i>")||t.parseEndTag("mono","</code>"))||i(o)||t.add(o),t.position++}return t.emitBlock(),t.blocks}},{key:"splitMarkdownBlocks",value:function(e){for(var t=this,i=new wh(e),o=!0,n=function(e){return!!/\\/.test(e)&&(i.position<t.text.length+1&&(i.position++,e=t.text.charAt(i.position),/ \t/.test(e)?i.spacing=!0:(i.add(e),o=!1)),!0)};i.position<i.text.length;){var s=i.text.charAt(i.position);i.parseWS(s)||n(s)||(o||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono")||(i.add(s),o=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(e,t){var i=this.decodeMarkupSystem(t);return"none"===i?[{text:e,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(e):"html"===i?this.splitHtmlBlocks(e):void 0}},{key:"overMaxWidth",value:function(e){var t=this.ctx.measureText(e).width;return this.lines.curWidth()+t>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(e){for(var t="",i=0;i<e.length;){var o=t+(""===t?"":" ")+e[i];if(this.overMaxWidth(o))break;t=o,i++}return i}},{key:"getLongestFitWord",value:function(e){for(var t=0;t<e.length&&!this.overMaxWidth(dh(e).call(e,0,t));)t++;return t}},{key:"splitStringIntoLines",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal",i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this.parent.getFormattingValues(this.ctx,this.selected,this.hover,t);for(var o=(e=(e=e.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");o.length>0;){var n=this.getLongestFit(o);if(0===n){var s=o[0],r=this.getLongestFitWord(s);this.lines.newLine(dh(s).call(s,0,r),t),o[0]=dh(s).call(s,r)}else{var a=n;" "===o[n-1]?n--:" "===o[a]&&a++;var h=dh(o).call(o,0,n).join("");n==o.length&&i?this.lines.append(h,t):this.lines.newLine(h,t),o=dh(o).call(o,a)}}}}]),e}(),_h=["bold","ital","boldital","mono"],xh=function(){function e(t,i){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2];Ks(this,e),this.body=t,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(i),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=o}return Qs(e,[{key:"setOptions",value:function(e){if(this.elementOptions=e,this.initFontOptions(e.font),th.isValidLabel(e.label)?this.labelDirty=!0:e.label=void 0,void 0!==e.font&&null!==e.font)if("string"==typeof e.font)this.baseSize=this.fontOptions.size;else if("object"===eh(e.font)){var t=e.font.size;void 0!==t&&(this.baseSize=t)}}},{key:"initFontOptions",value:function(i){var o=this;t.forEach(_h,(function(e){o.fontOptions[e]={}})),e.parseFontString(this.fontOptions,i)?this.fontOptions.vadjust=0:t.forEach(i,(function(e,t){null!=e&&"object"!==eh(e)&&(o.fontOptions[t]=e)}))}},{key:"constrain",value:function(e){var i={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},o=t.topMost(e,"widthConstraint");if("number"==typeof o)i.maxWdt=Number(o),i.minWdt=Number(o);else if("object"===eh(o)){var n=t.topMost(e,["widthConstraint","maximum"]);"number"==typeof n&&(i.maxWdt=Number(n));var s=t.topMost(e,["widthConstraint","minimum"]);"number"==typeof s&&(i.minWdt=Number(s))}var r=t.topMost(e,"heightConstraint");if("number"==typeof r)i.minHgt=Number(r);else if("object"===eh(r)){var a=t.topMost(e,["heightConstraint","minimum"]);"number"==typeof a&&(i.minHgt=Number(a));var h=t.topMost(e,["heightConstraint","valign"]);"string"==typeof h&&("top"!==h&&"bottom"!==h||(i.valign=h))}return i}},{key:"update",value:function(e,i){this.setOptions(e,!0),this.propagateFonts(i),t.deepExtend(this.fontOptions,this.constrain(i)),this.fontOptions.chooser=th.choosify("label",i)}},{key:"adjustSizes",value:function(e){var t=e?e.right+e.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=t,this.fontOptions.minWdt-=t);var i=e?e.top+e.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(e,t){for(var i=0;i<t.length;++i)this.addFontToPile(e,t[i])}},{key:"addFontToPile",value:function(e,t){if(void 0!==t&&void 0!==t.font&&null!==t.font){var i=t.font;e.push(i)}}},{key:"getBasicOptions",value:function(i){for(var o={},n=0;n<i.length;++n){var s=i[n],r={};e.parseFontString(r,s)&&(s=r),t.forEach(s,(function(e,t){void 0!==e&&(o.hasOwnProperty(t)||(-1!==Vi(_h).call(_h,t)?o[t]={}:o[t]=e))}))}return o}},{key:"getFontOption",value:function(t,i,o){for(var n,s=0;s<t.length;++s){var r=t[s];if(r.hasOwnProperty(i)){if(null==(n=r[i]))continue;var a={};if(e.parseFontString(a,n)&&(n=a),n.hasOwnProperty(o))return n[o]}}if(this.fontOptions.hasOwnProperty(o))return this.fontOptions[o];throw new Error("Did not find value for multi-font for property: '"+o+"'")}},{key:"getFontOptions",value:function(e,t){for(var i={},o=["color","size","face","mod","vadjust"],n=0;n<o.length;++n){var s=o[n];i[s]=this.getFontOption(e,t,s)}return i}},{key:"propagateFonts",value:function(e){var i=this,o=[];this.addFontOptionsToPile(o,e),this.fontOptions=this.getBasicOptions(o);for(var n=function(e){var n=_h[e],s=i.fontOptions[n],r=i.getFontOptions(o,n);t.forEach(r,(function(e,t){s[t]=e})),s.size=Number(s.size),s.vadjust=Number(s.vadjust)},s=0;s<_h.length;++s)n(s)}},{key:"draw",value:function(e,t,i,o,n){var s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";if(void 0!==this.elementOptions.label){var r=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&r<this.elementOptions.scaling.label.drawThreshold-1||(r>=this.elementOptions.scaling.label.maxVisible&&(r=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(e,o,n,t,i,s),this._drawBackground(e),this._drawText(e,t,this.size.yLine,s,r))}}},{key:"_drawBackground",value:function(e){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){e.fillStyle=this.fontOptions.background;var t=this.getSize();e.fillRect(t.left,t.top,t.width,t.height)}}},{key:"_drawText",value:function(e,t,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"middle",n=arguments.length>4?arguments[4]:void 0,s=this._setAlignment(e,t,i,o),r=qa(s,2);t=r[0],i=r[1],e.textAlign="left",t-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(var a=0;a<this.lineCount;a++){var h=this.lines[a];if(h&&h.blocks){var d=0;this.isEdgeLabel||"center"===this.fontOptions.align?d+=(this.size.width-h.width)/2:"right"===this.fontOptions.align&&(d+=this.size.width-h.width);for(var l=0;l<h.blocks.length;l++){var c=h.blocks[l];e.font=c.font;var u=this._getColor(c.color,n,c.strokeColor),p=qa(u,2),f=p[0],v=p[1];c.strokeWidth>0&&(e.lineWidth=c.strokeWidth,e.strokeStyle=v,e.lineJoin="round"),e.fillStyle=f,c.strokeWidth>0&&e.strokeText(c.text,t+d,i+c.vadjust),e.fillText(c.text,t+d,i+c.vadjust),d+=c.width}i+=h.height}}}},{key:"_setAlignment",value:function(e,t,i,o){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){t=0,i=0;"top"===this.fontOptions.align?(e.textBaseline="alphabetic",i-=4):"bottom"===this.fontOptions.align?(e.textBaseline="hanging",i+=4):e.textBaseline="middle"}else e.textBaseline=o;return[t,i]}},{key:"_getColor",value:function(e,i,o){var n=e||"#000000",s=o||"#ffffff";if(i<=this.elementOptions.scaling.label.drawThreshold){var r=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-i)));n=t.overrideOpacity(n,r),s=t.overrideOpacity(s,r)}return[n,s]}},{key:"getTextSize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return this._processLabel(e,t,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var e=this.size.left,t=this.size.top-1;if(this.isEdgeLabel){var i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":e=i,t=.5*-this.size.height;break;case"top":e=i,t=-(this.size.height+2);break;case"bottom":e=i,t=2}}return{left:e,top:t,width:this.size.width,height:this.size.height}}},{key:"calculateLabelSize",value:function(e,t,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:0,s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";this._processLabel(e,t,i),this.size.left=o-.5*this.size.width,this.size.top=n-.5*this.size.height,this.size.yLine=n+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===s&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(e,t,i,o){var n=function(e,t,i){return"normal"===t?"mod"===i?"":e[i]:void 0!==e[t][i]?e[t][i]:e[i]},s={color:n(this.fontOptions,o,"color"),size:n(this.fontOptions,o,"size"),face:n(this.fontOptions,o,"face"),mod:n(this.fontOptions,o,"mod"),vadjust:n(this.fontOptions,o,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(t||i)&&("normal"===o&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?s.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(s,this.elementOptions.id,t,i));var r="";return void 0!==s.mod&&""!==s.mod&&(r+=s.mod+" "),r+=s.size+"px "+s.face,e.font=r.replace(/"/g,""),s.font=e.font,s.height=s.size,s}},{key:"differentState",value:function(e,t){return e!==this.selectedState||t!==this.hoverState}},{key:"_processLabelText",value:function(e,t,i,o){return new kh(e,this,t,i).process(o)}},{key:"_processLabel",value:function(e,t,i){if(!1!==this.labelDirty||this.differentState(t,i)){var o=this._processLabelText(e,t,i,this.elementOptions.label);this.fontOptions.minWdt>0&&o.width<this.fontOptions.minWdt&&(o.width=this.fontOptions.minWdt),this.size.labelHeight=o.height,this.fontOptions.minHgt>0&&o.height<this.fontOptions.minHgt&&(o.height=this.fontOptions.minHgt),this.lines=o.lines,this.lineCount=o.lines.length,this.size.width=o.width,this.size.height=o.height,this.selectedState=t,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){return 0!==this.size.width&&0!==this.size.height&&void 0!==this.elementOptions.label&&!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(e,t){if(!t||"string"!=typeof t)return!1;var i=t.split(" ");return e.size=+i[0].replace("px",""),e.face=i[1],e.color=i[2],!0}}]),e}();var Eh=function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e};var Oh=function(e,t){return!t||"object"!==eh(t)&&"function"!=typeof t?Eh(e):t},Ch=l((function(){je(1)}));G({target:"Object",stat:!0,forced:Ch,sham:!Ae},{getPrototypeOf:function(e){return je(Ne(e))}});var Th=L.Object.getPrototypeOf;G({target:"Object",stat:!0},{setPrototypeOf:Dt});var Sh=L.Object.setPrototypeOf,Mh=r((function(e){function t(i){return e.exports=t=Sh?Th:function(e){return e.__proto__||Th(e)},t(i)}e.exports=t})),Dh=Ui,Ih=r((function(e){function t(i,o){return e.exports=t=Sh||function(e,t){return e.__proto__=t,e},t(i,o)}e.exports=t}));var Ph=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Dh(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Ih(e,t)};G({target:"Array",proto:!0},{fill:function(e){for(var t=Ne(this),i=et(t.length),o=arguments.length,n=ot(o>1?arguments[1]:void 0,i),s=o>2?arguments[2]:void 0,r=void 0===s?i:ot(s,i);r>n;)t[n++]=e;return t}});var Fh=Q("Array").fill,Bh=Array.prototype,zh=function(e){var t=e.fill;return e===Bh||e instanceof Array&&t===Bh.fill?Fh:t},Nh=function(){function e(t,i,o){Ks(this,e),this.body=i,this.labelModule=o,this.setOptions(t),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return Qs(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"_setMargins",value:function(e){this.margin={},this.options.margin&&("object"==eh(this.options.margin)?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),e.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(e,t){var i=this.options.borderWidth;return e&&this.resize(e),Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}},{key:"enableShadow",value:function(e,t){t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}},{key:"disableShadow",value:function(e,t){t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(e,t){if(!1!==t.borderDashes)if(void 0!==e.setLineDash){var i=t.borderDashes;!0===i&&(i=[5,15]),e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1}},{key:"disableBorderDashes",value:function(e,t){!1!==t.borderDashes&&(void 0!==e.setLineDash?e.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1))}},{key:"needsRefresh",value:function(e,t){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(e,t)}},{key:"initContextForDraw",value:function(e,t){var i=t.borderWidth/this.body.view.scale;e.lineWidth=Math.min(this.width,i),e.strokeStyle=t.borderColor,e.fillStyle=t.color}},{key:"performStroke",value:function(e,t){var i=t.borderWidth/this.body.view.scale;e.save(),i>0&&(this.enableBorderDashes(e,t),e.stroke(),this.disableBorderDashes(e,t)),e.restore()}},{key:"performFill",value:function(e,t){this.enableShadow(e,t),zh(e).call(e),this.disableShadow(e,t),this.performStroke(e,t)}},{key:"_addBoundingBoxMargin",value:function(e){this.boundingBox.left-=e,this.boundingBox.top-=e,this.boundingBox.bottom+=e,this.boundingBox.right+=e}},{key:"_updateBoundingBox",value:function(e,t,i,o,n){void 0!==i&&this.resize(i,o,n),this.left=e-this.width/2,this.top=t-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(e,t,i,o,n){this._updateBoundingBox(e,t,i,o,n)}},{key:"getDimensionsFromLabel",value:function(e,t,i){this.textSize=this.labelModule.getTextSize(e,t,i);var o=this.textSize.width,n=this.textSize.height;return 0===o&&(o=14,n=14),{width:o,height:n}}}]),e}(),Ah=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o)))._setMargins(o),n}return Ph(t,e),Qs(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i);this.width=o.width+this.margin.right+this.margin.left,this.height=o.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(e,t,i,o,n,s){this.resize(e,o,n),this.left=t-this.width/2,this.top=i-this.height/2,this.initContextForDraw(e,s),ne(e,this.left,this.top,this.width,this.height,s.borderRadius),this.performFill(e,s),this.updateBoundingBox(t,i,e,o,n),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n)}},{key:"updateBoundingBox",value:function(e,t,i,o,n){this._updateBoundingBox(e,t,i,o,n);var s=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(s)}},{key:"distanceToBorder",value:function(e,t){e&&this.resize(e);var i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}}]),t}(Nh),Rh=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o))).labelOffset=0,n.selected=!1,n}return Ph(t,e),Qs(t,[{key:"setOptions",value:function(e,t,i){this.options=e,void 0===t&&void 0===i||this.setImages(t,i)}},{key:"setImages",value:function(e,t){t&&this.selected?(this.imageObj=t,this.imageObjAlt=e):(this.imageObj=e,this.imageObjAlt=t)}},{key:"switchImages",value:function(e){var t=e&&!this.selected||!e&&this.selected;if(this.selected=e,void 0!==this.imageObjAlt&&t){var i=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=i}}},{key:"_getImagePadding",value:function(){var e={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var t=this.options.imagePadding;"object"==eh(t)?(e.top=t.top,e.right=t.right,e.bottom=t.bottom,e.left=t.left):(e.top=t,e.right=t,e.bottom=t,e.left=t)}return e}},{key:"_resizeImage",value:function(){var e,t;if(!1===this.options.shapeProperties.useImageSize){var i=1,o=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:o=this.imageObj.height/this.imageObj.width),e=2*this.options.size*i,t=2*this.options.size*o}else{var n=this._getImagePadding();e=this.imageObj.width+n.left+n.right,t=this.imageObj.height+n.top+n.bottom}this.width=e,this.height=t,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(e,t,i,o){this.initContextForDraw(e,o),oe(e,t,i,o.size),this.performFill(e,o)}},{key:"_drawImageAtPosition",value:function(e,t){if(0!=this.imageObj.width){e.globalAlpha=1,this.enableShadow(e,t);var i=1;!0===this.options.shapeProperties.interpolation&&(i=this.imageObj.width/this.width/this.body.view.scale);var o=this._getImagePadding(),n=this.left+o.left,s=this.top+o.top,r=this.width-o.left-o.right,a=this.height-o.top-o.bottom;this.imageObj.drawImageAtPosition(e,i,n,s,r,a),this.disableShadow(e,t)}}},{key:"_drawImageLabel",value:function(e,t,i,o,n){var s,r=0;if(void 0!==this.height){r=.5*this.height;var a=this.labelModule.getTextSize(e,o,n);a.lineCount>=1&&(r+=a.height/2)}s=i+r,this.options.label&&(this.labelOffset=r),this.labelModule.draw(e,t,s,o,n,"hanging")}}]),t}(Nh),Lh=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o)))._setMargins(o),n}return Ph(t,e),Qs(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i),n=Math.max(o.width+this.margin.right+this.margin.left,o.height+this.margin.top+this.margin.bottom);this.options.size=n/2,this.width=n,this.height=n,this.radius=this.width/2}}},{key:"draw",value:function(e,t,i,o,n,s){this.resize(e,o,n),this.left=t-this.width/2,this.top=i-this.height/2,this._drawRawCircle(e,t,i,s),this.updateBoundingBox(t,i),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,i,o,n)}},{key:"updateBoundingBox",value:function(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size}},{key:"distanceToBorder",value:function(e,t){return e&&this.resize(e),.5*this.width}}]),t}(Rh),jh=function(e){function t(e,i,o,n,s){var r;return Ks(this,t),(r=Oh(this,Mh(t).call(this,e,i,o))).setImages(n,s),r}return Ph(t,e),Qs(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(o){var n=2*this.options.size;return this.width=n,this.height=n,void(this.radius=.5*this.width)}this.needsRefresh(t,i)&&this._resizeImage()}},{key:"draw",value:function(e,t,i,o,n,s){this.switchImages(o),this.resize(),this.left=t-this.width/2,this.top=i-this.height/2,this._drawRawCircle(e,t,i,s),e.save(),e.clip(),this._drawImageAtPosition(e,s),e.restore(),this._drawImageLabel(e,t,i,o,n),this.updateBoundingBox(t,i)}},{key:"updateBoundingBox",value:function(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size,this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(e,t){return e&&this.resize(e),.5*this.width}}]),t}(Rh),Hh=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o)))._setMargins(o),n}return Ph(t,e),Qs(t,[{key:"resize",value:function(e,t,i){if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i).width+this.margin.right+this.margin.left;this.width=o,this.height=o,this.radius=this.width/2}}},{key:"draw",value:function(e,t,i,o,n,s){this.resize(e,o,n),this.left=t-this.width/2,this.top=i-this.height/2,this.initContextForDraw(e,s),re(e,t-this.width/2,i-this.height/2,this.width,this.height),this.performFill(e,s),this.updateBoundingBox(t,i,e,o,n),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Nh),Wh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{size:this.options.size};if(this.needsRefresh(t,i)){this.labelModule.getTextSize(e,t,i);var n=2*o.size;this.width=n,this.height=n,this.radius=.5*this.width}}},{key:"_drawShape",value:function(e,t,i,o,n,s,r,a){var h;if(this.resize(e,s,r,a),this.left=o-this.width/2,this.top=n-this.height/2,this.initContextForDraw(e,a),(h=t,Object.prototype.hasOwnProperty.call(he,h)?he[h]:function(e){for(var t=arguments.length,i=new Array(t>1?t-1:0),o=1;o<t;o++)i[o-1]=arguments[o];CanvasRenderingContext2D.prototype[h].call(e,i)})(e,o,n,a.size),this.performFill(e,a),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(e.font=(s?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),e.fillStyle=this.options.icon.color||"black",e.textAlign="center",e.textBaseline="middle",e.fillText(this.options.icon.code,o,n)),void 0!==this.options.label){this.labelModule.calculateLabelSize(e,s,r,o,n,"hanging");var d=n+.5*this.height+.5*this.labelModule.size.height;this.labelModule.draw(e,o,d,s,r,"hanging")}this.updateBoundingBox(o,n)}},{key:"updateBoundingBox",value:function(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),t}(Nh),Vh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"diamond",4,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Wh),qh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"circle",2,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return e&&this.resize(e),this.options.size}}]),t}(Wh),Uh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(t,i)){var o=this.getDimensionsFromLabel(e,t,i);this.height=2*o.height,this.width=o.width+o.height,this.radius=.5*this.width}}},{key:"draw",value:function(e,t,i,o,n,s){this.resize(e,o,n),this.left=t-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(e,s),se(e,this.left,this.top,this.width,this.height),this.performFill(e,s),this.updateBoundingBox(t,i,e,o,n),this.labelModule.draw(e,t,i,o,n)}},{key:"distanceToBorder",value:function(e,t){e&&this.resize(e);var i=.5*this.width,o=.5*this.height,n=Math.sin(t)*i,s=Math.cos(t)*o;return i*o/Math.sqrt(n*n+s*s)}}]),t}(Nh),Yh=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o)))._setMargins(o),n}return Ph(t,e),Qs(t,[{key:"resize",value:function(e,t,i){this.needsRefresh(t,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(e,t,i,o,n,s){if(this.resize(e,o,n),this.options.icon.size=this.options.icon.size||50,this.left=t-this.width/2,this.top=i-this.height/2,this._icon(e,t,i,o,n,s),void 0!==this.options.label){this.labelModule.draw(e,this.left+this.iconSize.width/2+this.margin.left,i+this.height/2+5,o)}this.updateBoundingBox(t,i)}},{key:"updateBoundingBox",value:function(e,t){if(this.boundingBox.top=t-.5*this.options.icon.size,this.boundingBox.left=e-.5*this.options.icon.size,this.boundingBox.right=e+.5*this.options.icon.size,this.boundingBox.bottom=t+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}},{key:"_icon",value:function(e,t,i,o,n,s){var r=Number(this.options.icon.size);void 0!==this.options.icon.code?(e.font=[null!=this.options.icon.weight?this.options.icon.weight:o?"bold":"",(null!=this.options.icon.weight&&o?5:0)+r+"px",this.options.icon.face].join(" "),e.fillStyle=this.options.icon.color||"black",e.textAlign="center",e.textBaseline="middle",this.enableShadow(e,s),e.fillText(this.options.icon.code,t,i),this.disableShadow(e,s)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Nh),Xh=function(e){function t(e,i,o,n,s){var r;return Ks(this,t),(r=Oh(this,Mh(t).call(this,e,i,o))).setImages(n,s),r}return Ph(t,e),Qs(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(o){var n=2*this.options.size;return this.width=n,void(this.height=n)}this.needsRefresh(t,i)&&this._resizeImage()}},{key:"draw",value:function(e,t,i,o,n,s){if(this.switchImages(o),this.resize(),this.left=t-this.width/2,this.top=i-this.height/2,!0===this.options.shapeProperties.useBorderWithImage){var r=this.options.borderWidth,a=this.options.borderWidthSelected||2*this.options.borderWidth,h=(o?a:r)/this.body.view.scale;e.lineWidth=Math.min(this.width,h),e.beginPath(),e.strokeStyle=o?this.options.color.highlight.border:n?this.options.color.hover.border:this.options.color.border,e.fillStyle=o?this.options.color.highlight.background:n?this.options.color.hover.background:this.options.color.background,e.rect(this.left-.5*e.lineWidth,this.top-.5*e.lineWidth,this.width+e.lineWidth,this.height+e.lineWidth),zh(e).call(e),this.performStroke(e,s),e.closePath()}this._drawImageAtPosition(e,s),this._drawImageLabel(e,t,i,o,n),this.updateBoundingBox(t,i)}},{key:"updateBoundingBox",value:function(e,t){this.resize(),this._updateBoundingBox(e,t),void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Rh),Gh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"square",2,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Wh),Kh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"hexagon",4,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Wh),Zh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"star",4,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Wh),$h=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o)))._setMargins(o),n}return Ph(t,e),Qs(t,[{key:"resize",value:function(e,t,i){this.needsRefresh(t,i)&&(this.textSize=this.labelModule.getTextSize(e,t,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(e,t,i,o,n,s){this.resize(e,o,n),this.left=t-this.width/2,this.top=i-this.height/2,this.enableShadow(e,s),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n),this.disableShadow(e,s),this.updateBoundingBox(t,i,e,o,n)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Nh),Jh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"triangle",3,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Wh),Qh=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"draw",value:function(e,t,i,o,n,s){this._drawShape(e,"triangleDown",3,t,i,o,n,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(Wh),ed=ut("JSON","stringify"),td=/[\uD800-\uDFFF]/g,id=/^[\uD800-\uDBFF]$/,od=/^[\uDC00-\uDFFF]$/,nd=function(e,t,i){var o=i.charAt(t-1),n=i.charAt(t+1);return id.test(e)&&!od.test(n)||od.test(e)&&!id.test(o)?"\\u"+e.charCodeAt(0).toString(16):e},sd=l((function(){return'"\\udf06\\ud834"'!==ed("\udf06\ud834")||'"\\udead"'!==ed("\udead")}));ed&&G({target:"JSON",stat:!0,forced:sd},{stringify:function(e,t,i){var o=ed.apply(null,arguments);return"string"==typeof o?o.replace(td,nd):o}}),L.JSON||(L.JSON={stringify:JSON.stringify});var rd,ad=function(e,t,i){return L.JSON.stringify.apply(null,arguments)},hd=!1,dd="background: #FFeeee; color: #dd0000",ld=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"validate",value:function(t,i,o){hd=!1,rd=i;var n=i;return void 0!==o&&(n=i[o]),e.parse(t,n,[]),hd}},{key:"parse",value:function(t,i,o){for(var n in t)t.hasOwnProperty(n)&&e.check(n,t,i,o)}},{key:"check",value:function(t,i,o,n){if(void 0!==o[t]||void 0!==o.__any__){var s=t,r=!0;void 0===o[t]&&void 0!==o.__any__&&(s="__any__",r="object"===e.getType(i[t]));var a=o[s];r&&void 0!==a.__type__&&(a=a.__type__),e.checkFields(t,i,o,s,a,n)}else e.getSuggestion(t,o,n)}},{key:"checkFields",value:function(i,o,n,s,r,a){var h=function(t){console.log("%c"+t+e.printLocation(a,i),dd)},d=e.getType(o[i]),l=r[d];void 0!==l?"array"===e.getType(l)&&-1===Vi(l).call(l,o[i])?(h('Invalid option detected in "'+i+'". Allowed values are:'+e.print(l)+' not "'+o[i]+'". '),hd=!0):"object"===d&&"__any__"!==s&&(a=t.copyAndExtendArray(a,i),e.parse(o[i],n[s],a)):void 0===r.any&&(h('Invalid type received for "'+i+'". Expected: '+e.print(kr(r))+". Received ["+d+'] "'+o[i]+'"'),hd=!0)}},{key:"getType",value:function(e){var t=eh(e);return"object"===t?null===e?"null":e instanceof Boolean?"boolean":e instanceof Number?"number":e instanceof String?"string":li(e)?"array":e instanceof Date?"date":void 0!==e.nodeType?"dom":!0===e._isAMomentObject?"moment":"object":"number"===t?"number":"boolean"===t?"boolean":"string"===t?"string":void 0===t?"undefined":t}},{key:"getSuggestion",value:function(t,i,o){var n,s=e.findInOptions(t,i,o,!1),r=e.findInOptions(t,rd,[],!0);n=void 0!==s.indexMatch?" in "+e.printLocation(s.path,t,"")+'Perhaps it was incomplete? Did you mean: "'+s.indexMatch+'"?\n\n':r.distance<=4&&s.distance>r.distance?" in "+e.printLocation(s.path,t,"")+"Perhaps it was misplaced? Matching option found at: "+e.printLocation(r.path,r.closestMatch,""):s.distance<=8?'. Did you mean "'+s.closestMatch+'"?'+e.printLocation(s.path,t):". Did you mean one of these: "+e.print(kr(i))+e.printLocation(o,t),console.log('%cUnknown option detected: "'+t+'"'+n,dd),hd=!0}},{key:"findInOptions",value:function(i,o,n){var s=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,a="",h=[],d=i.toLowerCase(),l=void 0;for(var c in o){var u=void 0;if(void 0!==o[c].__type__&&!0===s){var p=e.findInOptions(i,o[c],t.copyAndExtendArray(n,c));r>p.distance&&(a=p.closestMatch,h=p.path,r=p.distance,l=p.indexMatch)}else{var f;-1!==Vi(f=c.toLowerCase()).call(f,d)&&(l=c),r>(u=e.levenshteinDistance(i,c))&&(a=c,h=t.copyArray(n),r=u)}}return{closestMatch:a,path:h,distance:r,indexMatch:l}}},{key:"printLocation",value:function(e,t){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",o="\n\n"+i+"options = {\n",n=0;n<e.length;n++){for(var s=0;s<n+1;s++)o+="  ";o+=e[n]+": {\n"}for(var r=0;r<e.length+1;r++)o+="  ";o+=t+"\n";for(var a=0;a<e.length+1;a++){for(var h=0;h<e.length-a;h++)o+="  ";o+="}\n"}return o+"\n\n"}},{key:"print",value:function(e){return ad(e).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(e,t){if(0===e.length)return t.length;if(0===t.length)return e.length;var i,o,n=[];for(i=0;i<=t.length;i++)n[i]=[i];for(o=0;o<=e.length;o++)n[0][o]=o;for(i=1;i<=t.length;i++)for(o=1;o<=e.length;o++)t.charAt(i-1)==e.charAt(o-1)?n[i][o]=n[i-1][o-1]:n[i][o]=Math.min(n[i-1][o-1]+1,Math.min(n[i][o-1]+1,n[i-1][o]+1));return n[t.length][e.length]}}]),e}();function cd(e,t){var i=kr(e);if(ka){var o=ka(e);t&&(o=Rr(o).call(o,(function(t){return Pr(e,t).enumerable}))),i.push.apply(i,o)}return i}var ud=function(){function e(i,o,n,s,r,a){Ks(this,e),this.options=t.bridgeObject(r),this.globalOptions=r,this.defaultOptions=a,this.body=o,this.edges=[],this.id=void 0,this.imagelist=n,this.grouplist=s,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new xh(this.body,this.options,!1),this.setOptions(i)}return Qs(e,[{key:"attachEdge",value:function(e){var t;-1===Vi(t=this.edges).call(t,e)&&this.edges.push(e)}},{key:"detachEdge",value:function(e){var t,i,o=Vi(t=this.edges).call(t,e);-1!=o&&Oi(i=this.edges).call(i,o,1)}},{key:"setOptions",value:function(t){var i=this.options.shape;if(t){if(void 0!==t.color&&(this._localColor=t.color),void 0!==t.id&&(this.id=t.id),void 0===this.id)throw new Error("Node must have an id");e.checkMass(t,this.id),void 0!==t.x&&(null===t.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=Aa(t.x),this.predefinedPosition=!0)),void 0!==t.y&&(null===t.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=Aa(t.y),this.predefinedPosition=!0)),void 0!==t.size&&(this.baseSize=t.size),void 0!==t.value&&(t.value=Pa(t.value)),e.parseOptions(this.options,t,!0,this.globalOptions,this.grouplist);var o=[t,this.options,this.defaultOptions];return this.chooser=th.choosify("node",o),this._load_images(),this.updateLabelModule(t),this.updateShape(i),void 0!==t.hidden||void 0!==t.physics}}},{key:"_load_images",value:function(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var e={color:this.options.color.background,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};return this.selected||this.hover?!0===this.chooser?this.selected?(e.borderWidth*=2,e.color=this.options.color.highlight.background,e.borderColor=this.options.color.highlight.border,e.shadow=this.options.shadow.enabled):this.hover&&(e.color=this.options.color.hover.background,e.borderColor=this.options.color.hover.border,e.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(e,this.options.id,this.selected,this.hover),!1===e.shadow&&(e.shadowColor===this.options.shadow.color&&e.shadowSize===this.options.shadow.size&&e.shadowX===this.options.shadow.x&&e.shadowY===this.options.shadow.y||(e.shadow=!0))):e.shadow=this.options.shadow.enabled,e}},{key:"updateLabelModule",value:function(t){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),e.updateGroupOptions(this.options,function(e){for(var t=1;t<arguments.length;t++){var i,o=null!=arguments[t]?arguments[t]:{};if(t%2)ri(i=cd(Object(o),!0)).call(i,(function(t){_a(e,t,o[t])}));else if(Sr)xr(e,Sr(o));else{var n;ri(n=cd(Object(o))).call(n,(function(t){_r(e,t,Pr(o,t))}))}}return e}({},t,{color:t&&t.color||this._localColor||void 0}),this.grouplist);var i=this.grouplist.get(this.options.group,!1),o=[t,this.options,i,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,o),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(e){if(e===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new Ah(this.options,this.body,this.labelModule);break;case"circle":this.shape=new Lh(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new jh(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"database":this.shape=new Hh(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new Vh(this.options,this.body,this.labelModule);break;case"dot":this.shape=new qh(this.options,this.body,this.labelModule);break;case"ellipse":this.shape=new Uh(this.options,this.body,this.labelModule);break;case"icon":this.shape=new Yh(this.options,this.body,this.labelModule);break;case"image":this.shape=new Xh(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new Gh(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new Kh(this.options,this.body,this.labelModule);break;case"star":this.shape=new Zh(this.options,this.body,this.labelModule);break;case"text":this.shape=new $h(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new Jh(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new Qh(this.options,this.body,this.labelModule);break;default:this.shape=new Uh(this.options,this.body,this.labelModule)}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(e,t){return this.shape.distanceToBorder(e,t)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(e,t,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(e,t,i,this.options.value),n=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*s}this.options.size=this.options.scaling.min+o*n}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(e){var t=this.getFormattingValues();this.shape.draw(e,this.x,this.y,this.selected,this.hover,t)}},{key:"updateBoundingBox",value:function(e){this.shape.updateBoundingBox(this.x,this.y,e)}},{key:"resize",value:function(e){var t=this.getFormattingValues();this.shape.resize(e,this.selected,this.hover,t)}},{key:"getItemsOnPoint",value:function(e){var t=[];return this.labelModule.visible()&&th.pointInRect(this.labelModule.getSize(),e)&&t.push({nodeId:this.id,labelId:0}),th.pointInRect(this.shape.boundingBox,e)&&t.push({nodeId:this.id}),t}},{key:"isOverlappingWith",value:function(e){return this.shape.left<e.right&&this.shape.left+this.shape.width>e.left&&this.shape.top<e.bottom&&this.shape.top+this.shape.height>e.top}},{key:"isBoundingBoxOverlappingWith",value:function(e){return this.shape.boundingBox.left<e.right&&this.shape.boundingBox.right>e.left&&this.shape.boundingBox.top<e.bottom&&this.shape.boundingBox.bottom>e.top}}],[{key:"updateGroupOptions",value:function(e,i,o){if(void 0!==o){var n=e.group;if(void 0!==i&&void 0!==i.group&&n!==i.group)throw new Error("updateGroupOptions: group values in options don't match.");if("number"==typeof n||"string"==typeof n&&""!=n){var s=o.get(n),r=["font"];void 0!==i&&void 0!==i.color&&null!=i.color&&r.push("color"),t.selectiveNotDeepExtend(r,e,s),e.color=t.parseColor(e.color)}}}},{key:"parseOptions",value:function(i,o){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],s=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=arguments.length>4?arguments[4]:void 0,a=["color","fixed","shadow"];if(t.selectiveNotDeepExtend(a,i,o,n),e.checkMass(o),t.mergeOptions(i,o,"shadow",s),void 0!==o.color&&null!==o.color){var h=t.parseColor(o.color);t.fillIfDefined(i.color,h)}else!0===n&&null===o.color&&(i.color=t.bridgeObject(s.color));void 0!==o.fixed&&null!==o.fixed&&("boolean"==typeof o.fixed?(i.fixed.x=o.fixed,i.fixed.y=o.fixed):(void 0!==o.fixed.x&&"boolean"==typeof o.fixed.x&&(i.fixed.x=o.fixed.x),void 0!==o.fixed.y&&"boolean"==typeof o.fixed.y&&(i.fixed.y=o.fixed.y))),!0===n&&null===o.font&&(i.font=t.bridgeObject(s.font)),e.updateGroupOptions(i,o,r),void 0!==o.scaling&&t.mergeOptions(i.scaling,o.scaling,"label",s.scaling)}},{key:"checkMass",value:function(e,t){if(void 0!==e.mass&&e.mass<=0){var i="";void 0!==t&&(i=" in node id: "+t),console.log("%cNegative or zero mass disallowed"+i+", setting mass to 1.",dd),e.mass=1}}}]),e}(),pd=function(){function e(i,o,n,s){var r,a=this;if(Ks(this,e),this.body=i,this.images=o,this.groups=n,this.layoutEngine=s,this.body.functions.createNode=ie(r=this.create).call(r,this),this.nodesListeners={add:function(e,t){a.add(t.items)},update:function(e,t){a.update(t.items,t.data,t.oldData)},remove:function(e,t){a.remove(t.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:2,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(e,t,i,o){if(t===e)return.5;var n=1/(t-e);return Math.max(0,(o-e)*n)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=t.bridgeObject(this.defaultOptions),this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e,i,o=this;this.body.emitter.on("refreshNodes",ie(e=this.refresh).call(e,this)),this.body.emitter.on("refresh",ie(i=this.refresh).call(i,this)),this.body.emitter.on("destroy",(function(){t.forEach(o.nodesListeners,(function(e,t){o.body.data.nodes&&o.body.data.nodes.off(t,e)})),delete o.body.functions.createNode,delete o.nodesListeners.add,delete o.nodesListeners.update,delete o.nodesListeners.remove,delete o.nodesListeners}))}},{key:"setOptions",value:function(e){if(void 0!==e){if(ud.parseOptions(this.options,e),void 0!==e.shape)for(var t in this.body.nodes)this.body.nodes.hasOwnProperty(t)&&this.body.nodes[t].updateShape();if(void 0!==e.font||void 0!==e.widthConstraint||void 0!==e.heightConstraint)for(var i=0,o=kr(this.body.nodes);i<o.length;i++){var n=o[i];this.body.nodes[n].updateLabelModule(),this.body.nodes[n].needsRefresh()}if(void 0!==e.size)for(var s in this.body.nodes)this.body.nodes.hasOwnProperty(s)&&this.body.nodes[s].needsRefresh();void 0===e.hidden&&void 0===e.physics||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(e){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.data.nodes;if(e instanceof o.DataSet||e instanceof o.DataView)this.body.data.nodes=e;else if(li(e))this.body.data.nodes=new o.DataSet,this.body.data.nodes.add(e);else{if(e)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new o.DataSet}if(n&&t.forEach(this.nodesListeners,(function(e,t){n.off(t,e)})),this.body.nodes={},this.body.data.nodes){var s=this;t.forEach(this.nodesListeners,(function(e,t){s.body.data.nodes.on(t,e)}));var r=this.body.data.nodes.getIds();this.add(r,!0)}!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(e){for(var t,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=[],n=0;n<e.length;n++){t=e[n];var s=this.body.data.nodes.get(t),r=this.create(s);o.push(r),this.body.nodes[t]=r}this.layoutEngine.positionInitially(o),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(e,t,i){for(var o=this.body.nodes,n=!1,s=0;s<e.length;s++){var r=e[s],a=o[r],h=t[s];void 0!==a?a.setOptions(h)&&(n=!0):(n=!0,a=this.create(h),o[r]=a)}n||void 0===i||(n=br(t).call(t,(function(e,t){var o=i[t];return o&&o.level!==e.level}))),!0===n?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(e){for(var t=this.body.nodes,i=0;i<e.length;i++){delete t[e[i]]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:ud;return new t(e,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var e=this,i=arguments.length>0&&void 0!==arguments[0]&&arguments[0];t.forEach(this.body.nodes,(function(t,o){var n=e.body.data.nodes.get(o);void 0!==n&&(!0===i&&t.setOptions({x:null,y:null}),t.setOptions({fixed:!1}),t.setOptions(n))}))}},{key:"getPositions",value:function(e){var t={};if(void 0!==e){if(!0===li(e)){for(var i=0;i<e.length;i++)if(void 0!==this.body.nodes[e[i]]){var o=this.body.nodes[e[i]];t[e[i]]={x:Math.round(o.x),y:Math.round(o.y)}}}else if(void 0!==this.body.nodes[e]){var n=this.body.nodes[e];t[e]={x:Math.round(n.x),y:Math.round(n.y)}}}else for(var s=0;s<this.body.nodeIndices.length;s++){var r=this.body.nodes[this.body.nodeIndices[s]];t[this.body.nodeIndices[s]]={x:Math.round(r.x),y:Math.round(r.y)}}return t}},{key:"storePositions",value:function(){var e=[],t=this.body.data.nodes.getDataSet(),i=!0,o=!1,n=void 0;try{for(var s,r=pr(t.get());!(i=(s=r.next()).done);i=!0){var a=s.value,h=a.id,d=this.body.nodes[h],l=Math.round(d.x),c=Math.round(d.y);a.x===l&&a.y===c||e.push({id:h,x:l,y:c})}}catch(e){o=!0,n=e}finally{try{i||null==r.return||r.return()}finally{if(o)throw n}}t.update(e)}},{key:"getBoundingBox",value:function(e){if(void 0!==this.body.nodes[e])return this.body.nodes[e].shape.boundingBox}},{key:"getConnectedNodes",value:function(e,t){var i=[];if(void 0!==this.body.nodes[e])for(var o=this.body.nodes[e],n={},s=0;s<o.edges.length;s++){var r=o.edges[s];"to"!==t&&r.toId==o.id?void 0===n[r.fromId]&&(i.push(r.fromId),n[r.fromId]=!0):"from"!==t&&r.fromId==o.id&&void 0===n[r.toId]&&(i.push(r.toId),n[r.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(e){var t=[];if(void 0!==this.body.nodes[e])for(var i=this.body.nodes[e],o=0;o<i.edges.length;o++)t.push(i.edges[o].id);else console.log("NodeId provided for getConnectedEdges does not exist. Provided: ",e);return t}},{key:"moveNode",value:function(e,t,i){var o=this;void 0!==this.body.nodes[e]?(this.body.nodes[e].x=Number(t),this.body.nodes[e].y=Number(i),rr((function(){o.body.emitter.emit("startSimulation")}),0)):console.log("Node id supplied to moveNode does not exist. Provided: ",e)}}]),e}(),fd=Ir;G({target:"Reflect",stat:!0},{get:function e(t,i){var o,n,s=arguments.length<3?t:arguments[2];return W(t)===s?t[i]:(o=I.f(t,i))?O(o,"value")?o.value:void 0===o.get?void 0:o.get.call(s):_(n=je(t))?e(n,i,s):void 0}});var vd=L.Reflect.get;var gd=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=Mh(e)););return e},yd=r((function(e){function t(i,o,n){return"undefined"!=typeof Reflect&&vd?e.exports=t=vd:e.exports=t=function(e,t,i){var o=gd(e,t);if(o){var n=fd(o,t);return n.get?n.get.call(i):n.value}},t(i,o,n||i)}e.exports=t})),md=Math.hypot,bd=Math.abs,wd=Math.sqrt,kd=!!md&&md(1/0,NaN)!==1/0;G({target:"Math",stat:!0,forced:kd},{hypot:function(e,t){for(var i,o,n=0,s=0,r=arguments.length,a=0;s<r;)a<(i=bd(arguments[s++]))?(n=n*(o=a/i)*o+1,a=i):n+=i>0?(o=i/a)*o:i;return a===1/0?1/0:a*wd(n)}});var _d=L.Math.hypot,xd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"transform",value:function(e,t){li(e)||(e=[e]);for(var i=t.point.x,o=t.point.y,n=t.angle,s=t.length,r=0;r<e.length;++r){var a=e[r],h=a.x*Math.cos(n)-a.y*Math.sin(n),d=a.x*Math.sin(n)+a.y*Math.cos(n);a.x=i+s*h,a.y=o+s*d}}},{key:"drawPath",value:function(e,t){e.beginPath(),e.moveTo(t[0].x,t[0].y);for(var i=1;i<t.length;++i)e.lineTo(t[i].x,t[i].y);e.closePath()}}]),e}(),Ed=function(e){function t(){return Ks(this,t),Oh(this,Mh(t).apply(this,arguments))}return Ph(t,e),Qs(t,null,[{key:"draw",value:function(e,t){if(t.image){e.save(),e.translate(t.point.x,t.point.y),e.rotate(Math.PI/2+t.angle);var i=null!=t.imageWidth?t.imageWidth:t.image.width,o=null!=t.imageHeight?t.imageHeight:t.image.height;t.image.drawImageAtPosition(e,1,-i/2,0,i,o),e.restore()}return!1}}]),t}(xd),Od=function(e){function t(){return Ks(this,t),Oh(this,Mh(t).apply(this,arguments))}return Ph(t,e),Qs(t,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),t}(xd),Cd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),Td=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i={x:-.4,y:0};xd.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";var o=Math.PI,n=t.angle-o/2,s=t.angle+o/2;return e.beginPath(),e.arc(i.x,i.y,.4*t.length,n,s,!1),e.stroke(),!0}}]),e}(),Sd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i={x:-.3,y:0};xd.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";var o=Math.PI,n=t.angle+o/2,s=t.angle+3*o/2;return e.beginPath(),e.arc(i.x,i.y,.4*t.length,n,s,!1),e.stroke(),!0}}]),e}(),Md=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),Dd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),Id=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i={x:-.4,y:0};return xd.transform(i,t),oe(e,i.x,i.y,.4*t.length),!0}}]),e}(),Pd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),Fd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),Bd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),zd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return xd.transform(i,t),xd.drawPath(e,i),!0}}]),e}(),Nd=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"draw",value:function(e,t){var i;switch(t.type&&(i=t.type.toLowerCase()),i){case"image":return Ed.draw(e,t);case"circle":return Id.draw(e,t);case"box":return Fd.draw(e,t);case"crow":return Cd.draw(e,t);case"curve":return Td.draw(e,t);case"diamond":return Bd.draw(e,t);case"inv_curve":return Sd.draw(e,t);case"triangle":return Md.draw(e,t);case"inv_triangle":return Dd.draw(e,t);case"bar":return Pd.draw(e,t);case"vee":return zd.draw(e,t);case"arrow":default:return Od.draw(e,t)}}}]),e}();function Ad(e,t){var i=kr(e);if(ka){var o=ka(e);t&&(o=Rr(o).call(o,(function(t){return Pr(e,t).enumerable}))),i.push.apply(i,o)}return i}var Rd=function(){function e(t,i,o){Ks(this,e),this._body=i,this._labelModule=o,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(t),this.fromPoint=this.from,this.toPoint=this.to}return Qs(e,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(e){this.options=e,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(e,t,i,o){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.getViaNode();e.strokeStyle=this.getColor(e,t),e.lineWidth=t.width,!1!==t.dashes?this._drawDashedLine(e,t,n):this._drawLine(e,t,n)}},{key:"_drawLine",value:function(e,t,i,o,n){if(this.from!=this.to)this._line(e,t,i,o,n);else{var s=this._getCircleData(e),r=qa(s,3),a=r[0],h=r[1],d=r[2];this._circle(e,t,a,h,d)}}},{key:"_drawDashedLine",value:function(e,t,i,o,n){e.lineCap="round";var s=li(t.dashes)?t.dashes:[5,5];if(void 0!==e.setLineDash){if(e.save(),e.setLineDash(s),e.lineDashOffset=0,this.from!=this.to)this._line(e,t,i);else{var r=this._getCircleData(e),a=qa(r,3),h=a[0],d=a[1],l=a[2];this._circle(e,t,h,d,l)}e.setLineDash([0]),e.lineDashOffset=0,e.restore()}else{if(this.from!=this.to)ae(e,this.from.x,this.from.y,this.to.x,this.to.y,s);else{var c=this._getCircleData(e),u=qa(c,3),p=u[0],f=u[1],v=u[2];this._circle(e,t,p,f,v)}this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}}},{key:"findBorderPosition",value:function(e,t,i){return this.from!=this.to?this._findBorderPosition(e,t,i):this._findBorderPositionCircle(e,t,i)}},{key:"findBorderPositions",value:function(e){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,e),to:this._findBorderPosition(this.to,e)};var t,i=dh(t=this._getCircleData(e)).call(t,0,2),o=qa(i,2),n=o[0],s=o[1];return{from:this._findBorderPositionCircle(this.from,e,{x:n,y:s,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,e,{x:n,y:s,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(e){var t=this.options.selfReference.size;void 0!==e&&void 0===this.from.shape.width&&this.from.shape.resize(e);var i=th.getSelfRefCoordinates(e,this.options.selfReference.angle,t,this.from);return[i.x,i.y,t]}},{key:"_pointOnCircle",value:function(e,t,i,o){var n=2*o*Math.PI;return{x:e+i*Math.cos(n),y:t-i*Math.sin(n)}}},{key:"_findBorderPositionCircle",value:function(e,t,i){var o,n=i.x,s=i.y,r=i.low,a=i.high,h=i.direction,d=this.options.selfReference.size,l=.5*(r+a),c=0;do{l=.5*(r+a),o=this._pointOnCircle(n,s,d,l);var u=Math.atan2(e.y-o.y,e.x-o.x),p=e.distanceToBorder(t,u)-Math.sqrt(Math.pow(o.x-e.x,2)+Math.pow(o.y-e.y,2));if(Math.abs(p)<.05)break;p>0?h>0?r=l:a=l:h>0?a=l:r=l,++c}while(r<=a&&c<10);return function(e){for(var t=1;t<arguments.length;t++){var i,o=null!=arguments[t]?arguments[t]:{};if(t%2)ri(i=Ad(Object(o),!0)).call(i,(function(t){_a(e,t,o[t])}));else if(Sr)xr(e,Sr(o));else{var n;ri(n=Ad(Object(o))).call(n,(function(t){_r(e,t,Pr(o,t))}))}}return e}({},o,{t:l})}},{key:"getLineWidth",value:function(e,t){return!0===e?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===t?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(e,i){if(!1!==i.inheritsColor){if("both"===i.inheritsColor&&this.from.id!==this.to.id){var o=e.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),n=this.from.options.color.highlight.border,s=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(n=t.overrideOpacity(this.from.options.color.border,i.opacity),s=t.overrideOpacity(this.to.options.color.border,i.opacity)):!0===this.from.selected&&!1===this.to.selected?s=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(n=this.from.options.color.border),o.addColorStop(0,n),o.addColorStop(1,s),o}return"to"===i.inheritsColor?t.overrideOpacity(this.to.options.color.border,i.opacity):t.overrideOpacity(this.from.options.color.border,i.opacity)}return t.overrideOpacity(i.color,i.opacity)}},{key:"_circle",value:function(e,t,i,o,n){this.enableShadow(e,t);var s=0,r=2*Math.PI;if(!this.options.selfReference.renderBehindTheNode){var a=this.options.selfReference.angle,h=this.options.selfReference.angle+Math.PI,d=this._findBorderPositionCircle(this.from,e,{x:i,y:o,low:a,high:h,direction:-1}),l=this._findBorderPositionCircle(this.from,e,{x:i,y:o,low:a,high:h,direction:1});s=Math.atan2(d.y-o,d.x-i),r=Math.atan2(l.y-o,l.x-i)}e.beginPath(),e.arc(i,o,n,s,r,!1),e.stroke(),this.disableShadow(e,t)}},{key:"getDistanceToEdge",value:function(e,t,i,o,n,s){if(this.from!=this.to)return this._getDistanceToEdge(e,t,i,o,n,s);var r=this._getCircleData(void 0),a=qa(r,3),h=a[0],d=a[1],l=a[2],c=h-n,u=d-s;return Math.abs(Math.sqrt(c*c+u*u)-l)}},{key:"_getDistanceToLine",value:function(e,t,i,o,n,s){var r=i-e,a=o-t,h=((n-e)*r+(s-t)*a)/(r*r+a*a);h>1?h=1:h<0&&(h=0);var d=e+h*r-n,l=t+h*a-s;return Math.sqrt(d*d+l*l)}},{key:"getArrowData",value:function(e,t,i,o,n,s){var r,a,h,d,l,c,u,p=s.width;"from"===t?(h=this.from,d=this.to,l=s.fromArrowScale<0,c=Math.abs(s.fromArrowScale),u=s.fromArrowType):"to"===t?(h=this.to,d=this.from,l=s.toArrowScale<0,c=Math.abs(s.toArrowScale),u=s.toArrowType):(h=this.to,d=this.from,l=s.middleArrowScale<0,c=Math.abs(s.middleArrowScale),u=s.middleArrowType);var f=15*c+3*p;if(h!=d){var v=f/_d(h.x-d.x,h.y-d.y);if("middle"!==t)if(!0===this.options.smooth.enabled){var g=this._findBorderPosition(h,e,{via:i}),y=this.getPoint(g.t+v*("from"===t?1:-1),i);r=Math.atan2(g.y-y.y,g.x-y.x),a=g}else r=Math.atan2(h.y-d.y,h.x-d.x),a=this._findBorderPosition(h,e);else{var m=(l?-v:v)/2,b=this.getPoint(.5+m,i),w=this.getPoint(.5-m,i);r=Math.atan2(b.y-w.y,b.x-w.x),a=this.getPoint(.5,i)}}else{var k=this._getCircleData(e),_=qa(k,3),x=_[0],E=_[1],O=_[2];if("from"===t){var C=this.options.selfReference.angle,T=this.options.selfReference.angle+Math.PI,S=this._findBorderPositionCircle(this.from,e,{x:x,y:E,low:C,high:T,direction:-1});r=-2*S.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=S}else if("to"===t){var M=this.options.selfReference.angle,D=this.options.selfReference.angle+Math.PI,I=this._findBorderPositionCircle(this.from,e,{x:x,y:E,low:M,high:D,direction:1});r=-2*I.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=I}else{var P=this.options.selfReference.angle/(2*Math.PI);a=this._pointOnCircle(x,E,O,P),r=-2*P*Math.PI+1.5*Math.PI+.1*Math.PI}}return{point:a,core:{x:a.x-.9*f*Math.cos(r),y:a.y-.9*f*Math.sin(r)},angle:r,length:f,type:u}}},{key:"drawArrowHead",value:function(e,t,i,o,n){e.strokeStyle=this.getColor(e,t),e.fillStyle=e.strokeStyle,e.lineWidth=t.width,Nd.draw(e,n)&&(this.enableShadow(e,t),zh(e).call(e),this.disableShadow(e,t))}},{key:"enableShadow",value:function(e,t){!0===t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}},{key:"disableShadow",value:function(e,t){!0===t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}},{key:"drawBackground",value:function(e,t){if(!1!==t.background){var i={strokeStyle:e.strokeStyle,lineWidth:e.lineWidth,dashes:e.dashes};e.strokeStyle=t.backgroundColor,e.lineWidth=t.backgroundSize,this.setStrokeDashed(e,t.backgroundDashes),e.stroke(),e.strokeStyle=i.strokeStyle,e.lineWidth=i.lineWidth,e.dashes=i.dashes,this.setStrokeDashed(e,t.dashes)}}},{key:"setStrokeDashed",value:function(e,t){if(!1!==t)if(void 0!==e.setLineDash){var i=li(t)?t:[5,5];e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==e.setLineDash?e.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),e}();function Ld(e,t){var i=kr(e);if(ka){var o=ka(e);t&&(o=Rr(o).call(o,(function(t){return Pr(e,t).enumerable}))),i.push.apply(i,o)}return i}function jd(e){for(var t=1;t<arguments.length;t++){var i,o=null!=arguments[t]?arguments[t]:{};if(t%2)ri(i=Ld(Object(o),!0)).call(i,(function(t){_a(e,t,o[t])}));else if(Sr)xr(e,Sr(o));else{var n;ri(n=Ld(Object(o))).call(n,(function(t){_r(e,t,Pr(o,t))}))}}return e}var Hd=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"_findBorderPositionBezier",value:function(e,t){var i,o,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this._getViaCoordinates(),s=10,r=.2,a=!1,h=1,d=0,l=this.to;e.id===this.from.id&&(l=this.from,a=!0);var c=0;do{o=.5*(d+h),i=this.getPoint(o,n);var u=Math.atan2(l.y-i.y,l.x-i.x),p=l.distanceToBorder(t,u),f=Math.sqrt(Math.pow(i.x-l.x,2)+Math.pow(i.y-l.y,2)),v=p-f;if(Math.abs(v)<r)break;v<0?!1===a?d=o:h=o:!1===a?h=o:d=o,++c}while(d<=h&&c<s);return jd({},i,{t:o})}},{key:"_getDistanceToBezierEdge",value:function(e,t,i,o,n,s,r){var a,h,d,l,c,u=1e9,p=e,f=t;for(h=1;h<10;h++)d=.1*h,l=Math.pow(1-d,2)*e+2*d*(1-d)*r.x+Math.pow(d,2)*i,c=Math.pow(1-d,2)*t+2*d*(1-d)*r.y+Math.pow(d,2)*o,h>0&&(u=(a=this._getDistanceToLine(p,f,l,c,n,s))<u?a:u),p=l,f=c;return u}},{key:"_bezierCurve",value:function(e,t,i,o){e.beginPath(),e.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=o&&null!=o.x?e.bezierCurveTo(i.x,i.y,o.x,o.y,this.toPoint.x,this.toPoint.y):e.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):e.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(e,t),this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),t}(Rd),Wd=function(e){function t(e,i,o){var n;return Ks(this,t),(n=Oh(this,Mh(t).call(this,e,i,o))).via=n.via,n._boundFunction=function(){n.positionBezierNode()},n._body.emitter.on("_repositionBezierNodes",n._boundFunction),n}return Ph(t,e),Qs(t,[{key:"setOptions",value:function(e){yd(Mh(t.prototype),"setOptions",this).call(this,e);var i=!1;this.options.physics!==e.physics&&(i=!0),this.options=e,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===i&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics?this.via.setOptions({physics:!1}):this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}},{key:"setupSupportNode",value:function(){if(void 0===this.via){var e="edgeId:"+this.id,t=this._body.functions.createNode({id:e,shape:"circle",physics:!0,hidden:!0});this._body.nodes[e]=t,this.via=t,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(e,t,i){this._bezierCurve(e,t,i)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.via;if(this.from===this.to){var i=this._getCircleData(),o=qa(i,3),n=o[0],s=o[1],r=o[2],a=2*Math.PI*(1-e);return{x:n+r*Math.sin(a),y:s+r-r*(1-Math.cos(a))}}return{x:Math.pow(1-e,2)*this.fromPoint.x+2*e*(1-e)*t.x+Math.pow(e,2)*this.toPoint.x,y:Math.pow(1-e,2)*this.fromPoint.y+2*e*(1-e)*t.y+Math.pow(e,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(e,t){return this._findBorderPositionBezier(e,t,this.via)}},{key:"_getDistanceToEdge",value:function(e,t,i,o,n,s){return this._getDistanceToBezierEdge(e,t,i,o,n,s,this.via)}}]),t}(Hd),Vd=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"_line",value:function(e,t,i){this._bezierCurve(e,t,i)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var e,t,i=this.options.smooth.roundness,o=this.options.smooth.type,n=Math.abs(this.from.x-this.to.x),s=Math.abs(this.from.y-this.to.y);if("discrete"===o||"diagonalCross"===o){var r,a;r=a=n<=s?i*s:i*n,this.from.x>this.to.x&&(r=-r),this.from.y>=this.to.y&&(a=-a);var h=this.from.x+r,d=this.from.y+a;return"discrete"===o&&(n<=s?h=n<i*s?this.from.x:h:d=s<i*n?this.from.y:d),{x:h,y:d}}if("straightCross"===o){var l=(1-i)*n,c=(1-i)*s;return n<=s?(l=0,this.from.y<this.to.y&&(c=-c)):(this.from.x<this.to.x&&(l=-l),c=0),{x:this.to.x+l,y:this.to.y+c}}if("horizontal"===o){var u=(1-i)*n;return this.from.x<this.to.x&&(u=-u),{x:this.to.x+u,y:this.from.y}}if("vertical"===o){var p=(1-i)*s;return this.from.y<this.to.y&&(p=-p),{x:this.from.x,y:this.to.y+p}}if("curvedCW"===o){n=this.to.x-this.from.x,s=this.from.y-this.to.y;var f=Math.sqrt(n*n+s*s),v=Math.PI,g=(Math.atan2(s,n)+(.5*i+.5)*v)%(2*v);return{x:this.from.x+(.5*i+.5)*f*Math.sin(g),y:this.from.y+(.5*i+.5)*f*Math.cos(g)}}if("curvedCCW"===o){n=this.to.x-this.from.x,s=this.from.y-this.to.y;var y=Math.sqrt(n*n+s*s),m=Math.PI,b=(Math.atan2(s,n)+(.5*-i+.5)*m)%(2*m);return{x:this.from.x+(.5*i+.5)*y*Math.sin(b),y:this.from.y+(.5*i+.5)*y*Math.cos(b)}}e=t=n<=s?i*s:i*n,this.from.x>this.to.x&&(e=-e),this.from.y>=this.to.y&&(t=-t);var w=this.from.x+e,k=this.from.y+t;return n<=s?w=this.from.x<=this.to.x?this.to.x<w?this.to.x:w:this.to.x>w?this.to.x:w:k=this.from.y>=this.to.y?this.to.y>k?this.to.y:k:this.to.y<k?this.to.y:k,{x:w,y:k}}},{key:"_findBorderPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this._findBorderPositionBezier(e,t,i.via)}},{key:"_getDistanceToEdge",value:function(e,t,i,o,n,s){var r=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(e,t,i,o,n,s,r)}},{key:"getPoint",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=e,o=Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*t.x+Math.pow(i,2)*this.toPoint.x,n=Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*t.y+Math.pow(i,2)*this.toPoint.y;return{x:o,y:n}}}]),t}(Hd),qd=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"_line",value:function(e,t,i){var o=i[0],n=i[1];this._bezierCurve(e,t,o,n)}},{key:"_getViaCoordinates",value:function(){var e,t,i,o,n=this.from.x-this.to.x,s=this.from.y-this.to.y,r=this.options.smooth.roundness;return(Math.abs(n)>Math.abs(s)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(t=this.from.y,o=this.to.y,e=this.from.x-r*n,i=this.to.x+r*n):(t=this.from.y-r*s,o=this.to.y+r*s,e=this.from.x,i=this.to.x),[{x:e,y:t},{x:i,y:o}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(e,t){return this._findBorderPositionBezier(e,t)}},{key:"_getDistanceToEdge",value:function(e,t,i,o,n,s){var r=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates(),a=qa(r,2),h=a[0],d=a[1];return this._getDistanceToBezierEdge2(e,t,i,o,n,s,h,d)}},{key:"getPoint",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=qa(t,2),o=i[0],n=i[1],s=e,r=[Math.pow(1-s,3),3*s*Math.pow(1-s,2),3*Math.pow(s,2)*(1-s),Math.pow(s,3)],a=r[0]*this.fromPoint.x+r[1]*o.x+r[2]*n.x+r[3]*this.toPoint.x,h=r[0]*this.fromPoint.y+r[1]*o.y+r[2]*n.y+r[3]*this.toPoint.y;return{x:a,y:h}}}]),t}(function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"_getDistanceToBezierEdge2",value:function(e,t,i,o,n,s,r,a){for(var h=1e9,d=e,l=t,c=[0,0,0,0],u=1;u<10;u++){var p=.1*u;c[0]=Math.pow(1-p,3),c[1]=3*p*Math.pow(1-p,2),c[2]=3*Math.pow(p,2)*(1-p),c[3]=Math.pow(p,3);var f=c[0]*e+c[1]*r.x+c[2]*a.x+c[3]*i,v=c[0]*t+c[1]*r.y+c[2]*a.y+c[3]*o;if(u>0){var g=this._getDistanceToLine(d,l,f,v,n,s);h=g<h?g:h}d=f,l=v}return h}}]),t}(Hd)),Ud=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"_line",value:function(e,t){e.beginPath(),e.moveTo(this.fromPoint.x,this.fromPoint.y),e.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(e){return{x:(1-e)*this.fromPoint.x+e*this.toPoint.x,y:(1-e)*this.fromPoint.y+e*this.toPoint.y}}},{key:"_findBorderPosition",value:function(e,t){var i=this.to,o=this.from;e.id===this.from.id&&(i=this.from,o=this.to);var n=Math.atan2(i.y-o.y,i.x-o.x),s=i.x-o.x,r=i.y-o.y,a=Math.sqrt(s*s+r*r),h=(a-e.distanceToBorder(t,n))/a;return{x:(1-h)*o.x+h*i.x,y:(1-h)*o.y+h*i.y,t:0}}},{key:"_getDistanceToEdge",value:function(e,t,i,o,n,s){return this._getDistanceToLine(e,t,i,o,n,s)}}]),t}(Rd),Yd=function(){function e(i,o,n,s,r){if(Ks(this,e),void 0===o)throw new Error("No body provided");this.options=t.bridgeObject(s),this.globalOptions=s,this.defaultOptions=r,this.body=o,this.imagelist=n,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new xh(this.body,this.options,!0),this.setOptions(i)}return Qs(e,[{key:"setOptions",value:function(t){if(t){var i=void 0!==t.physics&&this.options.physics!==t.physics||void 0!==t.hidden&&(this.options.hidden||!1)!==(t.hidden||!1)||void 0!==t.from&&this.options.from!==t.from||void 0!==t.to&&this.options.to!==t.to;e.parseOptions(this.options,t,!0,this.globalOptions),void 0!==t.id&&(this.id=t.id),void 0!==t.from&&(this.fromId=t.from),void 0!==t.to&&(this.toId=t.to),void 0!==t.title&&(this.title=t.title),void 0!==t.value&&(t.value=Pa(t.value));var o=[t,this.options,this.defaultOptions];return this.chooser=th.choosify("edge",o),this.updateLabelModule(t),i=this.updateEdgeType()||i,this._setInteractionWidths(),this.connect(),i}}},{key:"getFormattingValues",value:function(){var e=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,t=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,o=this.options.color.inherit,n={toArrow:e,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:t,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:o?void 0:this.options.color.color,inheritsColor:o,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){var s=this.options.selectionWidth;"function"==typeof s?n.width=s(n.width):"number"==typeof s&&(n.width+=s),n.width=Math.max(n.width,.3/this.body.view.scale),n.color=this.options.color.highlight,n.shadow=this.options.shadow.enabled}else if(this.hover){var r=this.options.hoverWidth;"function"==typeof r?n.width=r(n.width):"number"==typeof r&&(n.width+=r),n.width=Math.max(n.width,.3/this.body.view.scale),n.color=this.options.color.hover,n.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(n,this.options.id,this.selected,this.hover),void 0!==n.color&&(n.inheritsColor=!1),!1===n.shadow&&(n.shadowColor===this.options.shadow.color&&n.shadowSize===this.options.shadow.size&&n.shadowX===this.options.shadow.x&&n.shadowY===this.options.shadow.y||(n.shadow=!0)));else n.shadow=this.options.shadow.enabled,n.width=Math.max(n.width,.3/this.body.view.scale);return n}},{key:"updateLabelModule",value:function(e){var t=[e,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,t),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var e=this.options.smooth,t=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof Wd&&!0===e.enabled&&"dynamic"===e.type||this.edgeType instanceof qd&&!0===e.enabled&&"cubicBezier"===e.type||this.edgeType instanceof Vd&&!0===e.enabled&&"dynamic"!==e.type&&"cubicBezier"!==e.type||this.edgeType instanceof Ud&&!1===e.type.enabled)&&(i=!1),!0===i&&(t=this.cleanup())),!0===i?!0===e.enabled?"dynamic"===e.type?(t=!0,this.edgeType=new Wd(this.options,this.body,this.labelModule)):"cubicBezier"===e.type?this.edgeType=new qd(this.options,this.body,this.labelModule):this.edgeType=new Vd(this.options,this.body,this.labelModule):this.edgeType=new Ud(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),t}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(e,t,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(e,t,i,this.options.value),n=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*s}this.options.width=this.options.scaling.min+o*n}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(e){var t=this.getFormattingValues();if(!t.hidden){var i=this.edgeType.getViaNode(),o={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,t.fromArrow&&(o.from=this.edgeType.getArrowData(e,"from",i,this.selected,this.hover,t),!1===t.arrowStrikethrough&&(this.edgeType.fromPoint=o.from.core),t.fromArrowSrc&&(o.from.image=this.imagelist.load(t.fromArrowSrc)),t.fromArrowImageWidth&&(o.from.imageWidth=t.fromArrowImageWidth),t.fromArrowImageHeight&&(o.from.imageHeight=t.fromArrowImageHeight)),t.toArrow&&(o.to=this.edgeType.getArrowData(e,"to",i,this.selected,this.hover,t),!1===t.arrowStrikethrough&&(this.edgeType.toPoint=o.to.core),t.toArrowSrc&&(o.to.image=this.imagelist.load(t.toArrowSrc)),t.toArrowImageWidth&&(o.to.imageWidth=t.toArrowImageWidth),t.toArrowImageHeight&&(o.to.imageHeight=t.toArrowImageHeight)),t.middleArrow&&(o.middle=this.edgeType.getArrowData(e,"middle",i,this.selected,this.hover,t),t.middleArrowSrc&&(o.middle.image=this.imagelist.load(t.middleArrowSrc)),t.middleArrowImageWidth&&(o.middle.imageWidth=t.middleArrowImageWidth),t.middleArrowImageHeight&&(o.middle.imageHeight=t.middleArrowImageHeight)),this.edgeType.drawLine(e,t,this.selected,this.hover,i),this.drawArrows(e,o,t),this.drawLabel(e,i)}}},{key:"drawArrows",value:function(e,t,i){i.fromArrow&&this.edgeType.drawArrowHead(e,i,this.selected,this.hover,t.from),i.middleArrow&&this.edgeType.drawArrowHead(e,i,this.selected,this.hover,t.middle),i.toArrow&&this.edgeType.drawArrowHead(e,i,this.selected,this.hover,t.to)}},{key:"drawLabel",value:function(e,t){if(void 0!==this.options.label){var i=this.from,o=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(e,this.selected,this.hover),i.id!=o.id){this.labelModule.pointToSelf=!1;var n=this.edgeType.getPoint(.5,t);e.save();var s=this._getRotation(e);0!=s.angle&&(e.translate(s.x,s.y),e.rotate(s.angle)),this.labelModule.draw(e,n.x,n.y,this.selected,this.hover),e.restore()}else{this.labelModule.pointToSelf=!0;var r=th.getSelfRefCoordinates(e,this.options.selfReference.angle,this.options.selfReference.size,i);n=this._pointOnCircle(r.x,r.y,this.options.selfReference.size,this.options.selfReference.angle),this.labelModule.draw(e,n.x,n.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(e){var t=[];if(this.labelModule.visible()){var i=this._getRotation();th.pointInRect(this.labelModule.getSize(),e,i)&&t.push({edgeId:this.id,labelId:0})}var o={left:e.x,top:e.y};return this.isOverlappingWith(o)&&t.push({edgeId:this.id}),t}},{key:"isOverlappingWith",value:function(e){if(this.connected){var t=this.from.x,i=this.from.y,o=this.to.x,n=this.to.y,s=e.left,r=e.top;return this.edgeType.getDistanceToEdge(t,i,o,n,s,r)<10}return!1}},{key:"_getRotation",value:function(e){var t=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,t);void 0!==e&&this.labelModule.calculateLabelSize(e,this.selected,this.hover,i.x,i.y);var o={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return o;if("horizontal"===this.options.font.align)return o;var n=this.from.y-this.to.y,s=this.from.x-this.to.x,r=Math.atan2(n,s);return(r<-1&&s<0||r>0&&s<0)&&(r+=Math.PI),o.angle=r,o}},{key:"_pointOnCircle",value:function(e,t,i,o){return{x:e+i*Math.cos(o),y:t-i*Math.sin(o)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}],[{key:"parseOptions",value:function(e,i){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},s=arguments.length>4&&void 0!==arguments[4]&&arguments[4],r=["arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","selfReference","to","title","value","width","font","chosen","widthConstraint"];if(t.selectiveDeepExtend(r,e,i,o),th.isValidLabel(i.label)?e.label=i.label:th.isValidLabel(e.label)||(e.label=void 0),t.mergeOptions(e,i,"smooth",n),t.mergeOptions(e,i,"shadow",n),t.mergeOptions(e,i,"background",n),void 0!==i.dashes&&null!==i.dashes?e.dashes=i.dashes:!0===o&&null===i.dashes&&(e.dashes=Yi(n.dashes)),void 0!==i.scaling&&null!==i.scaling?(void 0!==i.scaling.min&&(e.scaling.min=i.scaling.min),void 0!==i.scaling.max&&(e.scaling.max=i.scaling.max),t.mergeOptions(e.scaling,i.scaling,"label",n.scaling)):!0===o&&null===i.scaling&&(e.scaling=Yi(n.scaling)),void 0!==i.arrows&&null!==i.arrows)if("string"==typeof i.arrows){var a=i.arrows.toLowerCase();e.arrows.to.enabled=-1!=Vi(a).call(a,"to"),e.arrows.middle.enabled=-1!=Vi(a).call(a,"middle"),e.arrows.from.enabled=-1!=Vi(a).call(a,"from")}else{if("object"!==eh(i.arrows))throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+ad(i.arrows));t.mergeOptions(e.arrows,i.arrows,"to",n.arrows),t.mergeOptions(e.arrows,i.arrows,"middle",n.arrows),t.mergeOptions(e.arrows,i.arrows,"from",n.arrows)}else!0===o&&null===i.arrows&&(e.arrows=Yi(n.arrows));if(void 0!==i.color&&null!==i.color){var h=t.isString(i.color)?{color:i.color,highlight:i.color,hover:i.color,inherit:!1,opacity:1}:i.color,d=e.color;if(s)t.deepExtend(d,n.color,!1,o);else for(var l in d)d.hasOwnProperty(l)&&delete d[l];if(t.isString(d))d.color=d,d.highlight=d,d.hover=d,d.inherit=!1,void 0===h.opacity&&(d.opacity=1);else{var c=!1;void 0!==h.color&&(d.color=h.color,c=!0),void 0!==h.highlight&&(d.highlight=h.highlight,c=!0),void 0!==h.hover&&(d.hover=h.hover,c=!0),void 0!==h.inherit&&(d.inherit=h.inherit),void 0!==h.opacity&&(d.opacity=Math.min(1,Math.max(0,h.opacity))),!0===c?d.inherit=!1:void 0===d.inherit&&(d.inherit="from")}}else!0===o&&null===i.color&&(e.color=t.bridgeObject(n.color));!0===o&&null===i.font&&(e.font=t.bridgeObject(n.font)),i.hasOwnProperty("selfReferenceSize")&&(console.log("The selfReferenceSize property has been deprecated. Please use selfReference property instead. The selfReference can be set like thise selfReference:{size:30, angle:Math.PI / 4}"),e.selfReference.size=i.selfReferenceSize)}}]),e}(),Xd=function(){function e(i,o,n){var s,r=this;Ks(this,e),this.body=i,this.images=o,this.groups=n,this.body.functions.createEdge=ie(s=this.create).call(s,this),this.edgesListeners={add:function(e,t){r.add(t.items)},update:function(e,t){r.update(t.items)},remove:function(e,t){r.remove(t.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(e,t,i,o){if(t===e)return.5;var n=1/(t-e);return Math.max(0,(o-e)*n)}},selectionWidth:1.5,selfReference:{size:20,angle:Math.PI/4,renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},t.deepExtend(this.options,this.defaultOptions),this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e,i,o=this;this.body.emitter.on("_forceDisableDynamicCurves",(function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];"dynamic"===e&&(e="continuous");var i=!1;for(var n in o.body.edges)if(o.body.edges.hasOwnProperty(n)){var s=o.body.edges[n],r=o.body.data.edges.get(n);if(null!=r){var a=r.smooth;void 0!==a&&!0===a.enabled&&"dynamic"===a.type&&(void 0===e?s.setOptions({smooth:!1}):s.setOptions({smooth:{type:e}}),i=!0)}}!0===t&&!0===i&&o.body.emitter.emit("_dataChanged")})),this.body.emitter.on("_dataUpdated",(function(){o.reconnectEdges()})),this.body.emitter.on("refreshEdges",ie(e=this.refresh).call(e,this)),this.body.emitter.on("refresh",ie(i=this.refresh).call(i,this)),this.body.emitter.on("destroy",(function(){t.forEach(o.edgesListeners,(function(e,t){o.body.data.edges&&o.body.data.edges.off(t,e)})),delete o.body.functions.createEdge,delete o.edgesListeners.add,delete o.edgesListeners.update,delete o.edgesListeners.remove,delete o.edgesListeners}))}},{key:"setOptions",value:function(e){if(void 0!==e){Yd.parseOptions(this.options,e,!0,this.defaultOptions,!0);var t=!1;if(void 0!==e.smooth)for(var i in this.body.edges)this.body.edges.hasOwnProperty(i)&&(t=this.body.edges[i].updateEdgeType()||t);if(void 0!==e.font)for(var o in this.body.edges)this.body.edges.hasOwnProperty(o)&&this.body.edges[o].updateLabelModule();void 0===e.hidden&&void 0===e.physics&&!0!==t||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(e){var i=this,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],s=this.body.data.edges;if(e instanceof o.DataSet||e instanceof o.DataView)this.body.data.edges=e;else if(li(e))this.body.data.edges=new o.DataSet,this.body.data.edges.add(e);else{if(e)throw new TypeError("Array or DataSet expected");this.body.data.edges=new o.DataSet}if(s&&t.forEach(this.edgesListeners,(function(e,t){s.off(t,e)})),this.body.edges={},this.body.data.edges){t.forEach(this.edgesListeners,(function(e,t){i.body.data.edges.on(t,e)}));var r=this.body.data.edges.getIds();this.add(r,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===n&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(e){for(var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.edges,o=this.body.data.edges,n=0;n<e.length;n++){var s=e[n],r=i[s];r&&r.disconnect();var a=o.get(s,{showInternalIds:!0});i[s]=this.create(a)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===t&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(e){for(var t=this.body.edges,i=this.body.data.edges,o=!1,n=0;n<e.length;n++){var s=e[n],r=i.get(s),a=t[s];void 0!==a?(a.disconnect(),o=a.setOptions(r)||o,a.connect()):(this.body.edges[s]=this.create(r),o=!0)}!0===o?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(e){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(0!==e.length){var o=this.body.edges;t.forEach(e,(function(e){var t=o[e];void 0!==t&&t.remove()})),i&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var e=this;t.forEach(this.body.edges,(function(t,i){var o=e.body.data.edges.get(i);void 0!==o&&t.setOptions(o)}))}},{key:"create",value:function(e){return new Yd(e,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var e,t=this.body.nodes,i=this.body.edges;for(e in t)t.hasOwnProperty(e)&&(t[e].edges=[]);for(e in i)if(i.hasOwnProperty(e)){var o=i[e];o.from=null,o.to=null,o.connect()}}},{key:"getConnectedNodes",value:function(e){var t=[];if(void 0!==this.body.edges[e]){var i=this.body.edges[e];void 0!==i.fromId&&t.push(i.fromId),void 0!==i.toId&&t.push(i.toId)}return t}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var e=this,i=[];t.forEach(this.body.edges,(function(t,o){var n=e.body.nodes[t.toId],s=e.body.nodes[t.fromId];void 0!==n&&!0===n.isCluster||void 0!==s&&!0===s.isCluster||void 0!==n&&void 0!==s||i.push(o)})),this.remove(i,!1)}},{key:"_addMissingEdges",value:function(){var e=this.body.data.edges;if(null!=e){var t=this.body.edges,i=[];ri(e).call(e,(function(e,o){void 0===t[o]&&i.push(o)})),this.add(i,!0)}}}]),e}();G({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var Gd=L.Date.now;G({target:"Number",stat:!0},{isNaN:function(e){return e!=e}});var Kd=L.Number.isNaN,Zd=function(){function e(i,o,n){Ks(this,e),this.body=i,this.physicsBody=o,this.barnesHutTree,this.setOptions(n),this._rng=t.Alea("BARNES HUT SOLVER")}return Qs(e,[{key:"setOptions",value:function(e){this.options=e,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"solve",value:function(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){var e,t=this.body.nodes,i=this.physicsBody.physicsNodeIndices,o=i.length,n=this._formBarnesHutTree(t,i);this.barnesHutTree=n;for(var s=0;s<o;s++)(e=t[i[s]]).options.mass>0&&this._getForceContributions(n.root,e)}}},{key:"_getForceContributions",value:function(e,t){this._getForceContribution(e.children.NW,t),this._getForceContribution(e.children.NE,t),this._getForceContribution(e.children.SW,t),this._getForceContribution(e.children.SE,t)}},{key:"_getForceContribution",value:function(e,t){var i,o,n;e.childrenCount>0&&(i=e.centerOfMass.x-t.x,o=e.centerOfMass.y-t.y,(n=Math.sqrt(i*i+o*o))*e.calcSize>this.thetaInversed?this._calculateForces(n,i,o,t,e):4===e.childrenCount?this._getForceContributions(e,t):e.children.data.id!=t.id&&this._calculateForces(n,i,o,t,e))}},{key:"_calculateForces",value:function(e,t,i,o,n){0===e&&(t=e=.1),this.overlapAvoidanceFactor<1&&o.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,e-o.shape.radius));var s=this.options.gravitationalConstant*n.mass*o.options.mass/Math.pow(e,3),r=t*s,a=i*s;this.physicsBody.forces[o.id].x+=r,this.physicsBody.forces[o.id].y+=a}},{key:"_formBarnesHutTree",value:function(e,t){for(var i,o=t.length,n=e[t[0]].x,s=e[t[0]].y,r=e[t[0]].x,a=e[t[0]].y,h=1;h<o;h++){var d=e[t[h]],l=d.x,c=d.y;d.options.mass>0&&(l<n&&(n=l),l>r&&(r=l),c<s&&(s=c),c>a&&(a=c))}var u=Math.abs(r-n)-Math.abs(a-s);u>0?(s-=.5*u,a+=.5*u):(n+=.5*u,r-=.5*u);var p=Math.max(1e-5,Math.abs(r-n)),f=.5*p,v=.5*(n+r),g=.5*(s+a),y={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:v-f,maxX:v+f,minY:g-f,maxY:g+f},size:p,calcSize:1/p,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(y.root);for(var m=0;m<o;m++)(i=e[t[m]]).options.mass>0&&this._placeInTree(y.root,i);return y}},{key:"_updateBranchMass",value:function(e,t){var i=e.centerOfMass,o=e.mass+t.options.mass,n=1/o;i.x=i.x*e.mass+t.x*t.options.mass,i.x*=n,i.y=i.y*e.mass+t.y*t.options.mass,i.y*=n,e.mass=o;var s=Math.max(Math.max(t.height,t.radius),t.width);e.maxWidth=e.maxWidth<s?s:e.maxWidth}},{key:"_placeInTree",value:function(e,t,i){1==i&&void 0!==i||this._updateBranchMass(e,t);var o,n=e.children.NW.range;o=n.maxX>t.x?n.maxY>t.y?"NW":"SW":n.maxY>t.y?"NE":"SE",this._placeInRegion(e,t,o)}},{key:"_placeInRegion",value:function(e,t,i){var o=e.children[i];switch(o.childrenCount){case 0:o.children.data=t,o.childrenCount=1,this._updateBranchMass(o,t);break;case 1:o.children.data.x===t.x&&o.children.data.y===t.y?(t.x+=this._rng(),t.y+=this._rng()):(this._splitBranch(o),this._placeInTree(o,t));break;case 4:this._placeInTree(o,t)}}},{key:"_splitBranch",value:function(e){var t=null;1===e.childrenCount&&(t=e.children.data,e.mass=0,e.centerOfMass.x=0,e.centerOfMass.y=0),e.childrenCount=4,e.children.data=null,this._insertRegion(e,"NW"),this._insertRegion(e,"NE"),this._insertRegion(e,"SW"),this._insertRegion(e,"SE"),null!=t&&this._placeInTree(e,t)}},{key:"_insertRegion",value:function(e,t){var i,o,n,s,r=.5*e.size;switch(t){case"NW":i=e.range.minX,o=e.range.minX+r,n=e.range.minY,s=e.range.minY+r;break;case"NE":i=e.range.minX+r,o=e.range.maxX,n=e.range.minY,s=e.range.minY+r;break;case"SW":i=e.range.minX,o=e.range.minX+r,n=e.range.minY+r,s=e.range.maxY;break;case"SE":i=e.range.minX+r,o=e.range.maxX,n=e.range.minY+r,s=e.range.maxY}e.children[t]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:o,minY:n,maxY:s},size:.5*e.size,calcSize:2*e.calcSize,children:{data:null},maxWidth:0,level:e.level+1,childrenCount:0}}},{key:"_debug",value:function(e,t){void 0!==this.barnesHutTree&&(e.lineWidth=1,this._drawBranch(this.barnesHutTree.root,e,t))}},{key:"_drawBranch",value:function(e,t,i){void 0===i&&(i="#FF0000"),4===e.childrenCount&&(this._drawBranch(e.children.NW,t),this._drawBranch(e.children.NE,t),this._drawBranch(e.children.SE,t),this._drawBranch(e.children.SW,t)),t.strokeStyle=i,t.beginPath(),t.moveTo(e.range.minX,e.range.minY),t.lineTo(e.range.maxX,e.range.minY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.minY),t.lineTo(e.range.maxX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.maxY),t.lineTo(e.range.minX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.minX,e.range.maxY),t.lineTo(e.range.minX,e.range.minY),t.stroke()}}]),e}(),$d=function(){function e(i,o,n){Ks(this,e),this._rng=t.Alea("REPULSION SOLVER"),this.body=i,this.physicsBody=o,this.setOptions(n)}return Qs(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,o,n,s,r,a,h=this.body.nodes,d=this.physicsBody.physicsNodeIndices,l=this.physicsBody.forces,c=this.options.nodeDistance,u=-2/3/c,p=0;p<d.length-1;p++){r=h[d[p]];for(var f=p+1;f<d.length;f++)e=(a=h[d[f]]).x-r.x,t=a.y-r.y,0===(i=Math.sqrt(e*e+t*t))&&(e=i=.1*this._rng()),i<2*c&&(s=i<.5*c?1:u*i+4/3,o=e*(s/=i),n=t*s,l[r.id].x-=o,l[r.id].y-=n,l[a.id].x+=o,l[a.id].y+=n)}}}]),e}();var Jd=function(e){throw new Error('"'+e+'" is read-only')},Qd=function(){function e(t,i,o){Ks(this,e),this.body=t,this.physicsBody=i,this.setOptions(o)}return Qs(e,[{key:"setOptions",value:function(e){this.options=e,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var e=this.body.nodes,t=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,o=this.options.nodeDistance,n=0;n<t.length-1;n++)for(var s=e[t[n]],r=n+1;r<t.length;r++){var a=e[t[r]];if(s.level===a.level){var h=o+this.overlapAvoidanceFactor*((s.shape.radius||0)/2+(a.shape.radius||0)/2),d=a.x-s.x,l=a.y-s.y,c=Math.sqrt(d*d+l*l),u=void 0;u=c<h?-Math.pow(.05*c,2)+Math.pow(.05*h,2):0,0===c?(Jd("distance"),c=.01):u/=c;var p=d*u,f=l*u;i[s.id].x-=p,i[s.id].y-=f,i[a.id].x+=p,i[a.id].y+=f}}}}]),e}(),el=function(){function e(t,i,o){Ks(this,e),this.body=t,this.physicsBody=i,this.setOptions(o)}return Qs(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,o,n,s=this.physicsBody.physicsEdgeIndices,r=this.body.edges,a=0;a<s.length;a++)!0===(t=r[s[a]]).connected&&t.toId!==t.fromId&&void 0!==this.body.nodes[t.toId]&&void 0!==this.body.nodes[t.fromId]&&(void 0!==t.edgeType.via?(e=void 0===t.options.length?this.options.springLength:t.options.length,i=t.to,o=t.edgeType.via,n=t.from,this._calculateSpringForce(i,o,.5*e),this._calculateSpringForce(o,n,.5*e)):(e=void 0===t.options.length?1.5*this.options.springLength:t.options.length,this._calculateSpringForce(t.from,t.to,e)))}},{key:"_calculateSpringForce",value:function(e,t,i){var o=e.x-t.x,n=e.y-t.y,s=Math.max(Math.sqrt(o*o+n*n),.01),r=this.options.springConstant*(i-s)/s,a=o*r,h=n*r;void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x+=a,this.physicsBody.forces[e.id].y+=h),void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x-=a,this.physicsBody.forces[t.id].y-=h)}}]),e}(),tl=function(){function e(t,i,o){Ks(this,e),this.body=t,this.physicsBody=i,this.setOptions(o)}return Qs(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,o,n,s,r,a,h,d,l=this.body.edges,c=this.physicsBody.physicsEdgeIndices,u=this.physicsBody.physicsNodeIndices,p=this.physicsBody.forces,f=0;f<u.length;f++){var v=u[f];p[v].springFx=0,p[v].springFy=0}for(var g=0;g<c.length;g++)!0===(t=l[c[g]]).connected&&(e=void 0===t.options.length?this.options.springLength:t.options.length,i=t.from.x-t.to.x,o=t.from.y-t.to.y,a=0===(a=Math.sqrt(i*i+o*o))?.01:a,n=i*(r=this.options.springConstant*(e-a)/a),s=o*r,t.to.level!=t.from.level?(void 0!==p[t.toId]&&(p[t.toId].springFx-=n,p[t.toId].springFy-=s),void 0!==p[t.fromId]&&(p[t.fromId].springFx+=n,p[t.fromId].springFy+=s)):(void 0!==p[t.toId]&&(p[t.toId].x-=.5*n,p[t.toId].y-=.5*s),void 0!==p[t.fromId]&&(p[t.fromId].x+=.5*n,p[t.fromId].y+=.5*s)));r=1;for(var y=0;y<u.length;y++){var m=u[y];h=Math.min(r,Math.max(-r,p[m].springFx)),d=Math.min(r,Math.max(-r,p[m].springFy)),p[m].x+=h,p[m].y+=d}for(var b=0,w=0,k=0;k<u.length;k++){var _=u[k];b+=p[_].x,w+=p[_].y}for(var x=b/u.length,E=w/u.length,O=0;O<u.length;O++){var C=u[O];p[C].x-=x,p[C].y-=E}}}]),e}(),il=function(){function e(t,i,o){Ks(this,e),this.body=t,this.physicsBody=i,this.setOptions(o)}return Qs(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,o,n=this.body.nodes,s=this.physicsBody.physicsNodeIndices,r=this.physicsBody.forces,a=0;a<s.length;a++){e=-(o=n[s[a]]).x,t=-o.y,i=Math.sqrt(e*e+t*t),this._calculateForces(i,e,t,r,o)}}},{key:"_calculateForces",value:function(e,t,i,o,n){var s=0===e?0:this.options.centralGravity/e;o[n.id].x=t*s,o[n.id].y=i*s}}]),e}(),ol=function(e){function i(e,o,n){var s;return Ks(this,i),(s=Oh(this,Mh(i).call(this,e,o,n)))._rng=t.Alea("FORCE ATLAS 2 BASED REPULSION SOLVER"),s}return Ph(i,e),Qs(i,[{key:"_calculateForces",value:function(e,t,i,o,n){0===e&&(t=e=.1*this._rng()),this.overlapAvoidanceFactor<1&&o.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,e-o.shape.radius));var s=o.edges.length+1,r=this.options.gravitationalConstant*n.mass*o.options.mass*s/Math.pow(e,2),a=t*r,h=i*r;this.physicsBody.forces[o.id].x+=a,this.physicsBody.forces[o.id].y+=h}}]),i}(Zd),nl=function(e){function t(e,i,o){return Ks(this,t),Oh(this,Mh(t).call(this,e,i,o))}return Ph(t,e),Qs(t,[{key:"_calculateForces",value:function(e,t,i,o,n){if(e>0){var s=n.edges.length+1,r=this.options.centralGravity*s*n.options.mass;o[n.id].x=t*r,o[n.id].y=i*r}}}]),t}(il),sl=function(){function e(i){Ks(this,e),this.body=i,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0,wind:{x:0,y:0}},t.extend(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("initPhysics",(function(){e.initPhysics()})),this.body.emitter.on("_layoutFailed",(function(){e.layoutFailed=!0})),this.body.emitter.on("resetPhysics",(function(){e.stopSimulation(),e.ready=!1})),this.body.emitter.on("disablePhysics",(function(){e.physicsEnabled=!1,e.stopSimulation()})),this.body.emitter.on("restorePhysics",(function(){e.setOptions(e.options),!0===e.ready&&e.startSimulation()})),this.body.emitter.on("startSimulation",(function(){!0===e.ready&&e.startSimulation()})),this.body.emitter.on("stopSimulation",(function(){e.stopSimulation()})),this.body.emitter.on("destroy",(function(){e.stopSimulation(!1),e.body.emitter.off()})),this.body.emitter.on("_dataChanged",(function(){e.updatePhysicsData()}))}},{key:"setOptions",value:function(e){if(void 0!==e)if(!1===e)this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation();else if(!0===e)this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation();else{this.physicsEnabled=!0,t.selectiveNotDeepExtend(["stabilization"],this.options,e),t.mergeOptions(this.options,e,"stabilization"),void 0===e.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation());var i=this.options.wind;i&&(("number"!=typeof i.x||Kd(i.x))&&(i.x=0),("number"!=typeof i.y||Kd(i.y))&&(i.y=0)),this.timestep=this.options.timestep}this.init()}},{key:"init",value:function(){var e;"forceAtlas2Based"===this.options.solver?(e=this.options.forceAtlas2Based,this.nodesSolver=new ol(this.body,this.physicsBody,e),this.edgesSolver=new el(this.body,this.physicsBody,e),this.gravitySolver=new nl(this.body,this.physicsBody,e)):"repulsion"===this.options.solver?(e=this.options.repulsion,this.nodesSolver=new $d(this.body,this.physicsBody,e),this.edgesSolver=new el(this.body,this.physicsBody,e),this.gravitySolver=new il(this.body,this.physicsBody,e)):"hierarchicalRepulsion"===this.options.solver?(e=this.options.hierarchicalRepulsion,this.nodesSolver=new Qd(this.body,this.physicsBody,e),this.edgesSolver=new tl(this.body,this.physicsBody,e),this.gravitySolver=new il(this.body,this.physicsBody,e)):(e=this.options.barnesHut,this.nodesSolver=new Zd(this.body,this.physicsBody,e),this.edgesSolver=new el(this.body,this.physicsBody,e),this.gravitySolver=new il(this.body,this.physicsBody,e)),this.modelOptions=e}},{key:"initPhysics",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){var e;!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=ie(e=this.simulationStep).call(e,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];this.stabilized=!0,!0===e&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===e&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var e=Gd();this.physicsTick(),(Gd()-e<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||!0===this.startedStabilization)&&rr((function(){e.body.emitter.emit("stabilized",{iterations:t}),e.startedStabilization=!1,e.stabilizationIterations=0}),0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled)this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1;else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var e=this.body.nodes,t=this.body.edges;for(var i in e)e.hasOwnProperty(i)&&!0===e[i].options.physics&&this.physicsBody.physicsNodeIndices.push(e[i].id);for(var o in t)t.hasOwnProperty(o)&&!0===t[o].options.physics&&this.physicsBody.physicsEdgeIndices.push(t[o].id);for(var n=0;n<this.physicsBody.physicsNodeIndices.length;n++){var s=this.physicsBody.physicsNodeIndices[n];this.physicsBody.forces[s]={x:0,y:0},void 0===this.physicsBody.velocities[s]&&(this.physicsBody.velocities[s]={x:0,y:0})}for(var r in this.physicsBody.velocities)void 0===e[r]&&delete this.physicsBody.velocities[r]}},{key:"revert",value:function(){var e=kr(this.previousStates),t=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var o=0;o<e.length;o++){var n=e[o];void 0!==t[n]?!0===t[n].options.physics&&(this.referenceState[n]={positions:{x:t[n].x,y:t[n].y}},i[n].x=this.previousStates[n].vx,i[n].y=this.previousStates[n].vy,t[n].x=this.previousStates[n].x,t[n].y=this.previousStates[n].y):delete this.previousStates[n]}}},{key:"_evaluateStepQuality",value:function(){var e,t,i=this.body.nodes,o=this.referenceState;for(var n in this.referenceState)if(this.referenceState.hasOwnProperty(n)&&void 0!==i[n]&&(e=i[n].x-o[n].positions.x,t=i[n].y-o[n].positions.y,Math.sqrt(Math.pow(e,2)+Math.pow(t,2))>.3))return!1;return!0}},{key:"moveNodes",value:function(){for(var e=this.physicsBody.physicsNodeIndices,t=0,i=0,o=0;o<e.length;o++){var n=e[o],s=this._performStep(n);t=Math.max(t,s),i+=s}this.adaptiveTimestepEnabled=i/e.length<5,this.stabilized=t<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(e,t,i){e+=(t-this.modelOptions.damping*e)/i*this.timestep;var o=this.options.maxVelocity||1e9;return Math.abs(e)>o&&(e=e>0?o:-o),e}},{key:"_performStep",value:function(e){var t=this.body.nodes[e],i=this.physicsBody.forces[e];this.options.wind&&(i.x+=this.options.wind.x,i.y+=this.options.wind.y);var o=this.physicsBody.velocities[e];return this.previousStates[e]={x:t.x,y:t.y,vx:o.x,vy:o.y},!1===t.options.fixed.x?(o.x=this.calculateComponentVelocity(o.x,i.x,t.options.mass),t.x+=o.x*this.timestep):(i.x=0,o.x=0),!1===t.options.fixed.y?(o.y=this.calculateComponentVelocity(o.y,i.y,t.options.mass),t.y+=o.y*this.timestep):(i.y=0,o.y=0),Math.sqrt(Math.pow(o.x,2)+Math.pow(o.y,2))}},{key:"_freezeNodes",value:function(){var e=this.body.nodes;for(var t in e)if(e.hasOwnProperty(t)&&e[t].x&&e[t].y){var i=e[t].options.fixed;this.freezeCache[t]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var e=this.body.nodes;for(var t in e)e.hasOwnProperty(t)&&void 0!==this.freezeCache[t]&&(e[t].options.fixed.x=this.freezeCache[t].x,e[t].options.fixed.y=this.freezeCache[t].y);this.freezeCache={}}},{key:"stabilize",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.stabilization.iterations;"number"!=typeof t&&(t=this.options.stabilization.iterations,console.log("The stabilize method needs a numeric amount of iterations. Switching to default: ",t)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=t,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,rr((function(){return e._stabilizationBatch()}),0)):this.ready=!0}},{key:"_startStabilizing",value:function(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var e=this,t=function(){return!1===e.stabilized&&e.stabilizationIterations<e.targetIterations},i=function(){e.body.emitter.emit("stabilizationProgress",{iterations:e.stabilizationIterations,total:e.targetIterations})};this._startStabilizing()&&i();for(var o,n=0;t()&&n<this.options.stabilization.updateInterval;)this.physicsTick(),n++;(i(),t())?rr(ie(o=this._stabilizationBatch).call(o,this),0):this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(e){for(var i=0;i<this.physicsBody.physicsNodeIndices.length;i++){var o=this.physicsBody.physicsNodeIndices[i],n=this.body.nodes[o],s=this.physicsBody.forces[o],r=Math.sqrt(Math.pow(s.x,2)+Math.pow(s.x,2)),a=Math.min(Math.max(5,r),15),h=3*a,d=t.HSVToHex((180-180*Math.min(1,Math.max(0,.03*r)))/360,1,1),l={x:n.x+20*s.x,y:n.y+20*s.y};e.lineWidth=a,e.strokeStyle=d,e.beginPath(),e.moveTo(n.x,n.y),e.lineTo(l.x,l.y),e.stroke();var c=Math.atan2(s.y,s.x);e.fillStyle=d,Nd.draw(e,{type:"arrow",point:l,angle:c,length:h}),zh(e).call(e)}}}]),e}(),rl=[].reverse,al=[1,2];G({target:"Array",proto:!0,forced:String(al)===String(al.reverse())},{reverse:function(){return Vt(this)&&(this.length=this.length),rl.call(this)}});var hl=Q("Array").reverse,dl=Array.prototype,ll=function(e){var t=e.reverse;return e===dl||e instanceof Array&&t===dl.reverse?hl:t},cl=function(){function e(){Ks(this,e)}return Qs(e,null,[{key:"getRange",value:function(e){var t,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=1e9,n=-1e9,s=1e9,r=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)s>(t=e[i[a]]).shape.boundingBox.left&&(s=t.shape.boundingBox.left),r<t.shape.boundingBox.right&&(r=t.shape.boundingBox.right),o>t.shape.boundingBox.top&&(o=t.shape.boundingBox.top),n<t.shape.boundingBox.bottom&&(n=t.shape.boundingBox.bottom);return 1e9===s&&-1e9===r&&1e9===o&&-1e9===n&&(o=0,n=0,s=0,r=0),{minX:s,maxX:r,minY:o,maxY:n}}},{key:"getRangeCore",value:function(e){var t,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=1e9,n=-1e9,s=1e9,r=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)s>(t=e[i[a]]).x&&(s=t.x),r<t.x&&(r=t.x),o>t.y&&(o=t.y),n<t.y&&(n=t.y);return 1e9===s&&-1e9===r&&1e9===o&&-1e9===n&&(o=0,n=0,s=0,r=0),{minX:s,maxX:r,minY:o,maxY:n}}},{key:"findCenter",value:function(e){return{x:.5*(e.maxX+e.minX),y:.5*(e.maxY+e.minY)}}},{key:"cloneOptions",value:function(e,i){var o={};return void 0===i||"node"===i?(t.deepExtend(o,e.options,!0),o.x=e.x,o.y=e.y,o.amountOfConnections=e.edges.length):t.deepExtend(o,e.options,!0),o}}]),e}(),ul=function(e){function i(e,t,o,n,s,r){var a;return Ks(this,i),(a=Oh(this,Mh(i).call(this,e,t,o,n,s,r))).isCluster=!0,a.containedNodes={},a.containedEdges={},a}return Ph(i,e),Qs(i,[{key:"_openChildCluster",value:function(e){var i=this,o=this.body.nodes[e];if(void 0===this.containedNodes[e])throw new Error("node with id: "+e+" not in current cluster");if(!o.isCluster)throw new Error("node with id: "+e+" is not a cluster");delete this.containedNodes[e],t.forEach(o.edges,(function(e){delete i.containedEdges[e.id]})),t.forEach(o.containedNodes,(function(e,t){i.containedNodes[t]=e})),o.containedNodes={},t.forEach(o.containedEdges,(function(e,t){i.containedEdges[t]=e})),o.containedEdges={},t.forEach(o.edges,(function(e){t.forEach(i.edges,(function(o){var n,s,r=Vi(n=o.clusteringEdgeReplacingIds).call(n,e.id);-1!==r&&(t.forEach(e.clusteringEdgeReplacingIds,(function(e){o.clusteringEdgeReplacingIds.push(e),i.body.edges[e].edgeReplacedById=o.id})),Oi(s=o.clusteringEdgeReplacingIds).call(s,r,1))}))})),o.edges=[]}}]),i}(ud),pl=function(){function e(i){var o=this;Ks(this,e),this.body=i,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},t.extend(this.options,this.defaultOptions),this.body.emitter.on("_resetData",(function(){o.clusteredNodes={},o.clusteredEdges={}}))}return Qs(e,[{key:"clusterByHubsize",value:function(e,t){void 0===e?e=this._getHubSize():"object"===eh(e)&&(t=this._checkOptions(e),e=this._getHubSize());for(var i=[],o=0;o<this.body.nodeIndices.length;o++){var n=this.body.nodes[this.body.nodeIndices[o]];n.edges.length>=e&&i.push(n.id)}for(var s=0;s<i.length;s++)this.clusterByConnection(i[s],t,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var e=this,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},o=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(void 0===i.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");i=this._checkOptions(i);var n={},s={};t.forEach(this.body.nodes,(function(o,r){o.options&&!0===i.joinCondition(o.options)&&(n[r]=o,t.forEach(o.edges,(function(t){void 0===e.clusteredEdges[t.id]&&(s[t.id]=t)})))})),this._cluster(n,s,i,o)}},{key:"clusterByEdgeCount",value:function(e,t){var i=this,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];t=this._checkOptions(t);for(var n,s,r,a=[],h={},d=function(o){var d={},l={},p=i.body.nodeIndices[o],f=i.body.nodes[p];if(void 0===h[p]){r=0,s=[];for(var v=0;v<f.edges.length;v++)n=f.edges[v],void 0===i.clusteredEdges[n.id]&&(n.toId!==n.fromId&&r++,s.push(n));if(r===e){c=function(e){if(void 0===t.joinCondition||null===t.joinCondition)return!0;var i=cl.cloneOptions(e);return t.joinCondition(i)};for(var g=!0,y=0;y<s.length;y++){n=s[y];var m=i._getConnectedId(n,p);if(!c(f)){g=!1;break}l[n.id]=n,d[p]=f,d[m]=i.body.nodes[m],h[p]=!0}if(kr(d).length>0&&kr(l).length>0&&!0===g)if(void 0!==(u=function(){for(var e=0;e<a.length;++e)for(var t in d)if(void 0!==a[e].nodes[t])return a[e]}())){for(var b in d)void 0===u.nodes[b]&&(u.nodes[b]=d[b]);for(var w in l)void 0===u.edges[w]&&(u.edges[w]=l[w])}else a.push({nodes:d,edges:l})}}},l=0;l<this.body.nodeIndices.length;l++){var c,u;d(l)}for(var p=0;p<a.length;p++)this._cluster(a[p].nodes,a[p].edges,t,!1);!0===o&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(1,e,t)}},{key:"clusterBridges",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(2,e,t)}},{key:"clusterByConnection",value:function(e,t){var i,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===e)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[e])throw new Error("The nodeId given to clusterByConnection does not exist!");var n=this.body.nodes[e];void 0===(t=this._checkOptions(t,n)).clusterNodeProperties.x&&(t.clusterNodeProperties.x=n.x),void 0===t.clusterNodeProperties.y&&(t.clusterNodeProperties.y=n.y),void 0===t.clusterNodeProperties.fixed&&(t.clusterNodeProperties.fixed={},t.clusterNodeProperties.fixed.x=n.options.fixed.x,t.clusterNodeProperties.fixed.y=n.options.fixed.y);var s={},r={},a=n.id,h=cl.cloneOptions(n);s[a]=n;for(var d=0;d<n.edges.length;d++){var l=n.edges[d];if(void 0===this.clusteredEdges[l.id]){var c=this._getConnectedId(l,a);if(void 0===this.clusteredNodes[c])if(c!==a)if(void 0===t.joinCondition)r[l.id]=l,s[c]=this.body.nodes[c];else{var u=cl.cloneOptions(this.body.nodes[c]);!0===t.joinCondition(h,u)&&(r[l.id]=l,s[c]=this.body.nodes[c])}else r[l.id]=l}}var p=Po(i=kr(s)).call(i,(function(e){return s[e].id}));for(f in s)if(s.hasOwnProperty(f))for(var f=s[f],v=0;v<f.edges.length;v++){var g=f.edges[v];Vi(p).call(p,this._getConnectedId(g,f.id))>-1&&(r[g.id]=g)}this._cluster(s,r,t,o)}},{key:"_createClusterEdges",value:function(e,t,i,o){for(var n,s,r,a,h,d,l=kr(e),c=[],u=0;u<l.length;u++){r=e[s=l[u]];for(var p=0;p<r.edges.length;p++)n=r.edges[p],void 0===this.clusteredEdges[n.id]&&(n.toId==n.fromId?t[n.id]=n:n.toId==s?(a=i.id,d=h=n.fromId):(a=n.toId,h=i.id,d=a),void 0===e[d]&&c.push({edge:n,fromId:h,toId:a}))}for(var f=[],v=function(e){for(var t=0;t<f.length;t++){var i=f[t],o=e.fromId===i.fromId&&e.toId===i.toId,n=e.fromId===i.toId&&e.toId===i.fromId;if(o||n)return i}return null},g=0;g<c.length;g++){var y=c[g],m=y.edge,b=v(y);null===b?(b=this._createClusteredEdge(y.fromId,y.toId,m,o),f.push(b)):b.clusteringEdgeReplacingIds.push(m.id),this.body.edges[m.id].edgeReplacedById=b.id,this._backupEdgeOptions(m),m.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return void 0===e.clusterEdgeProperties&&(e.clusterEdgeProperties={}),void 0===e.clusterNodeProperties&&(e.clusterNodeProperties={}),e}},{key:"_cluster",value:function(e,i,o){var n=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],s=[];for(var r in e)e.hasOwnProperty(r)&&void 0!==this.clusteredNodes[r]&&s.push(r);for(var a=0;a<s.length;++a)delete e[s[a]];if(0!=kr(e).length&&(1!=kr(e).length||1==o.clusterNodeProperties.allowSingleNodeCluster)){var h=t.deepExtend({},o.clusterNodeProperties);if(void 0!==o.processProperties){var d=[];for(var l in e)if(e.hasOwnProperty(l)){var c=cl.cloneOptions(e[l]);d.push(c)}var u=[];for(var p in i)if(i.hasOwnProperty(p)&&"clusterEdge:"!==p.substr(0,12)){var f=cl.cloneOptions(i[p],"edge");u.push(f)}if(!(h=o.processProperties(h,d,u)))throw new Error("The processProperties function does not return properties!")}void 0===h.id&&(h.id="cluster:"+t.randomUUID());var v=h.id;void 0===h.label&&(h.label="cluster");var g=void 0;void 0===h.x&&(g=this._getClusterPosition(e),h.x=g.x),void 0===h.y&&(void 0===g&&(g=this._getClusterPosition(e)),h.y=g.y),h.id=v;var y=this.body.functions.createNode(h,ul);y.containedNodes=e,y.containedEdges=i,y.clusterEdgeProperties=o.clusterEdgeProperties,this.body.nodes[h.id]=y,this._clusterEdges(e,i,h,o.clusterEdgeProperties),h.id=void 0,!0===n&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(e){void 0===this.clusteredEdges[e.id]&&(this.clusteredEdges[e.id]={physics:e.options.physics})}},{key:"_restoreEdge",value:function(e){var t=this.clusteredEdges[e.id];void 0!==t&&(e.setOptions({physics:t.physics}),delete this.clusteredEdges[e.id])}},{key:"isCluster",value:function(e){return void 0!==this.body.nodes[e]?!0===this.body.nodes[e].isCluster:(console.log("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(e){for(var t,i=kr(e),o=e[i[0]].x,n=e[i[0]].x,s=e[i[0]].y,r=e[i[0]].y,a=1;a<i.length;a++)o=(t=e[i[a]]).x<o?t.x:o,n=t.x>n?t.x:n,s=t.y<s?t.y:s,r=t.y>r?t.y:r;return{x:.5*(o+n),y:.5*(s+r)}}},{key:"openCluster",value:function(e,i){var o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===e)throw new Error("No clusterNodeId supplied to openCluster.");var n=this.body.nodes[e];if(void 0===n)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==n.isCluster||void 0===n.containedNodes||void 0===n.containedEdges)throw new Error("The node:"+e+" is not a valid cluster.");var s=this.findNode(e),r=Vi(s).call(s,e)-1;if(r>=0){var a=s[r],h=this.body.nodes[a];return h._openChildCluster(e),delete this.body.nodes[e],void(!0===o&&this.body.emitter.emit("_dataChanged"))}var d=n.containedNodes,l=n.containedEdges;if(void 0!==i&&void 0!==i.releaseFunction&&"function"==typeof i.releaseFunction){var c={},u={x:n.x,y:n.y};for(var p in d)if(d.hasOwnProperty(p)){var f=this.body.nodes[p];c[p]={x:f.x,y:f.y}}var v=i.releaseFunction(u,c);for(var g in d)if(d.hasOwnProperty(g)){var y=this.body.nodes[g];void 0!==v[g]&&(y.x=void 0===v[g].x?n.x:v[g].x,y.y=void 0===v[g].y?n.y:v[g].y)}}else t.forEach(d,(function(e){!1===e.options.fixed.x&&(e.x=n.x),!1===e.options.fixed.y&&(e.y=n.y)}));for(var m in d)if(d.hasOwnProperty(m)){var b=this.body.nodes[m];b.vx=n.vx,b.vy=n.vy,b.setOptions({physics:!0}),delete this.clusteredNodes[m]}for(var w=[],k=0;k<n.edges.length;k++)w.push(n.edges[k]);for(var _=0;_<w.length;_++){for(var x=w[_],E=this._getConnectedId(x,e),O=this.clusteredNodes[E],C=0;C<x.clusteringEdgeReplacingIds.length;C++){var T=x.clusteringEdgeReplacingIds[C],S=this.body.edges[T];if(void 0!==S)if(void 0!==O){var M=this.body.nodes[O.clusterId];M.containedEdges[S.id]=S,delete l[S.id];var D=S.fromId,I=S.toId;S.toId==E?I=O.clusterId:D=O.clusterId,this._createClusteredEdge(D,I,S,M.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(S)}x.remove()}for(var P in l)l.hasOwnProperty(P)&&this._restoreEdge(l[P]);delete this.body.nodes[e],!0===o&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(e){var t=[];if(!0===this.isCluster(e)){var i=this.body.nodes[e].containedNodes;for(var o in i)i.hasOwnProperty(o)&&t.push(this.body.nodes[o].id)}return t}},{key:"findNode",value:function(e){for(var t,i=[],o=0;void 0!==this.clusteredNodes[e]&&o<100;){if(void 0===(t=this.body.nodes[e]))return[];i.push(t.id),e=this.clusteredNodes[e].clusterId,o++}return void 0===(t=this.body.nodes[e])?[]:(i.push(t.id),ll(i).call(i),i)}},{key:"updateClusteredNode",value:function(e,t){if(void 0===e)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===t)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[e])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[e].setOptions(t),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(e,t){if(void 0===e)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===t)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[e])throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(e),o=0;o<i.length;o++){this.body.edges[i[o]].setOptions(t)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(e){for(var t=[],i=0;void 0!==e&&void 0!==this.body.edges[e]&&i<100;)t.push(this.body.edges[e].id),e=this.body.edges[e].edgeReplacedById,i++;return ll(t).call(t),t}},{key:"getBaseEdge",value:function(e){return this.getBaseEdges(e)[0]}},{key:"getBaseEdges",value:function(e){for(var t=[e],i=[],o=[],n=0;t.length>0&&n<100;){var s=t.pop();if(void 0!==s){var r=this.body.edges[s];if(void 0!==r){n++;var a=r.clusteringEdgeReplacingIds;if(void 0===a)o.push(s);else for(var h=0;h<a.length;++h){var d=a[h];-1===Vi(t).call(t,a)&&-1===Vi(i).call(i,a)&&t.push(d)}i.push(s)}}}return o}},{key:"_getConnectedId",value:function(e,t){return e.toId!=t?e.toId:(e.fromId,e.fromId)}},{key:"_getHubSize",value:function(){for(var e=0,t=0,i=0,o=0,n=0;n<this.body.nodeIndices.length;n++){var s=this.body.nodes[this.body.nodeIndices[n]];s.edges.length>o&&(o=s.edges.length),e+=s.edges.length,t+=Math.pow(s.edges.length,2),i+=1}e/=i;var r=(t/=i)-Math.pow(e,2),a=Math.sqrt(r),h=Math.floor(e+2*a);return h>o&&(h=o),h}},{key:"_createClusteredEdge",value:function(e,i,o,n,s){var r=cl.cloneOptions(o,"edge");t.deepExtend(r,n),r.from=e,r.to=i,r.id="clusterEdge:"+t.randomUUID(),void 0!==s&&t.deepExtend(r,s);var a=this.body.functions.createEdge(r);return a.clusteringEdgeReplacingIds=[o.id],a.connect(),this.body.edges[a.id]=a,a}},{key:"_clusterEdges",value:function(e,t,i,o){if(t instanceof Yd){var n=t,s={};s[n.id]=n,t=s}if(e instanceof ud){var r=e,a={};a[r.id]=r,e=a}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");for(var h in void 0===o&&(o=i.clusterEdgeProperties),this._createClusterEdges(e,t,i,o),t)if(t.hasOwnProperty(h)&&void 0!==this.body.edges[h]){var d=this.body.edges[h];this._backupEdgeOptions(d),d.setOptions({physics:!1})}for(var l in e)e.hasOwnProperty(l)&&(this.clusteredNodes[l]={clusterId:i.id,node:this.body.nodes[l]},this.body.nodes[l].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(e){if(void 0!==e){var t=this.clusteredNodes[e];if(void 0!==t){var i=t.clusterId;if(void 0!==i)return this.body.nodes[i]}}}},{key:"_filter",value:function(e,i){var o=[];return t.forEach(e,(function(e){i(e)&&o.push(e)})),o}},{key:"_updateState",value:function(){var e,i=this,o=[],n={},s=function(e){t.forEach(i.body.nodes,(function(t){!0===t.isCluster&&e(t)}))};for(e in this.clusteredNodes){if(this.clusteredNodes.hasOwnProperty(e))void 0===this.body.nodes[e]&&o.push(e)}s((function(e){for(var t=0;t<o.length;t++)delete e.containedNodes[o[t]]}));for(var r=0;r<o.length;r++)delete this.clusteredNodes[o[r]];t.forEach(this.clusteredEdges,(function(e){var t=i.body.edges[e];void 0!==t&&t.endPointsValid()||(n[e]=e)})),s((function(e){t.forEach(e.containedEdges,(function(e,t){e.endPointsValid()||n[t]||(n[t]=t)}))})),t.forEach(this.body.edges,(function(e,o){var s=!0,r=e.clusteringEdgeReplacingIds;if(void 0!==r){var a=0;t.forEach(r,(function(e){var t=i.body.edges[e];void 0!==t&&t.endPointsValid()&&(a+=1)})),s=a>0}e.endPointsValid()&&s||(n[o]=o)})),s((function(e){t.forEach(n,(function(o){delete e.containedEdges[o],t.forEach(e.edges,(function(t,s){t.id!==o?t.clusteringEdgeReplacingIds=i._filter(t.clusteringEdgeReplacingIds,(function(e){return!n[e]})):e.edges[s]=null})),e.edges=i._filter(e.edges,(function(e){return null!==e}))}))})),t.forEach(n,(function(e){delete i.clusteredEdges[e]})),t.forEach(n,(function(e){delete i.body.edges[e]}));var a=kr(this.body.edges);t.forEach(a,(function(e){var t=i.body.edges[e],o=i._isClusteredNode(t.fromId)||i._isClusteredNode(t.toId);if(o!==i._isClusteredEdge(t.id))if(o){var n=i._getClusterNodeForNode(t.fromId);void 0!==n&&i._clusterEdges(i.body.nodes[t.fromId],t,n);var s=i._getClusterNodeForNode(t.toId);void 0!==s&&i._clusterEdges(i.body.nodes[t.toId],t,s)}else delete i._clusterEdges[e],i._restoreEdge(t)}));for(var h=!1,d=!0,l=function(){var e=[];s((function(t){var i=kr(t.containedNodes).length,o=!0===t.options.allowSingleNodeCluster;(o&&i<1||!o&&i<2)&&e.push(t.id)}));for(var t=0;t<e.length;++t)i.openCluster(e[t],{},!1);d=e.length>0,h=h||d};d;)l();h&&this._updateState()}},{key:"_isClusteredNode",value:function(e){return void 0!==this.clusteredNodes[e]}},{key:"_isClusteredEdge",value:function(e){return void 0!==this.clusteredEdges[e]}}]),e}();var fl=function(){function e(i,o){var n;Ks(this,e),void 0!==window&&(n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===n?function(e){e()}:n,this.body=i,this.canvas=o,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},t.extend(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e,t=this;this.body.emitter.on("dragStart",(function(){t.dragging=!0})),this.body.emitter.on("dragEnd",(function(){t.dragging=!1})),this.body.emitter.on("zoom",(function(){t.zooming=!0,window.clearTimeout(t.zoomTimeoutId),t.zoomTimeoutId=window.setTimeout((function(){var e;t.zooming=!1,ie(e=t._requestRedraw).call(e,t)()}),250)})),this.body.emitter.on("_resizeNodes",(function(){t._resizeNodes()})),this.body.emitter.on("_redraw",(function(){!1===t.renderingActive&&t._redraw()})),this.body.emitter.on("_blockRedraw",(function(){t.allowRedraw=!1})),this.body.emitter.on("_allowRedraw",(function(){t.allowRedraw=!0,t.redrawRequested=!1})),this.body.emitter.on("_requestRedraw",ie(e=this._requestRedraw).call(e,this)),this.body.emitter.on("_startRendering",(function(){t.renderRequests+=1,t.renderingActive=!0,t._startRendering()})),this.body.emitter.on("_stopRendering",(function(){t.renderRequests-=1,t.renderingActive=t.renderRequests>0,t.renderTimer=void 0})),this.body.emitter.on("destroy",(function(){t.renderRequests=0,t.allowRedraw=!1,t.renderingActive=!1,!0===t.requiresTimeout?clearTimeout(t.renderTimer):window.cancelAnimationFrame(t.renderTimer),t.body.emitter.off()}))}},{key:"setOptions",value:function(e){if(void 0!==e){t.selectiveDeepExtend(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"],this.options,e)}}},{key:"_requestNextFrame",value:function(e,t){if("undefined"!=typeof window){var i,o=window;return!0===this.requiresTimeout?i=o.setTimeout(e,t):o.requestAnimationFrame&&(i=o.requestAnimationFrame(e)),i}}},{key:"_startRendering",value:function(){var e;!0===this.renderingActive&&(void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(ie(e=this._renderStep).call(e,this),this.simulationInterval)))}},{key:"_renderStep",value:function(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var e=this;!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame((function(){e._redraw(!1)}),0))}},{key:"_redraw",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1,0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();var t=this.canvas.getContext(),i=this.canvas.frame.canvas.clientWidth,o=this.canvas.frame.canvas.clientHeight;if(t.clearRect(0,0,i,o),0===this.canvas.frame.clientWidth)return;t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale),t.beginPath(),this.body.emitter.emit("beforeDrawing",t),t.closePath(),!1===e&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(t),(!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag)&&this._drawNodes(t,e),t.beginPath(),this.body.emitter.emit("afterDrawing",t),t.closePath(),t.restore(),!0===e&&t.clearRect(0,0,i,o)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var e=this.canvas.getContext();e.save(),e.translate(this.body.view.translation.x,this.body.view.translation.y),e.scale(this.body.view.scale,this.body.view.scale);var t,i=this.body.nodes;for(var o in i)i.hasOwnProperty(o)&&((t=i[o]).resize(e),t.updateBoundingBox(e,t.selected));e.restore()}},{key:"_drawNodes",value:function(e){for(var t,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=this.body.nodes,n=this.body.nodeIndices,s=[],r=20,a=this.canvas.DOMtoCanvas({x:-r,y:-r}),h=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+r,y:this.canvas.frame.canvas.clientHeight+r}),d={top:a.y,left:a.x,bottom:h.y,right:h.x},l=0;l<n.length;l++)(t=o[n[l]]).isSelected()?s.push(n[l]):!0===i?t.draw(e):!0===t.isBoundingBoxOverlappingWith(d)?t.draw(e):t.updateBoundingBox(e,t.selected);for(var c=0;c<s.length;c++)(t=o[s[c]]).draw(e)}},{key:"_drawEdges",value:function(e){for(var t,i=this.body.edges,o=this.body.edgeIndices,n=0;n<o.length;n++)!0===(t=i[o[n]]).connected&&t.draw(e)}},{key:"_determineBrowserMethod",value:function(){if("undefined"!=typeof window){var e=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,-1!=Vi(e).call(e,"msie 9.0")?this.requiresTimeout=!0:-1!=Vi(e).call(e,"safari")&&Vi(e).call(e,"chrome")<=-1&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}}]),e}(),vl=L.setInterval,gl=r((function(e,t){t.onTouch=function(e,t){t.inputHandler=function(e){e.isFirst&&t(e)},e.on("hammer.input",t.inputHandler)},t.onRelease=function(e,t){return t.inputHandler=function(e){e.isFinal&&t(e)},e.on("hammer.input",t.inputHandler)},t.offTouch=function(e,t){e.off("hammer.input",t.inputHandler)},t.offRelease=t.offTouch,t.disablePreventDefaultVertically=function(e){return e.getTouchAction=function(){return["pan-y"]},e}})),yl=(gl.onTouch,gl.onRelease,gl.offTouch,gl.offRelease,gl.disablePreventDefaultVertically,function(){function e(i){var o;Ks(this,e),this.body=i,this.pixelRatio=1,this.resizeTimer=void 0,this.resizeFunction=ie(o=this._onResize).call(o,this),this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},t.extend(this.options,this.defaultOptions),this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e,t=this;this.body.emitter.once("resize",(function(e){0!==e.width&&(t.body.view.translation.x=.5*e.width),0!==e.height&&(t.body.view.translation.y=.5*e.height)})),this.body.emitter.on("setSize",ie(e=this.setSize).call(e,this)),this.body.emitter.on("destroy",(function(){t.hammerFrame.destroy(),t.hammer.destroy(),t._cleanUp()}))}},{key:"setOptions",value:function(e){var i,o=this;if(void 0!==e){t.selectiveDeepExtend(["width","height","autoResize"],this.options,e)}!0===this.options.autoResize&&(this._cleanUp(),this.resizeTimer=vl((function(){!0===o.setSize()&&o.body.emitter.emit("_requestRedraw")}),1e3),this.resizeFunction=ie(i=this._onResize).call(i,this),t.addEventListener(window,"resize",this.resizeFunction))}},{key:"_cleanUp",value:function(){void 0!==this.resizeTimer&&clearInterval(this.resizeTimer),t.removeEventListener(window,"resize",this.resizeFunction),this.resizeFunction=void 0}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.pixelRatio;!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/e,this.cameraState.previousHeight=this.frame.canvas.height/e,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/e,y:.5*this.frame.canvas.height/e}))}},{key:"_setCameraState",value:function(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0&&this.cameraState.previousHeight>0){var e=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,t=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;1!=e&&1!=t?i=.5*this.cameraState.scale*(e+t):1!=e?i=this.cameraState.scale*e:1!=t&&(i=this.cameraState.scale*t),this.body.view.scale=i;var o=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),n={x:o.x-this.cameraState.position.x,y:o.y-this.cameraState.position.y};this.body.view.translation.x+=n.x*this.body.view.scale,this.body.view.translation.y+=n.y*this.body.view.scale}}},{key:"_prepareValue",value:function(e){if("number"==typeof e)return e+"px";if("string"==typeof e){if(-1!==Vi(e).call(e,"%")||-1!==Vi(e).call(e,"px"))return e;if(-1===Vi(e).call(e,"%"))return e+"px"}throw new Error("Could not use the value supplied for width or height:"+e)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=900,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var e=document.createElement("DIV");e.style.color="red",e.style.fontWeight="bold",e.style.padding="10px",e.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(e)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var e=this;void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new Us(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:Us.DIRECTION_ALL}),gl.onTouch(this.hammer,(function(t){e.body.eventListeners.onTouch(t)})),this.hammer.on("tap",(function(t){e.body.eventListeners.onTap(t)})),this.hammer.on("doubletap",(function(t){e.body.eventListeners.onDoubleTap(t)})),this.hammer.on("press",(function(t){e.body.eventListeners.onHold(t)})),this.hammer.on("panstart",(function(t){e.body.eventListeners.onDragStart(t)})),this.hammer.on("panmove",(function(t){e.body.eventListeners.onDrag(t)})),this.hammer.on("panend",(function(t){e.body.eventListeners.onDragEnd(t)})),this.hammer.on("pinch",(function(t){e.body.eventListeners.onPinch(t)})),this.frame.canvas.addEventListener("wheel",(function(t){e.body.eventListeners.onMouseWheel(t)})),this.frame.canvas.addEventListener("mousemove",(function(t){e.body.eventListeners.onMouseMove(t)})),this.frame.canvas.addEventListener("contextmenu",(function(t){e.body.eventListeners.onContext(t)})),this.hammerFrame=new Us(this.frame),gl.onRelease(this.hammerFrame,(function(t){e.body.eventListeners.onRelease(t)}))}},{key:"setSize",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.width,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.height;e=this._prepareValue(e),t=this._prepareValue(t);var i=!1,o=this.frame.canvas.width,n=this.frame.canvas.height,s=this.pixelRatio;if(this._setPixelRatio(),e!=this.options.width||t!=this.options.height||this.frame.style.width!=e||this.frame.style.height!=t)this._getCameraState(s),this.frame.style.width=e,this.frame.style.height=t,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=e,this.options.height=t,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var r=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),a=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===r&&this.frame.canvas.height===a||this._getCameraState(s),this.frame.canvas.width!==r&&(this.frame.canvas.width=r,i=!0),this.frame.canvas.height!==a&&(this.frame.canvas.height=a,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(o/this.pixelRatio),oldHeight:Math.round(n/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var e=this.getContext();if(void 0===e)throw new Error("Could not get canvax context");var t=1;return"undefined"!=typeof window&&(t=window.devicePixelRatio||1),t/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var e=this.getContext();if(void 0===e)throw new Error("Could not get canvax context");e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(e){return(e-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(e){return e*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(e){return(e-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(e){return e*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(e){return{x:this._XconvertCanvasToDOM(e.x),y:this._YconvertCanvasToDOM(e.y)}}},{key:"DOMtoCanvas",value:function(e){return{x:this._XconvertDOMtoCanvas(e.x),y:this._YconvertDOMtoCanvas(e.y)}}}]),e}()),ml=d.isFinite,bl=Number.isFinite||function(e){return"number"==typeof e&&ml(e)};G({target:"Number",stat:!0},{isFinite:bl});var wl=L.Number.isFinite,kl=function(){function e(t,i){var o,n,s=this;Ks(this,e),this.body=t,this.canvas=i,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",ie(o=this.fit).call(o,this)),this.body.emitter.on("animationFinished",(function(){s.body.emitter.emit("_stopRendering")})),this.body.emitter.on("unlockNode",ie(n=this.releaseNode).call(n,this))}return Qs(e,[{key:"setOptions",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.options=e}},{key:"fit",value:function(){var e,t,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{nodes:[]},o=arguments.length>1&&void 0!==arguments[1]&&arguments[1];void 0!==(i=yh({},i)).nodes&&0!==i.nodes.length||(i.nodes=this.body.nodeIndices);var n=this.canvas.frame.canvas.clientWidth,s=this.canvas.frame.canvas.clientHeight;if(0===n||0===s)t=1,e=cl.getRange(this.body.nodes,i.nodes);else if(!0===o){var r=0;for(var a in this.body.nodes)if(this.body.nodes.hasOwnProperty(a)){var h=this.body.nodes[a];!0===h.predefinedPosition&&(r+=1)}if(r>.5*this.body.nodeIndices.length)return void this.fit(i,!1);e=cl.getRange(this.body.nodes,i.nodes);var d=this.body.nodeIndices.length;t=12.662/(d+7.4147)+.0964822;var l=Math.min(n/600,s/600);t*=l}else{this.body.emitter.emit("_resizeNodes"),e=cl.getRange(this.body.nodes,i.nodes);var c=1.1*Math.abs(e.maxX-e.minX),u=1.1*Math.abs(e.maxY-e.minY),p=n/c,f=s/u;t=p<=f?p:f}t>1?t=1:0===t&&(t=1);var v=cl.findCenter(e),g={position:v,scale:t,animation:i.animation};this.moveTo(g)}},{key:"focus",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(void 0!==this.body.nodes[e]){var i={x:this.body.nodes[e].x,y:this.body.nodes[e].y};t.position=i,t.lockedOnNode=e,this.moveTo(t)}else console.log("Node: "+e+" cannot be found.")}},{key:"moveTo",value:function(e){if(void 0!==e){if(null!=e.offset){if(null!=e.offset.x){if(e.offset.x=+e.offset.x,!wl(e.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else e.offset.x=0;if(null!=e.offset.y){if(e.offset.y=+e.offset.y,!wl(e.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else e.offset.x=0}else e.offset={x:0,y:0};if(null!=e.position){if(null!=e.position.x){if(e.position.x=+e.position.x,!wl(e.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else e.position.x=0;if(null!=e.position.y){if(e.position.y=+e.position.y,!wl(e.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else e.position.x=0}else e.position=this.getViewPosition();if(null!=e.scale){if(e.scale=+e.scale,!(e.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else e.scale=this.body.view.scale;void 0===e.animation&&(e.animation={duration:0}),!1===e.animation&&(e.animation={duration:0}),!0===e.animation&&(e.animation={}),void 0===e.animation.duration&&(e.animation.duration=1e3),void 0===e.animation.easingFunction&&(e.animation.easingFunction="easeInOutQuad"),this.animateView(e)}else e={}}},{key:"animateView",value:function(e){if(void 0!==e){this.animationEasingFunction=e.animation.easingFunction,this.releaseNode(),!0===e.locked&&(this.lockedOnNodeId=e.lockedOnNode,this.lockedOnNodeOffset=e.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=e.scale,this.body.view.scale=this.targetScale;var t,i,o=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),n=o.x-e.position.x,s=o.y-e.position.y;if(this.targetTranslation={x:this.sourceTranslation.x+n*this.targetScale+e.offset.x,y:this.sourceTranslation.y+s*this.targetScale+e.offset.y},0===e.animation.duration)if(null!=this.lockedOnNodeId)this.viewFunction=ie(t=this._lockedRedraw).call(t,this),this.body.emitter.on("initRedraw",this.viewFunction);else this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw");else this.animationSpeed=1/(60*e.animation.duration*.001)||1/60,this.animationEasingFunction=e.animation.easingFunction,this.viewFunction=ie(i=this._transitionRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}},{key:"_lockedRedraw",value:function(){var e=this.body.nodes[this.lockedOnNodeId].x,t=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),o=i.x-e,n=i.y-t,s=this.body.view.translation,r={x:s.x+o*this.body.view.scale+this.lockedOnNodeOffset.x,y:s.y+n*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=r}},{key:"releaseNode",value:function(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.easingTime+=this.animationSpeed,this.easingTime=!0===e?1:this.easingTime;var i=t.easingFunctions[this.animationEasingFunction](this.easingTime);if(this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*i,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*i,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*i},this.easingTime>=1){var o;if(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId)this.viewFunction=ie(o=this._lockedRedraw).call(o,this),this.body.emitter.on("initRedraw",this.viewFunction);this.body.emitter.emit("animationFinished")}}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),e}(),_l=function(){function e(t,i){var o=this;Ks(this,e),this.body=t,this.canvas=i,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",(function(){o.activated=!0,o.configureKeyboardBindings()})),this.body.emitter.on("deactivate",(function(){o.activated=!1,o.configureKeyboardBindings()})),this.body.emitter.on("destroy",(function(){void 0!==o.keycharm&&o.keycharm.destroy()})),this.options={}}return Qs(e,[{key:"setOptions",value:function(e){void 0!==e&&(this.options=e,this.create())}},{key:"create",value:function(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(0!=this.navigationHammers.length){for(var e=0;e<this.navigationHammers.length;e++)this.navigationHammers[e].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var e=this;this.cleanNavigation(),this.navigationDOM={};var t=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var o=0;o<t.length;o++){this.navigationDOM[t[o]]=document.createElement("div"),this.navigationDOM[t[o]].className="vis-button vis-"+t[o],this.navigationDOM.wrapper.appendChild(this.navigationDOM[t[o]]);var n,s,r=new Us(this.navigationDOM[t[o]]);if("_fit"===i[o])gl.onTouch(r,ie(n=this._fit).call(n,this));else gl.onTouch(r,ie(s=this.bindToRedraw).call(s,this,i[o]));this.navigationHammers.push(r)}var a=new Us(this.canvas.frame);gl.onRelease(a,(function(){e._stopMovement()})),this.navigationHammers.push(a),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(e){var t;void 0===this.boundFunctions[e]&&(this.boundFunctions[e]=ie(t=this[e]).call(t,this),this.body.emitter.on("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_startRendering"))}},{key:"unbindFromRedraw",value:function(e){void 0!==this.boundFunctions[e]&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[e])}},{key:"_fit",value:function(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}},{key:"_stopMovement",value:function(){for(var e in this.boundFunctions)this.boundFunctions.hasOwnProperty(e)&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var e=this.body.view.scale,t=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=t/e,n=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,s=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=t,this.body.view.translation={x:n,y:s},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var e=this.body.view.scale,t=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=t/e,n=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,s=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=t,this.body.view.translation={x:n,y:s},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var e,t,o,n,s,r,a,h,d,l,c,u,p,f,v,g,y,m,b,w,k,_,x,E,O=this;(void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled)&&(!0===this.options.keyboard.bindToWindow?this.keycharm=i({container:window,preventDefault:!0}):this.keycharm=i({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(ie(e=this.keycharm).call(e,"up",(function(){O.bindToRedraw("_moveUp")}),"keydown"),ie(t=this.keycharm).call(t,"down",(function(){O.bindToRedraw("_moveDown")}),"keydown"),ie(o=this.keycharm).call(o,"left",(function(){O.bindToRedraw("_moveLeft")}),"keydown"),ie(n=this.keycharm).call(n,"right",(function(){O.bindToRedraw("_moveRight")}),"keydown"),ie(s=this.keycharm).call(s,"=",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),ie(r=this.keycharm).call(r,"num+",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),ie(a=this.keycharm).call(a,"num-",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),ie(h=this.keycharm).call(h,"-",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),ie(d=this.keycharm).call(d,"[",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),ie(l=this.keycharm).call(l,"]",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),ie(c=this.keycharm).call(c,"pageup",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),ie(u=this.keycharm).call(u,"pagedown",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),ie(p=this.keycharm).call(p,"up",(function(){O.unbindFromRedraw("_moveUp")}),"keyup"),ie(f=this.keycharm).call(f,"down",(function(){O.unbindFromRedraw("_moveDown")}),"keyup"),ie(v=this.keycharm).call(v,"left",(function(){O.unbindFromRedraw("_moveLeft")}),"keyup"),ie(g=this.keycharm).call(g,"right",(function(){O.unbindFromRedraw("_moveRight")}),"keyup"),ie(y=this.keycharm).call(y,"=",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),ie(m=this.keycharm).call(m,"num+",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),ie(b=this.keycharm).call(b,"num-",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),ie(w=this.keycharm).call(w,"-",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),ie(k=this.keycharm).call(k,"[",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),ie(_=this.keycharm).call(_,"]",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),ie(x=this.keycharm).call(x,"pageup",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),ie(E=this.keycharm).call(E,"pagedown",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup")))}}]),e}(),xl=function(){function e(t,i){Ks(this,e),this.container=t,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Qs(e,[{key:"setPosition",value:function(e,t){this.x=Aa(e),this.y=Aa(t)}},{key:"setText",value:function(e){e instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(e)):this.frame.innerHTML=e}},{key:"show",value:function(e){if(void 0===e&&(e=!0),!0===e){var t=this.frame.clientHeight,i=this.frame.clientWidth,o=this.frame.parentNode.clientHeight,n=this.frame.parentNode.clientWidth,s=0,r=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-t<this.padding&&(h=!1),this.x+i>n-this.padding&&(a=!0),s=a?this.x-i:this.x,r=h?this.y-t:this.y}else(r=this.y-t)+t+this.padding>o&&(r=o-t-this.padding),r<this.padding&&(r=this.padding),(s=this.x)+i+this.padding>n&&(s=n-i-this.padding),s<this.padding&&(s=this.padding);this.frame.style.left=s+"px",this.frame.style.top=r+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),e}(),El=function(){function e(i,o,n){var s,r,a,h,d,l,c,u,p,f,v,g,y;Ks(this,e),this.body=i,this.canvas=o,this.selectionHandler=n,this.navigationHandler=new _l(i,o),this.body.eventListeners.onTap=ie(s=this.onTap).call(s,this),this.body.eventListeners.onTouch=ie(r=this.onTouch).call(r,this),this.body.eventListeners.onDoubleTap=ie(a=this.onDoubleTap).call(a,this),this.body.eventListeners.onHold=ie(h=this.onHold).call(h,this),this.body.eventListeners.onDragStart=ie(d=this.onDragStart).call(d,this),this.body.eventListeners.onDrag=ie(l=this.onDrag).call(l,this),this.body.eventListeners.onDragEnd=ie(c=this.onDragEnd).call(c,this),this.body.eventListeners.onMouseWheel=ie(u=this.onMouseWheel).call(u,this),this.body.eventListeners.onPinch=ie(p=this.onPinch).call(p,this),this.body.eventListeners.onMouseMove=ie(f=this.onMouseMove).call(f,this),this.body.eventListeners.onRelease=ie(v=this.onRelease).call(v,this),this.body.eventListeners.onContext=ie(g=this.onContext).call(g,this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=ie(y=this.getPointer).call(y,this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},t.extend(this.options,this.defaultOptions),this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("destroy",(function(){clearTimeout(e.popupTimer),delete e.body.functions.getPointer}))}},{key:"setOptions",value:function(e){if(void 0!==e){t.selectiveNotDeepExtend(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"],this.options,e),t.mergeOptions(this.options,e,"keyboard"),e.tooltip&&(t.extend(this.options.tooltip,e.tooltip),e.tooltip.color&&(this.options.tooltip.color=t.parseColor(e.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(e){return{x:e.x-t.getAbsoluteLeft(this.canvas.frame.canvas),y:e.y-t.getAbsoluteTop(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(e){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(e.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}},{key:"onTap",value:function(e){var t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect&&(e.changedPointers[0].ctrlKey||e.changedPointers[0].metaKey);this.checkSelectionChanges(t,e,i),this.selectionHandler._generateClickEvent("click",e,t)}},{key:"onDoubleTap",value:function(e){var t=this.getPointer(e.center);this.selectionHandler._generateClickEvent("doubleClick",e,t)}},{key:"onHold",value:function(e){var t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(t,e,i),this.selectionHandler._generateClickEvent("click",e,t),this.selectionHandler._generateClickEvent("hold",e,t)}},{key:"onRelease",value:function(e){if((new Date).valueOf()-this.touchTime>10){var t=this.getPointer(e.center);this.selectionHandler._generateClickEvent("release",e,t),this.touchTime=(new Date).valueOf()}}},{key:"onContext",value:function(e){var t=this.getPointer({x:e.clientX,y:e.clientY});this.selectionHandler._generateClickEvent("oncontext",e,t)}},{key:"checkSelectionChanges",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=this.selectionHandler.getSelection(),n=!1;n=!0===i?this.selectionHandler.selectAdditionalOnPoint(e):this.selectionHandler.selectOnPoint(e);var s=this.selectionHandler.getSelection(),r=this._determineDifference(o,s),a=this._determineDifference(s,o);r.edges.length>0&&(this.selectionHandler._generateClickEvent("deselectEdge",t,e,o),n=!0),r.nodes.length>0&&(this.selectionHandler._generateClickEvent("deselectNode",t,e,o),n=!0),a.nodes.length>0&&(this.selectionHandler._generateClickEvent("selectNode",t,e),n=!0),a.edges.length>0&&(this.selectionHandler._generateClickEvent("selectEdge",t,e),n=!0),!0===n&&this.selectionHandler._generateClickEvent("select",t,e)}},{key:"_determineDifference",value:function(e,t){var i=function(e,t){for(var i=[],o=0;o<e.length;o++){var n=e[o];-1===Vi(t).call(t,n)&&i.push(n)}return i};return{nodes:i(e.nodes,t.nodes),edges:i(e.edges,t.edges)}}},{key:"onDragStart",value:function(e){void 0===this.drag.pointer&&this.onTouch(e);var i=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=t.extend({},this.body.view.translation),this.drag.nodeId=void 0,void 0!==i&&!0===this.options.dragNodes){this.drag.nodeId=i.id,!1===i.isSelected()&&(this.selectionHandler.unselectAll(),this.selectionHandler.selectObject(i)),this.selectionHandler._generateClickEvent("dragStart",e,this.drag.pointer);var o=this.selectionHandler.selectionObj.nodes;for(var n in o)if(o.hasOwnProperty(n)){var s=o[n],r={id:s.id,node:s,x:s.x,y:s.y,xFixed:s.options.fixed.x,yFixed:s.options.fixed.y};s.options.fixed.x=!0,s.options.fixed.y=!0,this.drag.selection.push(r)}}else this.selectionHandler._generateClickEvent("dragStart",e,this.drag.pointer,void 0,!0)}},{key:"onDrag",value:function(e){var t=this;if(!0!==this.drag.pinched){this.body.emitter.emit("unlockNode");var i=this.getPointer(e.center),o=this.drag.selection;if(o&&o.length&&!0===this.options.dragNodes){this.selectionHandler._generateClickEvent("dragging",e,i);var n=i.x-this.drag.pointer.x,s=i.y-this.drag.pointer.y;ri(o).call(o,(function(e){var i=e.node;!1===e.xFixed&&(i.x=t.canvas._XconvertDOMtoCanvas(t.canvas._XconvertCanvasToDOM(e.x)+n)),!1===e.yFixed&&(i.y=t.canvas._YconvertDOMtoCanvas(t.canvas._YconvertCanvasToDOM(e.y)+s))})),this.body.emitter.emit("startSimulation")}else if(!0===this.options.dragView){if(this.selectionHandler._generateClickEvent("dragging",e,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(e);var r=i.x-this.drag.pointer.x,a=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+r,y:this.drag.translation.y+a},this.body.emitter.emit("_requestRedraw")}}}},{key:"onDragEnd",value:function(e){this.drag.dragging=!1;var t=this.drag.selection;t&&t.length?(ri(t).call(t,(function(e){e.node.options.fixed.x=e.xFixed,e.node.options.fixed.y=e.yFixed})),this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}},{key:"onPinch",value:function(e){var t=this.getPointer(e.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);var i=this.pinch.scale*e.scale;this.zoom(i,t)}},{key:"zoom",value:function(e,t){if(!0===this.options.zoomView){var i=this.body.view.scale;e<1e-5&&(e=1e-5),e>10&&(e=10);var o=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(o=this.canvas.DOMtoCanvas(this.drag.pointer));var n=this.body.view.translation,s=e/i,r=(1-s)*t.x+n.x*s,a=(1-s)*t.y+n.y*s;if(this.body.view.scale=e,this.body.view.translation={x:r,y:a},null!=o){var h=this.canvas.canvasToDOM(o);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<e?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:t}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:t})}}},{key:"onMouseWheel",value:function(e){if(!0===this.options.zoomView){if(0!==e.deltaY){var t=this.body.view.scale;t*=1+(e.deltaY<0?1:-1)*(.1*this.options.zoomSpeed);var i=this.getPointer({x:e.clientX,y:e.clientY});this.zoom(t,i)}e.preventDefault()}}},{key:"onMouseMove",value:function(e){var t=this,i=this.getPointer({x:e.clientX,y:e.clientY}),o=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(i),!1===this.popup.hidden&&(o=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===o&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=rr((function(){return t._checkShowPopup(i)}),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(e,i)}},{key:"_checkShowPopup",value:function(e){var t=this.canvas._XconvertDOMtoCanvas(e.x),i=this.canvas._YconvertDOMtoCanvas(e.y),o={left:t,top:i,right:t,bottom:i},n=void 0===this.popupObj?void 0:this.popupObj.id,s=!1,r="node";if(void 0===this.popupObj){for(var a,h=this.body.nodeIndices,d=this.body.nodes,l=[],c=0;c<h.length;c++)!0===(a=d[h[c]]).isOverlappingWith(o)&&(s=!0,void 0!==a.getTitle()&&l.push(h[c]));l.length>0&&(this.popupObj=d[l[l.length-1]],s=!0)}if(void 0===this.popupObj&&!1===s){for(var u,p=this.body.edgeIndices,f=this.body.edges,v=[],g=0;g<p.length;g++)!0===(u=f[p[g]]).isOverlappingWith(o)&&!0===u.connected&&void 0!==u.getTitle()&&v.push(p[g]);v.length>0&&(this.popupObj=f[v[v.length-1]],r="edge")}void 0!==this.popupObj?this.popupObj.id!==n&&(void 0===this.popup&&(this.popup=new xl(this.canvas.frame)),this.popup.popupTargetType=r,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(e.x+3,e.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(e){var t=this.selectionHandler._pointerToPositionObject(e),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&!0===(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(t))){var o=this.selectionHandler.getNodeAt(e);i=void 0!==o&&o.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(e)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(t));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),e}(),Ol=function(){function e(i,o){var n=this;Ks(this,e),this.body=i,this.canvas=o,this.selectionObj={nodes:[],edges:[]},this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},t.extend(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",(function(){n.updateSelection()}))}return Qs(e,[{key:"setOptions",value:function(e){if(void 0!==e){t.selectiveDeepExtend(["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"],this.options,e)}}},{key:"selectOnPoint",value:function(e){var t=!1;if(!0===this.options.selectable){var i=this.getNodeAt(e)||this.getEdgeAt(e);this.unselectAll(),void 0!==i&&(t=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return t}},{key:"selectAdditionalOnPoint",value:function(e){var t=!1;if(!0===this.options.selectable){var i=this.getNodeAt(e)||this.getEdgeAt(e);void 0!==i&&(t=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return t}},{key:"_initBaseEvent",value:function(e,t){var i={};return i.pointer={DOM:{x:t.x,y:t.y},canvas:this.canvas.DOMtoCanvas(t)},i.event=e,i}},{key:"_generateClickEvent",value:function(e,t,i,o){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4],s=this._initBaseEvent(t,i);if(!0===n)s.nodes=[],s.edges=[];else{var r=this.getSelection();s.nodes=r.nodes,s.edges=r.edges}void 0!==o&&(s.previousSelection=o),"click"==e&&(s.items=this.getClickedItems(i)),void 0!==t.controlEdge&&(s.controlEdge=t.controlEdge),this.body.emitter.emit(e,s)}},{key:"selectObject",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.selectConnectedEdges;return void 0!==e&&(e instanceof ud&&!0===t&&this._selectConnectedEdges(e),e.select(),this._addToSelection(e),!0)}},{key:"deselectObject",value:function(e){!0===e.isSelected()&&(e.selected=!1,this._removeFromSelection(e))}},{key:"_getAllNodesOverlappingWith",value:function(e){for(var t=[],i=this.body.nodes,o=0;o<this.body.nodeIndices.length;o++){var n=this.body.nodeIndices[o];i[n].isOverlappingWith(e)&&t.push(n)}return t}},{key:"_pointerToPositionObject",value:function(e){var t=this.canvas.DOMtoCanvas(e);return{left:t.x-1,top:t.y+1,right:t.x+1,bottom:t.y-1}}},{key:"getNodeAt",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._pointerToPositionObject(e),o=this._getAllNodesOverlappingWith(i);return o.length>0?!0===t?this.body.nodes[o[o.length-1]]:o[o.length-1]:void 0}},{key:"_getEdgesOverlappingWith",value:function(e,t){for(var i=this.body.edges,o=0;o<this.body.edgeIndices.length;o++){var n=this.body.edgeIndices[o];i[n].isOverlappingWith(e)&&t.push(n)}}},{key:"_getAllEdgesOverlappingWith",value:function(e){var t=[];return this._getEdgesOverlappingWith(e,t),t}},{key:"getEdgeAt",value:function(e){for(var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.canvas.DOMtoCanvas(e),o=10,n=null,s=this.body.edges,r=0;r<this.body.edgeIndices.length;r++){var a=this.body.edgeIndices[r],h=s[a];if(h.connected){var d=h.from.x,l=h.from.y,c=h.to.x,u=h.to.y,p=h.edgeType.getDistanceToEdge(d,l,c,u,i.x,i.y);p<o&&(n=a,o=p)}}return null!==n?!0===t?this.body.edges[n]:n:void 0}},{key:"_addToSelection",value:function(e){e instanceof ud?this.selectionObj.nodes[e.id]=e:this.selectionObj.edges[e.id]=e}},{key:"_addToHover",value:function(e){e instanceof ud?this.hoverObj.nodes[e.id]=e:this.hoverObj.edges[e.id]=e}},{key:"_removeFromSelection",value:function(e){e instanceof ud?(delete this.selectionObj.nodes[e.id],this._unselectConnectedEdges(e)):delete this.selectionObj.edges[e.id]}},{key:"unselectAll",value:function(){for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&this.selectionObj.nodes[e].unselect();for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&this.selectionObj.edges[t].unselect();this.selectionObj={nodes:{},edges:{}}}},{key:"_getSelectedNodeCount",value:function(){var e=0;for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(e+=1);return e}},{key:"_getSelectedNode",value:function(){for(var e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e))return this.selectionObj.nodes[e]}},{key:"_getSelectedEdge",value:function(){for(var e in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(e))return this.selectionObj.edges[e]}},{key:"_getSelectedEdgeCount",value:function(){var e=0;for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&(e+=1);return e}},{key:"_getSelectedObjectCount",value:function(){var e=0;for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(e+=1);for(var i in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(i)&&(e+=1);return e}},{key:"_selectionIsEmpty",value:function(){for(var e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e))return!1;for(var t in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(t))return!1;return!0}},{key:"_clusterInSelection",value:function(){for(var e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e)&&this.selectionObj.nodes[e].clusterSize>1)return!0;return!1}},{key:"_selectConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.select(),this._addToSelection(i)}}},{key:"_hoverConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.hover=!0,this._addToHover(i)}}},{key:"_unselectConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.unselect(),this._removeFromSelection(i)}}},{key:"emitBlurEvent",value:function(e,t,i){var o=this._initBaseEvent(e,t);!0===i.hover&&(i.hover=!1,i instanceof ud?(o.node=i.id,this.body.emitter.emit("blurNode",o)):(o.edge=i.id,this.body.emitter.emit("blurEdge",o)))}},{key:"emitHoverEvent",value:function(e,t,i){var o=this._initBaseEvent(e,t),n=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),n=!0,i instanceof ud?(o.node=i.id,this.body.emitter.emit("hoverNode",o)):(o.edge=i.id,this.body.emitter.emit("hoverEdge",o))),n}},{key:"hoverObject",value:function(e,t){var i=this.getNodeAt(t);void 0===i&&(i=this.getEdgeAt(t));var o=!1;for(var n in this.hoverObj.nodes)this.hoverObj.nodes.hasOwnProperty(n)&&(void 0===i||i instanceof ud&&i.id!=n||i instanceof Yd)&&(this.emitBlurEvent(e,t,this.hoverObj.nodes[n]),delete this.hoverObj.nodes[n],o=!0);for(var s in this.hoverObj.edges)this.hoverObj.edges.hasOwnProperty(s)&&(!0===o?(this.hoverObj.edges[s].hover=!1,delete this.hoverObj.edges[s]):(void 0===i||i instanceof Yd&&i.id!=s||i instanceof ud&&!i.hover)&&(this.emitBlurEvent(e,t,this.hoverObj.edges[s]),delete this.hoverObj.edges[s],o=!0));if(void 0!==i){var r=kr(this.hoverObj.edges).length,a=kr(this.hoverObj.nodes).length;(o||i instanceof Yd&&0===r&&0===a||i instanceof ud&&0===r&&0===a)&&(o=this.emitHoverEvent(e,t,i)),i instanceof ud&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===o&&this.body.emitter.emit("_requestRedraw")}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodes(),edges:this.getSelectedEdges()}}},{key:"getSelectedNodes",value:function(){var e=[];if(!0===this.options.selectable)for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&e.push(this.selectionObj.nodes[t].id);return e}},{key:"getSelectedEdges",value:function(){var e=[];if(!0===this.options.selectable)for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&e.push(this.selectionObj.edges[t].id);return e}},{key:"setSelection",value:function(e){var t,i,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!e||!e.nodes&&!e.edges)throw"Selection must be an object with nodes and/or edges properties";if((o.unselectAll||void 0===o.unselectAll)&&this.unselectAll(),e.nodes)for(t=0;t<e.nodes.length;t++){i=e.nodes[t];var n=this.body.nodes[i];if(!n)throw new RangeError('Node with id "'+i+'" not found');this.selectObject(n,o.highlightEdges)}if(e.edges)for(t=0;t<e.edges.length;t++){i=e.edges[t];var s=this.body.edges[i];if(!s)throw new RangeError('Edge with id "'+i+'" not found');this.selectObject(s)}this.body.emitter.emit("_requestRedraw")}},{key:"selectNodes",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(!e||void 0===e.length)throw"Selection must be an array with ids";this.setSelection({nodes:e},{highlightEdges:t})}},{key:"selectEdges",value:function(e){if(!e||void 0===e.length)throw"Selection must be an array with ids";this.setSelection({edges:e})}},{key:"updateSelection",value:function(){for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(this.body.nodes.hasOwnProperty(e)||delete this.selectionObj.nodes[e]);for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&(this.body.edges.hasOwnProperty(t)||delete this.selectionObj.edges[t])}},{key:"getClickedItems",value:function(e){for(var t=this.canvas.DOMtoCanvas(e),i=[],o=this.body.nodeIndices,n=this.body.nodes,s=o.length-1;s>=0;s--){var r=n[o[s]].getItemsOnPoint(t);i.push.apply(i,r)}for(var a=this.body.edgeIndices,h=this.body.edges,d=a.length-1;d>=0;d--){var l=h[a[d]].getItemsOnPoint(t);i.push.apply(i,l)}return i}}]),e}(),Cl=!l((function(){return Object.isExtensible(Object.preventExtensions({}))})),Tl=r((function(e){var t=q.f,i=_e("meta"),o=0,n=Object.isExtensible||function(){return!0},s=function(e){t(e,i,{value:{objectID:"O"+ ++o,weakData:{}}})},r=e.exports={REQUIRED:!1,fastKey:function(e,t){if(!_(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!O(e,i)){if(!n(e))return"F";if(!t)return"E";s(e)}return e[i].objectID},getWeakData:function(e,t){if(!O(e,i)){if(!n(e))return!0;if(!t)return!1;s(e)}return e[i].weakData},onFreeze:function(e){return Cl&&r.REQUIRED&&n(e)&&!O(e,i)&&s(e),e}};Oe[i]=!0})),Sl=(Tl.REQUIRED,Tl.fastKey,Tl.getWeakData,Tl.onFreeze,Ye("iterator")),Ml=Array.prototype,Dl=function(e,t,i,o){try{return o?t(W(i)[0],i[1]):t(i)}catch(t){var n=e.return;throw void 0!==n&&W(n.call(e)),t}},Il=r((function(e){var t=function(e,t){this.stopped=e,this.result=t};(e.exports=function(e,i,o,n,s){var r,a,h,d,l,c,u,p,f=H(i,o,n?2:1);if(s)r=e;else{if("function"!=typeof(a=ur(e)))throw TypeError("Target is not iterable");if(void 0!==(p=a)&&(le.Array===p||Ml[Sl]===p)){for(h=0,d=et(e.length);d>h;h++)if((l=n?f(W(u=e[h])[0],u[1]):f(e[h]))&&l instanceof t)return l;return new t(!1)}r=a.call(e)}for(c=r.next;!(u=c.call(r)).done;)if("object"==typeof(l=Dl(r,f,u.value,n))&&l&&l instanceof t)return l;return new t(!1)}).stop=function(e){return new t(!0,e)}})),Pl=function(e,t,i){if(!(e instanceof t))throw TypeError("Incorrect "+(i?i+" ":"")+"invocation");return e},Fl=q.f,Bl=Gt.forEach,zl=ze.set,Nl=ze.getterFor,Al=function(e,t,i){var o,n=-1!==e.indexOf("Map"),s=-1!==e.indexOf("Weak"),r=n?"set":"add",a=d[e],h=a&&a.prototype,u={};if(c&&"function"==typeof a&&(s||h.forEach&&!l((function(){(new a).entries().next()})))){o=t((function(t,i){zl(Pl(t,o,e),{type:e,collection:new a}),null!=i&&Il(i,t[r],t,n)}));var p=Nl(e);Bl(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(e){var t="add"==e||"set"==e;e in h&&(!s||"clear"!=e)&&U(o.prototype,e,(function(i,o){var n=p(this).collection;if(!t&&s&&!_(i))return"get"==e&&void 0;var r=n[e](0===i?0:i,o);return t?this:r}))})),s||Fl(o.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else o=i.getConstructor(t,e,n,r),Tl.REQUIRED=!0;return Tt(o,e,!1,!0),u[e]=o,G({global:!0,forced:!0},u),s||i.setStrong(o,e,n),o},Rl=function(e,t,i){for(var o in t)i&&i.unsafe&&e[o]?e[o]=t[o]:It(e,o,t[o],i);return e},Ll=Ye("species"),jl=q.f,Hl=Tl.fastKey,Wl=ze.set,Vl=ze.getterFor,ql={getConstructor:function(e,t,i,o){var n=e((function(e,s){Pl(e,n,t),Wl(e,{type:t,index:mt(null),first:void 0,last:void 0,size:0}),c||(e.size=0),null!=s&&Il(s,e[o],e,i)})),s=Vl(t),r=function(e,t,i){var o,n,r=s(e),h=a(e,t);return h?h.value=i:(r.last=h={index:n=Hl(t,!0),key:t,value:i,previous:o=r.last,next:void 0,removed:!1},r.first||(r.first=h),o&&(o.next=h),c?r.size++:e.size++,"F"!==n&&(r.index[n]=h)),e},a=function(e,t){var i,o=s(e),n=Hl(t);if("F"!==n)return o.index[n];for(i=o.first;i;i=i.next)if(i.key==t)return i};return Rl(n.prototype,{clear:function(){for(var e=s(this),t=e.index,i=e.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete t[i.index],i=i.next;e.first=e.last=void 0,c?e.size=0:this.size=0},delete:function(e){var t=s(this),i=a(this,e);if(i){var o=i.next,n=i.previous;delete t.index[i.index],i.removed=!0,n&&(n.next=o),o&&(o.previous=n),t.first==i&&(t.first=o),t.last==i&&(t.last=n),c?t.size--:this.size--}return!!i},forEach:function(e){for(var t,i=s(this),o=H(e,arguments.length>1?arguments[1]:void 0,3);t=t?t.next:i.first;)for(o(t.value,t.key,this);t&&t.removed;)t=t.previous},has:function(e){return!!a(this,e)}}),Rl(n.prototype,i?{get:function(e){var t=a(this,e);return t&&t.value},set:function(e,t){return r(this,0===e?0:e,t)}}:{add:function(e){return r(this,e=0===e?0:e,e)}}),c&&jl(n.prototype,"size",{get:function(){return s(this).size}}),n},setStrong:function(e,t,i){var o=t+" Iterator",n=Vl(t),s=Vl(o);Nt(e,t,(function(e,t){Wl(this,{type:o,target:e,state:n(e),kind:t,last:void 0})}),(function(){for(var e=s(this),t=e.kind,i=e.last;i&&i.removed;)i=i.previous;return e.target&&(e.last=i=i?i.next:e.state.first)?"keys"==t?{value:i.key,done:!1}:"values"==t?{value:i.value,done:!1}:{value:[i.key,i.value],done:!1}:(e.target=void 0,{value:void 0,done:!0})}),i?"entries":"values",!i,!0),function(e){var t=ut(e),i=q.f;c&&t&&!t[Ll]&&i(t,Ll,{configurable:!0,get:function(){return this}})}(t)}},Ul=(Al("Map",(function(e){return function(){return e(this,arguments.length?arguments[0]:void 0)}}),ql),L.Map),Yl=function(e){return function(t,i,o,n){j(i);var s=Ne(t),r=b(s),a=et(s.length),h=e?a-1:0,d=e?-1:1;if(o<2)for(;;){if(h in r){n=r[h],h+=d;break}if(h+=d,e?h<0:a<=h)throw TypeError("Reduce of empty array with no initial value")}for(;e?h>=0:a>h;h+=d)h in r&&(n=i(n,r[h],h,s));return n}},Xl={left:Yl(!1),right:Yl(!0)}.left,Gl=Kt("reduce"),Kl=Jt("reduce",{1:0});G({target:"Array",proto:!0,forced:!Gl||!Kl},{reduce:function(e){return Xl(this,e,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Zl=Q("Array").reduce,$l=Array.prototype,Jl=function(e){var t=e.reduce;return e===$l||e instanceof Array&&t===$l.reduce?Zl:t},Ql=[],ec=Ql.sort,tc=l((function(){Ql.sort(void 0)})),ic=l((function(){Ql.sort(null)})),oc=Kt("sort");G({target:"Array",proto:!0,forced:tc||!ic||!oc},{sort:function(e){return void 0===e?ec.call(Ne(this)):ec.call(Ne(this),j(e))}});var nc,sc=Q("Array").sort,rc=Array.prototype,ac=function(e){var t=e.sort;return e===rc||e instanceof Array&&t===rc.sort?sc:t},hc=r((function(e,t){!function(e){e.__esModule=!0,e.sort=function(e,i,o,n){if(!Array.isArray(e))throw new TypeError("Can only sort arrays");i?"function"!=typeof i&&(n=o,o=i,i=r):i=r,o||(o=0),n||(n=e.length);var s=n-o;if(!(s<2)){var d=0;if(s<t)return d=a(e,o,n,i),void h(e,o,n,o+d,i);var l=new c(e,i),u=function(e){for(var i=0;e>=t;)i|=1&e,e>>=1;return e+i}(s);do{if((d=a(e,o,n,i))<u){var p=s;p>u&&(p=u),h(e,o,o+p,o+d,i),d=p}l.pushRun(o,d),l.mergeRuns(),s-=d,o+=d}while(0!==s);l.forceMergeRuns()}};var t=32,i=7,o=256,n=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9];function s(e){return e<1e5?e<100?e<10?0:1:e<1e4?e<1e3?2:3:4:e<1e7?e<1e6?5:6:e<1e9?e<1e8?7:8:9}function r(e,t){if(e===t)return 0;if(~~e===e&&~~t===t){if(0===e||0===t)return e<t?-1:1;if(e<0||t<0){if(t>=0)return-1;if(e>=0)return 1;e=-e,t=-t}var i=s(e),o=s(t),r=0;return i<o?(e*=n[o-i-1],t/=10,r=-1):i>o&&(t*=n[i-o-1],e/=10,r=1),e===t?r:e<t?-1:1}var a=String(e),h=String(t);return a===h?0:a<h?-1:1}function a(e,t,i,o){var n=t+1;if(n===i)return 1;if(o(e[n++],e[t])<0){for(;n<i&&o(e[n],e[n-1])<0;)n++;!function(e,t,i){for(i--;t<i;){var o=e[t];e[t++]=e[i],e[i--]=o}}(e,t,n)}else for(;n<i&&o(e[n],e[n-1])>=0;)n++;return n-t}function h(e,t,i,o,n){for(o===t&&o++;o<i;o++){for(var s=e[o],r=t,a=o;r<a;){var h=r+a>>>1;n(s,e[h])<0?a=h:r=h+1}var d=o-r;switch(d){case 3:e[r+3]=e[r+2];case 2:e[r+2]=e[r+1];case 1:e[r+1]=e[r];break;default:for(;d>0;)e[r+d]=e[r+d-1],d--}e[r]=s}}function d(e,t,i,o,n,s){var r=0,a=0,h=1;if(s(e,t[i+n])>0){for(a=o-n;h<a&&s(e,t[i+n+h])>0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),r+=n,h+=n}else{for(a=n+1;h<a&&s(e,t[i+n-h])<=0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var d=r;r=n-h,h=n-d}for(r++;r<h;){var l=r+(h-r>>>1);s(e,t[i+l])>0?r=l+1:h=l}return h}function l(e,t,i,o,n,s){var r=0,a=0,h=1;if(s(e,t[i+n])<0){for(a=n+1;h<a&&s(e,t[i+n-h])<0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var d=r;r=n-h,h=n-d}else{for(a=o-n;h<a&&s(e,t[i+n+h])>=0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),r+=n,h+=n}for(r++;r<h;){var l=r+(h-r>>>1);s(e,t[i+l])<0?h=l:r=l+1}return h}var c=function(){function e(t,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.array=null,this.compare=null,this.minGallop=i,this.length=0,this.tmpStorageLength=o,this.stackLength=0,this.runStart=null,this.runLength=null,this.stackSize=0,this.array=t,this.compare=n,this.length=t.length,this.length<2*o&&(this.tmpStorageLength=this.length>>>1),this.tmp=new Array(this.tmpStorageLength),this.stackLength=this.length<120?5:this.length<1542?10:this.length<119151?19:40,this.runStart=new Array(this.stackLength),this.runLength=new Array(this.stackLength)}return e.prototype.pushRun=function(e,t){this.runStart[this.stackSize]=e,this.runLength[this.stackSize]=t,this.stackSize+=1},e.prototype.mergeRuns=function(){for(;this.stackSize>1;){var e=this.stackSize-2;if(e>=1&&this.runLength[e-1]<=this.runLength[e]+this.runLength[e+1]||e>=2&&this.runLength[e-2]<=this.runLength[e]+this.runLength[e-1])this.runLength[e-1]<this.runLength[e+1]&&e--;else if(this.runLength[e]>this.runLength[e+1])break;this.mergeAt(e)}},e.prototype.forceMergeRuns=function(){for(;this.stackSize>1;){var e=this.stackSize-2;e>0&&this.runLength[e-1]<this.runLength[e+1]&&e--,this.mergeAt(e)}},e.prototype.mergeAt=function(e){var t=this.compare,i=this.array,o=this.runStart[e],n=this.runLength[e],s=this.runStart[e+1],r=this.runLength[e+1];this.runLength[e]=n+r,e===this.stackSize-3&&(this.runStart[e+1]=this.runStart[e+2],this.runLength[e+1]=this.runLength[e+2]),this.stackSize--;var a=l(i[s],i,o,n,0,t);o+=a,0!=(n-=a)&&0!==(r=d(i[o+n-1],i,s,r,r-1,t))&&(n<=r?this.mergeLow(o,n,s,r):this.mergeHigh(o,n,s,r))},e.prototype.mergeLow=function(e,t,o,n){var s=this.compare,r=this.array,a=this.tmp,h=0;for(h=0;h<t;h++)a[h]=r[e+h];var c=0,u=o,p=e;if(r[p++]=r[u++],0!=--n)if(1!==t){for(var f=this.minGallop;;){var v=0,g=0,y=!1;do{if(s(r[u],a[c])<0){if(r[p++]=r[u++],g++,v=0,0==--n){y=!0;break}}else if(r[p++]=a[c++],v++,g=0,1==--t){y=!0;break}}while((v|g)<f);if(y)break;do{if(0!==(v=l(r[u],a,c,t,0,s))){for(h=0;h<v;h++)r[p+h]=a[c+h];if(p+=v,c+=v,(t-=v)<=1){y=!0;break}}if(r[p++]=r[u++],0==--n){y=!0;break}if(0!==(g=d(a[c],r,u,n,0,s))){for(h=0;h<g;h++)r[p+h]=r[u+h];if(p+=g,u+=g,0==(n-=g)){y=!0;break}}if(r[p++]=a[c++],1==--t){y=!0;break}f--}while(v>=i||g>=i);if(y)break;f<0&&(f=0),f+=2}if(this.minGallop=f,f<1&&(this.minGallop=1),1===t){for(h=0;h<n;h++)r[p+h]=r[u+h];r[p+n]=a[c]}else{if(0===t)throw new Error("mergeLow preconditions were not respected");for(h=0;h<t;h++)r[p+h]=a[c+h]}}else{for(h=0;h<n;h++)r[p+h]=r[u+h];r[p+n]=a[c]}else for(h=0;h<t;h++)r[p+h]=a[c+h]},e.prototype.mergeHigh=function(e,t,o,n){var s=this.compare,r=this.array,a=this.tmp,h=0;for(h=0;h<n;h++)a[h]=r[o+h];var c=e+t-1,u=n-1,p=o+n-1,f=0,v=0;if(r[p--]=r[c--],0!=--t)if(1!==n){for(var g=this.minGallop;;){var y=0,m=0,b=!1;do{if(s(a[u],r[c])<0){if(r[p--]=r[c--],y++,m=0,0==--t){b=!0;break}}else if(r[p--]=a[u--],m++,y=0,1==--n){b=!0;break}}while((y|m)<g);if(b)break;do{if(0!=(y=t-l(a[u],r,e,t,t-1,s))){for(t-=y,v=1+(p-=y),f=1+(c-=y),h=y-1;h>=0;h--)r[v+h]=r[f+h];if(0===t){b=!0;break}}if(r[p--]=a[u--],1==--n){b=!0;break}if(0!=(m=n-d(r[c],a,0,n,n-1,s))){for(n-=m,v=1+(p-=m),f=1+(u-=m),h=0;h<m;h++)r[v+h]=a[f+h];if(n<=1){b=!0;break}}if(r[p--]=r[c--],0==--t){b=!0;break}g--}while(y>=i||m>=i);if(b)break;g<0&&(g=0),g+=2}if(this.minGallop=g,g<1&&(this.minGallop=1),1===n){for(v=1+(p-=t),f=1+(c-=t),h=t-1;h>=0;h--)r[v+h]=r[f+h];r[p]=a[u]}else{if(0===n)throw new Error("mergeHigh preconditions were not respected");for(f=p-(n-1),h=0;h<n;h++)r[f+h]=a[h]}}else{for(v=1+(p-=t),f=1+(c-=t),h=t-1;h>=0;h--)r[v+h]=r[f+h];r[p]=a[u]}else for(f=p-(n-1),h=0;h<n;h++)r[f+h]=a[h]},e}()}(t)}));(nc=hc)&&nc.__esModule&&Object.prototype.hasOwnProperty.call(nc,"default")&&nc.default;var dc=hc,lc=dc.sort,cc=function(){function e(){Ks(this,e)}return Qs(e,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(e){return this.fake_use(e),this.abstract()}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;this.fake_use(e,t,i),this.abstract()}},{key:"getTreeSize",value:function(e){return this.fake_use(e),this.abstract()}},{key:"sort",value:function(e){this.fake_use(e),this.abstract()}},{key:"fix",value:function(e,t){this.fake_use(e,t),this.abstract()}},{key:"shift",value:function(e,t){this.fake_use(e,t),this.abstract()}}]),e}(),uc=function(e){function t(e){var i;return Ks(this,t),(i=Oh(this,Mh(t).call(this))).layout=e,i}return Ph(t,e),Qs(t,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(e){return e.x}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(e,i),e.x=t}},{key:"getTreeSize",value:function(e){var t=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,e);return{min:t.min_x,max:t.max_x}}},{key:"sort",value:function(e){lc(e,(function(e,t){return e.x-t.x}))}},{key:"fix",value:function(e,t){e.y=this.layout.options.hierarchical.levelSeparation*t,e.options.fixed.y=!0}},{key:"shift",value:function(e,t){this.layout.body.nodes[e].x+=t}}]),t}(cc),pc=function(e){function t(e){var i;return Ks(this,t),(i=Oh(this,Mh(t).call(this))).layout=e,i}return Ph(t,e),Qs(t,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(e){return e.y}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(e,i),e.y=t}},{key:"getTreeSize",value:function(e){var t=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,e);return{min:t.min_y,max:t.max_y}}},{key:"sort",value:function(e){lc(e,(function(e,t){return e.y-t.y}))}},{key:"fix",value:function(e,t){e.x=this.layout.options.hierarchical.levelSeparation*t,e.options.fixed.x=!0}},{key:"shift",value:function(e,t){this.layout.body.nodes[e].y+=t}}]),t}(cc),fc=Gt.every,vc=Kt("every"),gc=Jt("every");G({target:"Array",proto:!0,forced:!vc||!gc},{every:function(e){return fc(this,e,arguments.length>1?arguments[1]:void 0)}});var yc=Q("Array").every,mc=Array.prototype,bc=function(e){var t=e.every;return e===mc||e instanceof Array&&t===mc.every?yc:t},wc=(Al("Set",(function(e){return function(){return e(this,arguments.length?arguments[0]:void 0)}}),ql),L.Set);function kc(e,t){var i=new wc;return ri(e).call(e,(function(e){var t;ri(t=e.edges).call(t,(function(e){e.connected&&i.add(e)}))})),ri(i).call(i,(function(e){var i=e.from.id,o=e.to.id;null==t[i]&&(t[i]=0),(null==t[o]||t[i]>=t[o])&&(t[o]=t[i]+1)})),t}function _c(e,t,i,o,n){var s=o.size,r=i+"Id",a="to"===i?1:-1,h=!0,d=!1,l=void 0;try{for(var c,u=function(){var h=qa(c.value,2),d=h[0],l=h[1];if(!o.has(d)||!e(l))return"continue";n[d]=0;for(var u=[l],p=0,f=void 0,v=function(){var e,h;if(!o.has(d))return"continue";var l=n[f.id]+a;if(ri(e=Rr(h=f.edges).call(h,(function(e){return e.connected&&e.to!==e.from&&e[i]!==f&&o.has(e.toId)&&o.has(e.fromId)}))).call(e,(function(e){var o=e[r],s=n[o];(null==s||t(l,s))&&(n[o]=l,u.push(e[i]))})),p>s)return{v:{v:kc(o,n)}};++p};f=u.pop();){var g=v();switch(g){case"continue":continue;default:if("object"===eh(g))return g.v}}},p=pr(o);!(h=(c=p.next()).done);h=!0){var f=u();switch(f){case"continue":continue;default:if("object"===eh(f))return f.v}}}catch(e){d=!0,l=e}finally{try{h||null==p.return||p.return()}finally{if(d)throw l}}return n}var xc=function(){function e(){Ks(this,e),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return Qs(e,[{key:"addRelation",value:function(e,t){void 0===this.childrenReference[e]&&(this.childrenReference[e]=[]),this.childrenReference[e].push(t),void 0===this.parentReference[t]&&(this.parentReference[t]=[]),this.parentReference[t].push(e)}},{key:"checkIfTree",value:function(){for(var e in this.parentReference)if(this.parentReference[e].length>1)return void(this.isTree=!1);this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(e,t){void 0!==t&&void 0===this.trees[e.id]&&(this.trees[e.id]=t,this.treeIndex=Math.max(t,this.treeIndex))}},{key:"ensureLevel",value:function(e){void 0===this.levels[e]&&(this.levels[e]=0)}},{key:"getMaxLevel",value:function(e){var t=this,i={};return function e(o){if(void 0!==i[o])return i[o];var n=t.levels[o];if(t.childrenReference[o]){var s=t.childrenReference[o];if(s.length>0)for(var r=0;r<s.length;r++)n=Math.max(n,e(s[r]))}return i[o]=n,n}(e)}},{key:"levelDownstream",value:function(e,t){void 0===this.levels[t.id]&&(void 0===this.levels[e.id]&&(this.levels[e.id]=0),this.levels[t.id]=this.levels[e.id]+1)}},{key:"setMinLevelToZero",value:function(e){var t=1e9;for(var i in e)e.hasOwnProperty(i)&&void 0!==this.levels[i]&&(t=Math.min(this.levels[i],t));for(var o in e)e.hasOwnProperty(o)&&void 0!==this.levels[o]&&(this.levels[o]-=t)}},{key:"getTreeSize",value:function(e,t){var i=1e9,o=-1e9,n=1e9,s=-1e9;for(var r in this.trees)if(this.trees.hasOwnProperty(r)&&this.trees[r]===t){var a=e[r];i=Math.min(a.x,i),o=Math.max(a.x,o),n=Math.min(a.y,n),s=Math.max(a.y,s)}return{min_x:i,max_x:o,min_y:n,max_y:s}}},{key:"hasSameParent",value:function(e,t){var i=this.parentReference[e.id],o=this.parentReference[t.id];if(void 0===i||void 0===o)return!1;for(var n=0;n<i.length;n++)for(var s=0;s<o.length;s++)if(i[n]==o[s])return!0;return!1}},{key:"inSameSubNetwork",value:function(e,t){return this.trees[e.id]===this.trees[t.id]}},{key:"getLevels",value:function(){return kr(this.distributionOrdering)}},{key:"addToOrdering",value:function(e,t){void 0===this.distributionOrdering[t]&&(this.distributionOrdering[t]=[]);var i=!1,o=this.distributionOrdering[t];for(var n in o)if(o[n]===e){i=!0;break}i||(this.distributionOrdering[t].push(e),this.distributionIndex[e.id]=this.distributionOrdering[t].length-1)}}]),e}(),Ec=function(){function e(i){Ks(this,e),this.body=i,this._resetRNG(Math.random()+":"+Gd()),this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},t.extend(this.options,this.defaultOptions),this.bindEventListeners()}return Qs(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("_dataChanged",(function(){e.setupHierarchicalLayout()})),this.body.emitter.on("_dataLoaded",(function(){e.layoutNetwork()})),this.body.emitter.on("_resetHierarchicalLayout",(function(){e.setupHierarchicalLayout()})),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",(function(){if(!0===e.options.hierarchical.enabled){var t=e.direction.curveType();e.body.emitter.emit("_forceDisableDynamicCurves",t,!1)}}))}},{key:"setOptions",value:function(e,i){if(void 0!==e){var o=this.options.hierarchical,n=o.enabled;if(t.selectiveDeepExtend(["randomSeed","improvedLayout","clusterThreshold"],this.options,e),t.mergeOptions(this.options,e,"hierarchical"),void 0!==e.randomSeed&&this._resetRNG(e.randomSeed),!0===o.enabled)return!0===n&&this.body.emitter.emit("refresh",!0),"RL"===o.direction||"DU"===o.direction?o.levelSeparation>0&&(o.levelSeparation*=-1):o.levelSeparation<0&&(o.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(i);if(!0===n)return this.body.emitter.emit("refresh"),t.deepExtend(i,this.optionsBackup)}return i}},{key:"_resetRNG",value:function(e){this.initialRandomSeed=e,this._rng=t.Alea(this.initialRandomSeed)}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(e){if(!0===this.options.hierarchical.enabled){var t=this.optionsBackup.physics;void 0===e.physics||!0===e.physics?(e.physics={enabled:void 0===t.enabled||t.enabled,solver:"hierarchicalRepulsion"},t.enabled=void 0===t.enabled||t.enabled,t.solver=t.solver||"barnesHut"):"object"===eh(e.physics)?(t.enabled=void 0===e.physics.enabled||e.physics.enabled,t.solver=e.physics.solver||"barnesHut",e.physics.solver="hierarchicalRepulsion"):!1!==e.physics&&(t.solver="barnesHut",e.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(void 0===e.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges={smooth:!1};else if(void 0===e.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges.smooth=!1;else if("boolean"==typeof e.edges.smooth)this.optionsBackup.edges={smooth:e.edges.smooth},e.edges.smooth={enabled:e.edges.smooth,type:i};else{var o=e.edges.smooth;void 0!==o.type&&"dynamic"!==o.type&&(i=o.type),this.optionsBackup.edges={smooth:void 0===o.enabled||o.enabled,type:void 0===o.type?"dynamic":o.type,roundness:void 0===o.roundness?.5:o.roundness,forceDirection:void 0!==o.forceDirection&&o.forceDirection},e.edges.smooth={enabled:void 0===o.enabled||o.enabled,type:i,roundness:void 0===o.roundness?.5:o.roundness,forceDirection:void 0!==o.forceDirection&&o.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return e}},{key:"positionInitially",value:function(e){if(!0!==this.options.hierarchical.enabled){this._resetRNG(this.initialRandomSeed);for(var t=e.length+50,i=0;i<e.length;i++){var o=e[i],n=2*Math.PI*this._rng();void 0===o.x&&(o.x=t*Math.cos(n)),void 0===o.y&&(o.y=t*Math.sin(n))}}}},{key:"layoutNetwork",value:function(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){for(var e=this.body.nodeIndices,t=0,i=0;i<e.length;i++){!0===this.body.nodes[e[i]].predefinedPosition&&(t+=1)}if(t<.5*e.length){var o=0,n=this.options.clusterThreshold,s={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(e.length>n){for(var r=e.length;e.length>n&&o<=10;){o+=1;var a=e.length;if(o%3==0?this.body.modules.clustering.clusterBridges(s):this.body.modules.clustering.clusterOutliers(s),a==e.length&&o%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*r)})}o>10&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(e,this.body.edgeIndices,!0),this._shiftToCenter();for(var h=0;h<e.length;h++){var d=this.body.nodes[e[h]];!1===d.predefinedPosition&&(d.x+=70*(.5-this._rng()),d.y+=70*(.5-this._rng()))}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var e=cl.getRangeCore(this.body.nodes,this.body.nodeIndices),t=cl.findCenter(e),i=0;i<this.body.nodeIndices.length;i++){var o=this.body.nodes[this.body.nodeIndices[i]];o.x-=t.x,o.y-=t.y}}},{key:"_declusterAll",value:function(){for(var e=!0;!0===e;){e=!1;for(var t=0;t<this.body.nodeIndices.length;t++)!0===this.body.nodes[this.body.nodeIndices[t]].isCluster&&(e=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[t],{},!1));!0===e&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){var e,t,i=!1,o=!1;for(t in this.lastNodeOnLevel={},this.hierarchical=new xc,this.body.nodes)this.body.nodes.hasOwnProperty(t)&&(void 0!==(e=this.body.nodes[t]).options.level?(i=!0,this.hierarchical.levels[t]=e.options.level):o=!0);if(!0===o&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(!0===o){var n=this.options.hierarchical.sortMethod;"hubsize"===n?this._determineLevelsByHubsize():"directed"===n?this._determineLevelsDirected():"custom"===n&&this._determineLevelsCustomCallback()}for(var s in this.body.nodes)this.body.nodes.hasOwnProperty(s)&&this.hierarchical.ensureLevel(s);var r=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(r),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var e=this,t=!1,i={},o=function(t,i){var o=e.hierarchical.trees;for(var n in o)o.hasOwnProperty(n)&&o[n]===t&&e.direction.shift(n,i)},n=function(){for(var t=[],i=0;i<e.hierarchical.numTrees();i++)t.push(e.direction.getTreeSize(i));return t},s=function t(i,o){if(!o[i.id]&&(o[i.id]=!0,e.hierarchical.childrenReference[i.id])){var n=e.hierarchical.childrenReference[i.id];if(n.length>0)for(var s=0;s<n.length;s++)t(e.body.nodes[n[s]],o)}},r=function(t){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1e9,o=1e9,n=1e9,s=1e9,r=-1e9;for(var a in t)if(t.hasOwnProperty(a)){var h=e.body.nodes[a],d=e.hierarchical.levels[h.id],l=e.direction.getPosition(h),c=e._getSpaceAroundNode(h,t),u=qa(c,2),p=u[0],f=u[1];o=Math.min(p,o),n=Math.min(f,n),d<=i&&(s=Math.min(l,s),r=Math.max(l,r))}return[s,r,o,n]},a=function(t,i){var o=e.hierarchical.getMaxLevel(t.id),n=e.hierarchical.getMaxLevel(i.id);return Math.min(o,n)},h=function(t,i,o){for(var n=e.hierarchical,s=0;s<i.length;s++){var r=i[s],a=n.distributionOrdering[r];if(a.length>1)for(var h=0;h<a.length-1;h++){var d=a[h],l=a[h+1];n.hasSameParent(d,l)&&n.inSameSubNetwork(d,l)&&t(d,l,o)}}},d=function(i,o){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],h=e.direction.getPosition(i),d=e.direction.getPosition(o),l=Math.abs(d-h),c=e.options.hierarchical.nodeSpacing;if(l>c){var u={},p={};s(i,u),s(o,p);var f=a(i,o),v=r(u,f),g=r(p,f),y=v[1],m=g[0],b=g[2],w=Math.abs(y-m);if(w>c){var k=y-m+c;k<-b+c&&(k=-b+c),k<0&&(e._shiftBlock(o.id,k),t=!0,!0===n&&e._centerParent(o))}}},l=function(o,n){for(var a=n.id,h=n.edges,d=e.hierarchical.levels[n.id],l=e.options.hierarchical.levelSeparation*e.options.hierarchical.levelSeparation,c={},u=[],p=0;p<h.length;p++){var f=h[p];if(f.toId!=f.fromId){var v=f.toId==a?f.from:f.to;c[h[p].id]=v,e.hierarchical.levels[v.id]<d&&u.push(f)}}var g=function(t,i){for(var o=0,n=0;n<i.length;n++)if(void 0!==c[i[n].id]){var s=e.direction.getPosition(c[i[n].id])-t;o+=s/Math.sqrt(s*s+l)}return o},y=function(t,i){for(var o=0,n=0;n<i.length;n++)if(void 0!==c[i[n].id]){var s=e.direction.getPosition(c[i[n].id])-t;o-=l*Math.pow(s*s+l,-1.5)}return o},m=function(t,i){for(var o=e.direction.getPosition(n),s={},r=0;r<t;r++){var a=g(o,i),h=y(o,i);if(void 0!==s[o-=Math.max(-40,Math.min(40,Math.round(a/h)))])break;s[o]=r}return o},b=m(o,u);!function(o){var a=e.direction.getPosition(n);if(void 0===i[n.id]){var h={};s(n,h),i[n.id]=h}var d=r(i[n.id]),l=d[2],c=d[3],u=o-a,p=0;u>0?p=Math.min(u,c-e.options.hierarchical.nodeSpacing):u<0&&(p=-Math.min(-u,l-e.options.hierarchical.nodeSpacing)),0!=p&&(e._shiftBlock(n.id,p),t=!0)}(b),function(i){var o=e.direction.getPosition(n),s=e._getSpaceAroundNode(n),r=qa(s,2),a=r[0],h=r[1],d=i-o,l=o;d>0?l=Math.min(o+(h-e.options.hierarchical.nodeSpacing),i):d<0&&(l=Math.max(o-(a-e.options.hierarchical.nodeSpacing),i)),l!==o&&(e.direction.setPosition(n,l),t=!0)}(b=m(o,h))};!0===this.options.hierarchical.blockShifting&&(function(i){var o=e.hierarchical.getLevels();o=ll(o).call(o);for(var n=0;n<i&&(t=!1,h(d,o,!0),!0===t);n++);}(5),function(){for(var t in e.body.nodes)e.body.nodes.hasOwnProperty(t)&&e._centerParent(e.body.nodes[t])}()),!0===this.options.hierarchical.edgeMinimization&&function(i){var o=e.hierarchical.getLevels();o=ll(o).call(o);for(var n=0;n<i;n++){t=!1;for(var s=0;s<o.length;s++)for(var r=o[s],a=e.hierarchical.distributionOrdering[r],h=0;h<a.length;h++)l(1e3,a[h]);if(!0!==t)break}}(20),!0===this.options.hierarchical.parentCentralization&&function(){var t=e.hierarchical.getLevels();t=ll(t).call(t);for(var i=0;i<t.length;i++)for(var o=t[i],n=e.hierarchical.distributionOrdering[o],s=0;s<n.length;s++)e._centerParent(n[s])}(),function(){for(var t=n(),i=0,s=0;s<t.length-1;s++){i+=t[s].max-t[s+1].min+e.options.hierarchical.treeSpacing,o(s+1,i)}}()}},{key:"_getSpaceAroundNode",value:function(e,t){var i=!0;void 0===t&&(i=!1);var o=this.hierarchical.levels[e.id];if(void 0!==o){var n=this.hierarchical.distributionIndex[e.id],s=this.direction.getPosition(e),r=this.hierarchical.distributionOrdering[o],a=1e9,h=1e9;if(0!==n){var d=r[n-1];if(!0===i&&void 0===t[d.id]||!1===i)a=s-this.direction.getPosition(d)}if(n!=r.length-1){var l=r[n+1];if(!0===i&&void 0===t[l.id]||!1===i){var c=this.direction.getPosition(l);h=Math.min(h,c-s)}}return[a,h]}return[0,0]}},{key:"_centerParent",value:function(e){if(this.hierarchical.parentReference[e.id])for(var t=this.hierarchical.parentReference[e.id],i=0;i<t.length;i++){var o=t[i],n=this.body.nodes[o],s=this.hierarchical.childrenReference[o];if(void 0!==s){var r=this._getCenterPosition(s),a=this.direction.getPosition(n),h=this._getSpaceAroundNode(n),d=qa(h,2),l=d[0],c=d[1],u=a-r;(u<0&&Math.abs(u)<c-this.options.hierarchical.nodeSpacing||u>0&&Math.abs(u)<l-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(n,r)}}}},{key:"_placeNodesByHierarchy",value:function(e){for(var t in this.positionedNodes={},e)if(e.hasOwnProperty(t)){var i,o=kr(e[t]);o=this._indexArrayToNodes(o),ac(i=this.direction).call(i,o);for(var n=0,s=0;s<o.length;s++){var r=o[s];if(void 0===this.positionedNodes[r.id]){var a=this.options.hierarchical.nodeSpacing,h=a*n;n>0&&(h=this.direction.getPosition(o[s-1])+a),this.direction.setPosition(r,h,t),this._validatePositionAndContinue(r,t,h),n++}}}}},{key:"_placeBranchNodes",value:function(e,t){var i,o=this.hierarchical.childrenReference[e];if(void 0!==o){for(var n=[],s=0;s<o.length;s++)n.push(this.body.nodes[o[s]]);ac(i=this.direction).call(i,n);for(var r=0;r<n.length;r++){var a=n[r],h=this.hierarchical.levels[a.id];if(!(h>t&&void 0===this.positionedNodes[a.id]))return;var d=this.options.hierarchical.nodeSpacing,l=void 0;l=0===r?this.direction.getPosition(this.body.nodes[e]):this.direction.getPosition(n[r-1])+d,this.direction.setPosition(a,l,h),this._validatePositionAndContinue(a,h,l)}var c=this._getCenterPosition(n);this.direction.setPosition(this.body.nodes[e],c,t)}}},{key:"_validatePositionAndContinue",value:function(e,t,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[t]){var o=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[t]]);if(i-o<this.options.hierarchical.nodeSpacing){var n=o+this.options.hierarchical.nodeSpacing-i,s=this._findCommonParent(this.lastNodeOnLevel[t],e.id);this._shiftBlock(s.withChild,n)}}this.lastNodeOnLevel[t]=e.id,this.positionedNodes[e.id]=!0,this._placeBranchNodes(e.id,t)}}},{key:"_indexArrayToNodes",value:function(e){for(var t=[],i=0;i<e.length;i++)t.push(this.body.nodes[e[i]]);return t}},{key:"_getDistribution",value:function(){var e,t,i={};for(e in this.body.nodes)if(this.body.nodes.hasOwnProperty(e)){t=this.body.nodes[e];var o=void 0===this.hierarchical.levels[e]?0:this.hierarchical.levels[e];this.direction.fix(t,o),void 0===i[o]&&(i[o]={}),i[o][e]=t}return i}},{key:"_getActiveEdges",value:function(e){var i=this,o=[];return t.forEach(e.edges,(function(e){var t;-1!==Vi(t=i.body.edgeIndices).call(t,e.id)&&o.push(e)})),o}},{key:"_getHubSizes",value:function(){var e=this,i={},o=this.body.nodeIndices;t.forEach(o,(function(t){var o=e.body.nodes[t],n=e._getActiveEdges(o).length;i[n]=!0}));var n=[];return t.forEach(i,(function(e){n.push(Number(e))})),ac(dc).call(dc,n,(function(e,t){return t-e})),n}},{key:"_determineLevelsByHubsize",value:function(){for(var e=this,i=function(t,i){e.hierarchical.levelDownstream(t,i)},o=this._getHubSizes(),n=function(n){var s=o[n];if(0===s)return"break";t.forEach(e.body.nodeIndices,(function(t){var o=e.body.nodes[t];s===e._getActiveEdges(o).length&&e._crawlNetwork(i,t)}))},s=0;s<o.length;++s){if("break"===n(s))break}}},{key:"_determineLevelsCustomCallback",value:function(){var e=this;this._crawlNetwork((function(t,i,o){var n=e.hierarchical.levels[t.id];void 0===n&&(n=e.hierarchical.levels[t.id]=1e5);var s=(cl.cloneOptions(t,"node"),cl.cloneOptions(i,"node"),void cl.cloneOptions(o,"edge"));e.hierarchical.levels[i.id]=n+s})),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var e,t=this,i=Jl(e=this.body.nodeIndices).call(e,(function(e,i){return e.set(i,t.body.nodes[i]),e}),new Ul),o=this.hierarchical.levels;"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Yi(null);return _c((function(t){var i,o;return bc(i=Rr(o=t.edges).call(o,(function(t){return e.has(t.toId)}))).call(i,(function(e){return e.from===t}))}),(function(e,t){return t<e}),"to",e,t)}(i,o):this.hierarchical.levels=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Yi(null);return _c((function(t){var i,o;return bc(i=Rr(o=t.edges).call(o,(function(t){return e.has(t.toId)}))).call(i,(function(e){return e.to===t}))}),(function(e,t){return t>e}),"from",e,t)}(i,o),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var e=this;this._crawlNetwork((function(t,i){e.hierarchical.levels[i.id]>e.hierarchical.levels[t.id]&&e.hierarchical.addRelation(t.id,i.id)})),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,o={},n=function i(n,s){if(void 0===o[n.id]){var r;e.hierarchical.setTreeIndex(n,s),o[n.id]=!0;for(var a=e._getActiveEdges(n),h=0;h<a.length;h++){var d=a[h];!0===d.connected&&(r=d.toId==n.id?d.from:d.to,n.id!=r.id&&(t(n,r,d),i(r,s)))}}};if(void 0===i)for(var s=0,r=0;r<this.body.nodeIndices.length;r++){var a=this.body.nodeIndices[r];if(void 0===o[a]){var h=this.body.nodes[a];n(h,s),s+=1}}else{var d=this.body.nodes[i];if(void 0===d)return void console.error("Node not found:",i);n(d)}}},{key:"_shiftBlock",value:function(e,t){var i=this,o={};!function e(n){if(!o[n]){o[n]=!0,i.direction.shift(n,t);var s=i.hierarchical.childrenReference[n];if(void 0!==s)for(var r=0;r<s.length;r++)e(s[r])}}(e)}},{key:"_findCommonParent",value:function(e,t){var i=this,o={};return function e(t,o){var n=i.hierarchical.parentReference[o];if(void 0!==n)for(var s=0;s<n.length;s++){var r=n[s];t[r]=!0,e(t,r)}}(o,e),function e(t,o){var n=i.hierarchical.parentReference[o];if(void 0!==n)for(var s=0;s<n.length;s++){var r=n[s];if(void 0!==t[r])return{foundParent:r,withChild:o};var a=e(t,r);if(null!==a.foundParent)return a}return{foundParent:null,withChild:o}}(o,t)}},{key:"setDirectionStrategy",value:function(){var e="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=e?new uc(this):new pc(this)}},{key:"_getCenterPosition",value:function(e){for(var t=1e9,i=-1e9,o=0;o<e.length;o++){var n=void 0;if(void 0!==e[o].id)n=e[o];else{var s=e[o];n=this.body.nodes[s]}var r=this.direction.getPosition(n);t=Math.min(t,r),i=Math.max(i,r)}return.5*(t+i)}}]),e}(),Oc=function(){function e(i,o,n,s){var r,a,h=this;Ks(this,e),this.body=i,this.canvas=o,this.selectionHandler=n,this.interactionHandler=s,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this.manipulationHammers=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},t.extend(this.options,this.defaultOptions),this.body.emitter.on("destroy",(function(){h._clean()})),this.body.emitter.on("_dataChanged",ie(r=this._restore).call(r,this)),this.body.emitter.on("_resetData",ie(a=this._restore).call(a,this))}return Qs(e,[{key:"_restore",value:function(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(e,i,o){void 0!==i&&(void 0!==i.locale?this.options.locale=i.locale:this.options.locale=o.locale,void 0!==i.locales?this.options.locales=i.locales:this.options.locales=o.locales),void 0!==e&&("boolean"==typeof e?this.options.enabled=e:(this.options.enabled=!0,t.deepExtend(this.options,e)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){var e,t;this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var i=this.selectionHandler._getSelectedNodeCount(),o=this.selectionHandler._getSelectedEdgeCount(),n=i+o,s=this.options.locales[this.options.locale],r=!1;!1!==this.options.addNode&&(this._createAddNodeButton(s),r=!0),!1!==this.options.addEdge&&(!0===r?this._createSeperator(1):r=!0,this._createAddEdgeButton(s)),1===i&&"function"==typeof this.options.editNode?(!0===r?this._createSeperator(2):r=!0,this._createEditNodeButton(s)):1===o&&0===i&&!1!==this.options.editEdge&&(!0===r?this._createSeperator(3):r=!0,this._createEditEdgeButton(s)),0!==n&&(i>0&&!1!==this.options.deleteNode?(!0===r&&this._createSeperator(4),this._createDeleteButton(s)):0===i&&!1!==this.options.deleteEdge&&(!0===r&&this._createSeperator(4),this._createDeleteButton(s))),this._bindHammerToDiv(this.closeDiv,ie(e=this.toggleEditMode).call(e,this)),this._temporaryBindEvent("select",ie(t=this.showManipulatorToolbar).call(t,this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){var e;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){var t,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.addDescription||this.options.locales.en.addDescription),this._bindHammerToDiv(this.closeDiv,ie(t=this.toggleEditMode).call(t,this))}this._temporaryBindEvent("click",ie(e=this._performAddNode).call(e,this))}},{key:"editNode",value:function(){var e=this;!0!==this.editMode&&this.enableEditMode(),this._clean();var i=this.selectionHandler._getSelectedNode();if(void 0!==i){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==i.isCluster){var o=t.deepExtend({},i.options,!1);if(o.x=i.x,o.y=i.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(o,(function(t){null!=t&&"editNode"===e.inMode&&e.body.data.nodes.getDataSet().update(t),e.showManipulatorToolbar()}))}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){var e,t,i,o,n;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){var s,r=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(r),this._createSeperator(),this._createDescription(r.edgeDescription||this.options.locales.en.edgeDescription),this._bindHammerToDiv(this.closeDiv,ie(s=this.toggleEditMode).call(s,this))}this._temporaryBindUI("onTouch",ie(e=this._handleConnect).call(e,this)),this._temporaryBindUI("onDragEnd",ie(t=this._finishConnect).call(t,this)),this._temporaryBindUI("onDrag",ie(i=this._dragControlNode).call(i,this)),this._temporaryBindUI("onRelease",ie(o=this._finishConnect).call(o,this)),this._temporaryBindUI("onDragStart",ie(n=this._dragStartEdge).call(n,this)),this._temporaryBindUI("onHold",(function(){}))}},{key:"editEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!==eh(this.options.editEdge)||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){var e,t=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(t),this._createSeperator(),this._createDescription(t.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindHammerToDiv(this.closeDiv,ie(e=this.toggleEditMode).call(e,this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0!==this.edgeBeingEditedId){var i,o,n,s,r=this.body.edges[this.edgeBeingEditedId],a=this._getNewTargetNode(r.from.x,r.from.y),h=this._getNewTargetNode(r.to.x,r.to.y);this.temporaryIds.nodes.push(a.id),this.temporaryIds.nodes.push(h.id),this.body.nodes[a.id]=a,this.body.nodeIndices.push(a.id),this.body.nodes[h.id]=h,this.body.nodeIndices.push(h.id),this._temporaryBindUI("onTouch",ie(i=this._controlNodeTouch).call(i,this)),this._temporaryBindUI("onTap",(function(){})),this._temporaryBindUI("onHold",(function(){})),this._temporaryBindUI("onDragStart",ie(o=this._controlNodeDragStart).call(o,this)),this._temporaryBindUI("onDrag",ie(n=this._controlNodeDrag).call(n,this)),this._temporaryBindUI("onDragEnd",ie(s=this._controlNodeDragEnd).call(s,this)),this._temporaryBindUI("onMouseMove",(function(){})),this._temporaryBindEvent("beforeDrawing",(function(e){var t=r.edgeType.findBorderPositions(e);!1===a.selected&&(a.x=t.from.x,a.y=t.from.y),!1===h.selected&&(h.x=t.to.x,h.y=t.to.y)})),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var d=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(d.from.id,d.to.id)}}},{key:"deleteSelected",value:function(){var e=this;!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";var t=this.selectionHandler.getSelectedNodes(),i=this.selectionHandler.getSelectedEdges(),o=void 0;if(t.length>0){for(var n=0;n<t.length;n++)if(!0===this.body.nodes[t[n]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(o=this.options.deleteNode)}else i.length>0&&"function"==typeof this.options.deleteEdge&&(o=this.options.deleteEdge);if("function"==typeof o){var s={nodes:t,edges:i};if(2!==o.length)throw new Error("The function for delete does not support two arguments (data, callback)");o(s,(function(t){null!=t&&"delete"===e.inMode?(e.body.data.edges.getDataSet().remove(t.edges),e.body.data.nodes.getDataSet().remove(t.nodes),e.body.emitter.emit("startSimulation"),e.showManipulatorToolbar()):(e.body.emitter.emit("startSimulation"),e.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(t),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv&&(this.closeDiv=document.createElement("div"),this.closeDiv.className="vis-close",this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}},{key:"_getNewTargetNode",value:function(e,i){var o=t.deepExtend({},this.options.controlNodeStyle);o.id="targetNode"+t.randomUUID(),o.hidden=!1,o.physics=!1,o.x=e,o.y=i;var n=this.body.functions.createNode(o);return n.shape.boundingBox={left:e,right:e,top:i,bottom:i},n}},{key:"_createEditButton",value:function(){var e;this._clean(),this.manipulationDOM={},t.recursiveDOMDelete(this.editModeDiv);var i=this.options.locales[this.options.locale],o=this._createButton("editMode","vis-button vis-edit vis-edit-mode",i.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(o),this._bindHammerToDiv(o,ie(e=this.toggleEditMode).call(e,this))}},{key:"_clean",value:function(){this.inMode=!1,!0===this.guiEnabled&&(t.recursiveDOMDelete(this.editModeDiv),t.recursiveDOMDelete(this.manipulationDiv),this._cleanManipulatorHammers()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanManipulatorHammers",value:function(){if(0!=this.manipulationHammers.length){for(var e=0;e<this.manipulationHammers.length;e++)this.manipulationHammers[e].destroy();this.manipulationHammers=[]}}},{key:"_removeManipulationDOM",value:function(){this._clean(),t.recursiveDOMDelete(this.manipulationDiv),t.recursiveDOMDelete(this.editModeDiv),t.recursiveDOMDelete(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+e]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+e].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+e])}},{key:"_createAddNodeButton",value:function(e){var t,i=this._createButton("addNode","vis-button vis-add",e.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,ie(t=this.addNodeMode).call(t,this))}},{key:"_createAddEdgeButton",value:function(e){var t,i=this._createButton("addEdge","vis-button vis-connect",e.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,ie(t=this.addEdgeMode).call(t,this))}},{key:"_createEditNodeButton",value:function(e){var t,i=this._createButton("editNode","vis-button vis-edit",e.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,ie(t=this.editNode).call(t,this))}},{key:"_createEditEdgeButton",value:function(e){var t,i=this._createButton("editEdge","vis-button vis-edit",e.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,ie(t=this.editEdgeMode).call(t,this))}},{key:"_createDeleteButton",value:function(e){var t,i;i=this.options.rtl?"vis-button vis-delete-rtl":"vis-button vis-delete";var o=this._createButton("delete",i,e.del||this.options.locales.en.del);this.manipulationDiv.appendChild(o),this._bindHammerToDiv(o,ie(t=this.deleteSelected).call(t,this))}},{key:"_createBackButton",value:function(e){var t,i=this._createButton("back","vis-button vis-back",e.back||this.options.locales.en.back);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,ie(t=this.showManipulatorToolbar).call(t,this))}},{key:"_createButton",value:function(e,t,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"vis-label";return this.manipulationDOM[e+"Div"]=document.createElement("div"),this.manipulationDOM[e+"Div"].className=t,this.manipulationDOM[e+"Label"]=document.createElement("div"),this.manipulationDOM[e+"Label"].className=o,this.manipulationDOM[e+"Label"].innerHTML=i,this.manipulationDOM[e+"Div"].appendChild(this.manipulationDOM[e+"Label"]),this.manipulationDOM[e+"Div"]}},{key:"_createDescription",value:function(e){this.manipulationDiv.appendChild(this._createButton("description","vis-button vis-none",e))}},{key:"_temporaryBindEvent",value:function(e,t){this.temporaryEventFunctions.push({event:e,boundFunction:t}),this.body.emitter.on(e,t)}},{key:"_temporaryBindUI",value:function(e,t){if(void 0===this.body.eventListeners[e])throw new Error("This UI function does not exist. Typo? You tried: "+e+" possible are: "+ad(kr(this.body.eventListeners)));this.temporaryUIFunctions[e]=this.body.eventListeners[e],this.body.eventListeners[e]=t}},{key:"_unbindTemporaryUIs",value:function(){for(var e in this.temporaryUIFunctions)this.temporaryUIFunctions.hasOwnProperty(e)&&(this.body.eventListeners[e]=this.temporaryUIFunctions[e],delete this.temporaryUIFunctions[e]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var e=0;e<this.temporaryEventFunctions.length;e++){var t=this.temporaryEventFunctions[e].event,i=this.temporaryEventFunctions[e].boundFunction;this.body.emitter.off(t,i)}this.temporaryEventFunctions=[]}},{key:"_bindHammerToDiv",value:function(e,t){var i=new Us(e,{});gl.onTouch(i,t),this.manipulationHammers.push(i)}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var e=0;e<this.temporaryIds.edges.length;e++){var t;this.body.edges[this.temporaryIds.edges[e]].disconnect(),delete this.body.edges[this.temporaryIds.edges[e]];var i,o=Vi(t=this.body.edgeIndices).call(t,this.temporaryIds.edges[e]);if(-1!==o)Oi(i=this.body.edgeIndices).call(i,o,1)}for(var n=0;n<this.temporaryIds.nodes.length;n++){var s;delete this.body.nodes[this.temporaryIds.nodes[n]];var r,a=Vi(s=this.body.nodeIndices).call(s,this.temporaryIds.nodes[n]);if(-1!==a)Oi(r=this.body.nodeIndices).call(r,a,1)}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(e){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=t.extend({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(e){var t=this.lastTouch,i=this.selectionHandler._pointerToPositionObject(t),o=this.body.nodes[this.temporaryIds.nodes[0]],n=this.body.nodes[this.temporaryIds.nodes[1]],s=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var r=o.isOverlappingWith(i),a=n.isOverlappingWith(i);!0===r?(this.selectedControlNode=o,s.edgeType.from=o):!0===a&&(this.selectedControlNode=n,s.edgeType.to=n),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(e){this.body.emitter.emit("disablePhysics");var t=this.body.functions.getPointer(e.center),i=this.canvas.DOMtoCanvas(t);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(e),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),o=this.body.edges[this.edgeBeingEditedId];if(void 0!==this.selectedControlNode){this.selectionHandler.unselectAll();for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=n.length-1;r>=0;r--)if(n[r]!==this.selectedControlNode.id){s=this.body.nodes[n[r]];break}if(void 0!==s&&void 0!==this.selectedControlNode)if(!0===s.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===a.id?this._performEditEdge(s.id,o.to.id):this._performEditEdge(o.from.id,s.id)}else o.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(e){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=t.extend({},this.body.view.translation);var i=this.lastTouch,o=this.selectionHandler.getNodeAt(i);if(void 0!==o)if(!0===o.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var n=this._getNewTargetNode(o.x,o.y);this.body.nodes[n.id]=n,this.body.nodeIndices.push(n.id);var s=this.body.functions.createEdge({id:"connectionEdge"+t.randomUUID(),from:o.id,to:n.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[s.id]=s,this.body.edgeIndices.push(s.id),this.temporaryIds.nodes.push(n.id),this.temporaryIds.edges.push(s.id)}this.touchTime=(new Date).valueOf()}}},{key:"_dragControlNode",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=n.length-1;r>=0;r--){var a;if(-1===Vi(a=this.temporaryIds.nodes).call(a,n[r])){s=this.body.nodes[n[r]];break}}if(e.controlEdge={from:o,to:s?s.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragging",e,t),void 0!==this.temporaryIds.nodes[0]){var h=this.body.nodes[this.temporaryIds.nodes[0]];h.x=this.canvas._XconvertDOMtoCanvas(t.x),h.y=this.canvas._YconvertDOMtoCanvas(t.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(e)}},{key:"_finishConnect",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=n.length-1;r>=0;r--){var a;if(-1===Vi(a=this.temporaryIds.nodes).call(a,n[r])){s=this.body.nodes[n[r]];break}}this._cleanupTemporaryNodesAndEdges(),void 0!==s&&(!0===s.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[o]&&void 0!==this.body.nodes[s.id]&&this._performAddEdge(o,s.id)),e.controlEdge={from:o,to:s?s.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragEnd",e,t),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(e){var t=this.lastTouch;this.selectionHandler._generateClickEvent("dragStart",e,t,void 0,!0)}},{key:"_performAddNode",value:function(e){var i=this,o={id:t.randomUUID(),x:e.pointer.canvas.x,y:e.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(o,(function(e){null!=e&&"addNode"===i.inMode&&i.body.data.nodes.getDataSet().add(e),i.showManipulatorToolbar()}))}else this.body.data.nodes.getDataSet().add(o),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(e,t){var i=this,o={from:e,to:t};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(o,(function(e){null!=e&&"addEdge"===i.inMode&&(i.body.data.edges.getDataSet().add(e),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().add(o),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(e,t){var i=this,o={id:this.edgeBeingEditedId,from:e,to:t,label:this.body.data.edges.get(this.edgeBeingEditedId).label},n=this.options.editEdge;if("object"===eh(n)&&(n=n.editWithoutDrag),"function"==typeof n){if(2!==n.length)throw new Error("The function for edit does not support two arguments (data, callback)");n(o,(function(e){null==e||"editEdge"!==i.inMode?(i.body.edges[o.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(e),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().update(o),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),e}(),Cc={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},Tc=function(){function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Ks(this,e),this.pixelRatio=t,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Qs(e,[{key:"insertTo",value:function(e){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=e,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(e){if("function"!=typeof e)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=e}},{key:"setCloseCallback",value:function(e){if("function"!=typeof e)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=e}},{key:"_isColorString",value:function(e){if("string"==typeof e)return Cc[e]}},{key:"setColor",value:function(e){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==e){var o,n=this._isColorString(e);if(void 0!==n&&(e=n),!0===t.isString(e)){if(!0===t.isValidRGB(e)){var s=e.substr(4).substr(0,e.length-5).split(",");o={r:s[0],g:s[1],b:s[2],a:1}}else if(!0===t.isValidRGBA(e)){var r=e.substr(5).substr(0,e.length-6).split(",");o={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===t.isValidHex(e)){var a=t.hexToRGB(e);o={r:a.r,g:a.g,b:a.b,a:1}}}else if(e instanceof Object&&void 0!==e.r&&void 0!==e.g&&void 0!==e.b){var h=void 0!==e.a?e.a:"1.0";o={r:e.r,g:e.g,b:e.b,a:h}}if(void 0===o)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+ad(e));this._setColor(o,i)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var e=this,i=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];!0===i&&(this.previousColor=t.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",rr((function(){void 0!==e.closeCallback&&(e.closeCallback(),e.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(e){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];!0===i&&(this.initialColor=t.extend({},e)),this.color=e;var o=t.RGBToHSV(e.r,e.g,e.b),n=2*Math.PI,s=this.r*o.s,r=this.centerCoordinates.x+s*Math.sin(n*o.h),a=this.centerCoordinates.y+s*Math.cos(n*o.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=a-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(e)}},{key:"_setOpacity",value:function(e){this.color.a=e/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(e){var i=t.RGBToHSV(this.color.r,this.color.g,this.color.b);i.v=e/100;var o=t.HSVToRGB(i.h,i.s,i.v);o.a=this.color.a,this.color=o,this._updatePicker()}},{key:"_updatePicker",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,i=t.RGBToHSV(e.r,e.g,e.b),o=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1)),o.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;o.clearRect(0,0,n,s),o.putImageData(this.hueCircle,0,0),o.fillStyle="rgba(0,0,0,"+(1-i.v)+")",o.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),zh(o).call(o),this.brightnessRange.value=100*i.v,this.opacityRange.value=100*e.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var e,t,i,o;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var n=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(n.webkitBackingStorePixelRatio||n.mozBackingStorePixelRatio||n.msBackingStorePixelRatio||n.oBackingStorePixelRatio||n.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var s=document.createElement("DIV");s.style.color="red",s.style.fontWeight="bold",s.style.padding="10px",s.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(s)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(e){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(e){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var r=this;this.opacityRange.onchange=function(){r._setOpacity(this.value)},this.opacityRange.oninput=function(){r._setOpacity(this.value)},this.brightnessRange.onchange=function(){r._setBrightness(this.value)},this.brightnessRange.oninput=function(){r._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=ie(e=this._hide).call(e,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=ie(t=this._apply).call(t,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=ie(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=ie(o=this._loadLast).call(o,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var e=this;this.drag={},this.pinch={},this.hammer=new Us(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),gl.onTouch(this.hammer,(function(t){e._moveSelector(t)})),this.hammer.on("tap",(function(t){e._moveSelector(t)})),this.hammer.on("panstart",(function(t){e._moveSelector(t)})),this.hammer.on("panmove",(function(t){e._moveSelector(t)})),this.hammer.on("panend",(function(t){e._moveSelector(t)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var e=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)),e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var i,o,n,s,r=this.colorPickerCanvas.clientWidth,a=this.colorPickerCanvas.clientHeight;e.clearRect(0,0,r,a),this.centerCoordinates={x:.5*r,y:.5*a},this.r=.49*r;var h,d=2*Math.PI/360,l=1/this.r;for(n=0;n<360;n++)for(s=0;s<this.r;s++)i=this.centerCoordinates.x+s*Math.sin(d*n),o=this.centerCoordinates.y+s*Math.cos(d*n),h=t.HSVToRGB(n*(1/360),s*l,1),e.fillStyle="rgb("+h.r+","+h.g+","+h.b+")",e.fillRect(i-.5,o-.5,2,2);e.strokeStyle="rgba(0,0,0,1)",e.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),e.stroke(),this.hueCircle=e.getImageData(0,0,r,a)}this.generated=!0}},{key:"_moveSelector",value:function(e){var i=this.colorPickerDiv.getBoundingClientRect(),o=e.center.x-i.left,n=e.center.y-i.top,s=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,a=o-r,h=n-s,d=Math.atan2(a,h),l=.98*Math.min(Math.sqrt(a*a+h*h),r),c=Math.cos(d)*l+s,u=Math.sin(d)*l+r;this.colorPickerSelector.style.top=c-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=u-.5*this.colorPickerSelector.clientWidth+"px";var p=d/(2*Math.PI);p=p<0?p+1:p;var f=l/this.r,v=t.RGBToHSV(this.color.r,this.color.g,this.color.b);v.h=p,v.s=f;var g=t.HSVToRGB(v.h,v.s,v.v);g.a=this.color.a,this.color=g,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),e}(),Sc=function(){function e(i,o,n){var s=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Ks(this,e),this.parent=i,this.changedOptions=[],this.container=o,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},t.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new Tc(s),this.wrapper=void 0}return Qs(e,[{key:"setOptions",value:function(e){if(void 0!==e){this.popupHistory={},this._removePopup();var t=!0;if("string"==typeof e)this.options.filter=e;else if(e instanceof Array)this.options.filter=e.join();else if("object"===eh(e)){if(null==e)throw new TypeError("options cannot be null");void 0!==e.container&&(this.options.container=e.container),void 0!==Rr(e)&&(this.options.filter=Rr(e)),void 0!==e.showButton&&(this.options.showButton=e.showButton),void 0!==e.enabled&&(t=e.enabled)}else"boolean"==typeof e?(this.options.filter=!0,t=e):"function"==typeof e&&(this.options.filter=e,t=!0);!1===Rr(this.options)&&(t=!1),this.options.enabled=t}this._clean()}},{key:"setModuleOptions",value:function(e){this.moduleOptions=e,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var e=Rr(this.options),t=0,i=!1;for(var o in this.configureOptions)this.configureOptions.hasOwnProperty(o)&&(this.allowCreation=!1,i=!1,"function"==typeof e?i=(i=e(o,[]))||this._handleObject(this.configureOptions[o],[o],!0):!0!==e&&-1===Vi(e).call(e,o)||(i=!0),!1!==i&&(this.allowCreation=!0,t>0&&this._makeItem([]),this._makeHeader(o),this._handleObject(this.configureOptions[o],[o])),t++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var e=0;e<this.domElements.length;e++)this.wrapper.appendChild(this.domElements[e]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var e=0;e<this.domElements.length;e++)this.wrapper.removeChild(this.domElements[e]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(e){for(var t=this.moduleOptions,i=0;i<e.length;i++){if(void 0===t[e[i]]){t=void 0;break}t=t[e[i]]}return t}},{key:"_makeItem",value:function(e){if(!0===this.allowCreation){var t=document.createElement("div");t.className="vis-configuration vis-config-item vis-config-s"+e.length;for(var i=arguments.length,o=new Array(i>1?i-1:0),n=1;n<i;n++)o[n-1]=arguments[n];return ri(o).call(o,(function(e){t.appendChild(e)})),this.domElements.push(t),this.domElements.length}return 0}},{key:"_makeHeader",value:function(e){var t=document.createElement("div");t.className="vis-configuration vis-config-header",t.innerHTML=e,this._makeItem([],t)}},{key:"_makeLabel",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=document.createElement("div");return o.className="vis-configuration vis-config-label vis-config-s"+t.length,o.innerHTML=!0===i?"<i><b>"+e+":</b></i>":e+":",o}},{key:"_makeDropdown",value:function(e,t,i){var o=document.createElement("select");o.className="vis-configuration vis-config-select";var n=0;void 0!==t&&-1!==Vi(e).call(e,t)&&(n=Vi(e).call(e,t));for(var s=0;s<e.length;s++){var r=document.createElement("option");r.value=e[s],s===n&&(r.selected="selected"),r.innerHTML=e[s],o.appendChild(r)}var a=this;o.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,o)}},{key:"_makeRange",value:function(e,t,i){var o=e[0],n=e[1],s=e[2],r=e[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=n,a.max=s}catch(e){}a.step=r;var h="",d=0;if(void 0!==t){t<0&&1.2*t<n?(a.min=Math.ceil(1.2*t),d=a.min,h="range increased"):t/1.2<n&&(a.min=Math.ceil(t/1.2),d=a.min,h="range increased"),1.2*t>s&&1!==s&&(a.max=Math.ceil(1.2*t),d=a.max,h="range increased"),a.value=t}else a.value=o;var l=document.createElement("input");l.className="vis-configuration vis-config-rangeinput",l.value=a.value;var c=this;a.onchange=function(){l.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){l.value=this.value};var u=this._makeLabel(i[i.length-1],i),p=this._makeItem(i,u,a,l);""!==h&&this.popupHistory[p]!==d&&(this.popupHistory[p]=d,this._setupPopup(h,p))}},{key:"_makeButton",value:function(){var e=this;if(!0===this.options.showButton){var t=document.createElement("div");t.className="vis-configuration vis-config-button",t.innerHTML="generate options",t.onclick=function(){e._printOptions()},t.onmouseover=function(){t.className="vis-configuration vis-config-button hover"},t.onmouseout=function(){t.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(t)}}},{key:"_setupPopup",value:function(e,t){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var o=document.createElement("div");o.id="vis-configuration-popup",o.className="vis-configuration-popup",o.innerHTML=e,o.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:o,index:t}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var e=this;if(void 0!==this.popupDiv.html){var t=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=t.left+"px",this.popupDiv.html.style.top=t.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=rr((function(){e.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=rr((function(){e._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(e,t,i){var o=document.createElement("input");o.type="checkbox",o.className="vis-configuration vis-config-checkbox",o.checked=e,void 0!==t&&(o.checked=t,t!==e&&("object"===eh(e)?t!==e.enabled&&this.changedOptions.push({path:i,value:t}):this.changedOptions.push({path:i,value:t})));var n=this;o.onchange=function(){n._update(this.checked,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_makeTextInput",value:function(e,t,i){var o=document.createElement("input");o.type="text",o.className="vis-configuration vis-config-text",o.value=t,t!==e&&this.changedOptions.push({path:i,value:t});var n=this;o.onchange=function(){n._update(this.value,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_makeColorField",value:function(e,t,i){var o=this,n=e[1],s=document.createElement("div");"none"!==(t=void 0===t?n:t)?(s.className="vis-configuration vis-config-colorBlock",s.style.backgroundColor=t):s.className="vis-configuration vis-config-colorBlock none",t=void 0===t?n:t,s.onclick=function(){o._showColorPicker(t,s,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,s)}},{key:"_showColorPicker",value:function(e,t,i){var o=this;t.onclick=function(){},this.colorPicker.insertTo(t),this.colorPicker.show(),this.colorPicker.setColor(e),this.colorPicker.setUpdateCallback((function(e){var n="rgba("+e.r+","+e.g+","+e.b+","+e.a+")";t.style.backgroundColor=n,o._update(n,i)})),this.colorPicker.setCloseCallback((function(){t.onclick=function(){o._showColorPicker(e,t,i)}}))}},{key:"_handleObject",value:function(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,s=Rr(this.options),r=!1;for(var a in e)if(e.hasOwnProperty(a)){n=!0;var h=e[a],d=t.copyAndExtendArray(i,a);if("function"==typeof s&&!1===(n=s(a,i))&&!(h instanceof Array)&&"string"!=typeof h&&"boolean"!=typeof h&&h instanceof Object&&(this.allowCreation=!1,n=this._handleObject(h,d,!0),this.allowCreation=!1===o),!1!==n){r=!0;var l=this._getValue(d);if(h instanceof Array)this._handleArray(h,l,d);else if("string"==typeof h)this._makeTextInput(h,l,d);else if("boolean"==typeof h)this._makeCheckbox(h,l,d);else if(h instanceof Object){var c=!0;if(-1!==Vi(i).call(i,"physics")&&this.moduleOptions.physics.solver!==a&&"wind"!==a&&(c=!1),!0===c)if(void 0!==h.enabled){var u=t.copyAndExtendArray(d,"enabled"),p=this._getValue(u);if(!0===p){var f=this._makeLabel(a,d,!0);this._makeItem(d,f),r=this._handleObject(h,d)||r}else this._makeCheckbox(h,p,d)}else{var v=this._makeLabel(a,d,!0);this._makeItem(d,v),r=this._handleObject(h,d)||r}}else console.error("dont know how to handle",h,a,d)}}return r}},{key:"_handleArray",value:function(e,t,i){"string"==typeof e[0]&&"color"===e[0]?(this._makeColorField(e,t,i),e[1]!==t&&this.changedOptions.push({path:i,value:t})):"string"==typeof e[0]?(this._makeDropdown(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:t})):"number"==typeof e[0]&&(this._makeRange(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:Number(t)}))}},{key:"_update",value:function(e,t){var i=this._constructOptions(e,t);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=i;e="false"!==(e="true"===e||e)&&e;for(var n=0;n<t.length;n++)"global"!==t[n]&&(void 0===o[t[n]]&&(o[t[n]]={}),n!==t.length-1?o=o[t[n]]:o[t[n]]=e);return i}},{key:"_printOptions",value:function(){var e=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+ad(e,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var e={},t=0;t<this.changedOptions.length;t++)this._constructOptions(this.changedOptions[t].value,this.changedOptions[t].path,e);return e}}]),e}(),Mc="string",Dc="boolean",Ic="number",Pc="object",Fc=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],Bc={configure:{enabled:{boolean:Dc},filter:{boolean:Dc,string:Mc,array:"array",function:"function"},container:{dom:"dom"},showButton:{boolean:Dc},__type__:{object:Pc,boolean:Dc,string:Mc,array:"array",function:"function"}},edges:{arrows:{to:{enabled:{boolean:Dc},scaleFactor:{number:Ic},type:{string:Fc},imageHeight:{number:Ic},imageWidth:{number:Ic},src:{string:Mc},__type__:{object:Pc,boolean:Dc}},middle:{enabled:{boolean:Dc},scaleFactor:{number:Ic},type:{string:Fc},imageWidth:{number:Ic},imageHeight:{number:Ic},src:{string:Mc},__type__:{object:Pc,boolean:Dc}},from:{enabled:{boolean:Dc},scaleFactor:{number:Ic},type:{string:Fc},imageWidth:{number:Ic},imageHeight:{number:Ic},src:{string:Mc},__type__:{object:Pc,boolean:Dc}},__type__:{string:["from","to","middle"],object:Pc}},arrowStrikethrough:{boolean:Dc},background:{enabled:{boolean:Dc},color:{string:Mc},size:{number:Ic},dashes:{boolean:Dc,array:"array"},__type__:{object:Pc,boolean:Dc}},chosen:{label:{boolean:Dc,function:"function"},edge:{boolean:Dc,function:"function"},__type__:{object:Pc,boolean:Dc}},color:{color:{string:Mc},highlight:{string:Mc},hover:{string:Mc},inherit:{string:["from","to","both"],boolean:Dc},opacity:{number:Ic},__type__:{object:Pc,string:Mc}},dashes:{boolean:Dc,array:"array"},font:{color:{string:Mc},size:{number:Ic},face:{string:Mc},background:{string:Mc},strokeWidth:{number:Ic},strokeColor:{string:Mc},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:Ic},multi:{boolean:Dc,string:Mc},bold:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},boldital:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},ital:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},mono:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},__type__:{object:Pc,string:Mc}},hidden:{boolean:Dc},hoverWidth:{function:"function",number:Ic},label:{string:Mc,undefined:"undefined"},labelHighlightBold:{boolean:Dc},length:{number:Ic,undefined:"undefined"},physics:{boolean:Dc},scaling:{min:{number:Ic},max:{number:Ic},label:{enabled:{boolean:Dc},min:{number:Ic},max:{number:Ic},maxVisible:{number:Ic},drawThreshold:{number:Ic},__type__:{object:Pc,boolean:Dc}},customScalingFunction:{function:"function"},__type__:{object:Pc}},selectionWidth:{function:"function",number:Ic},selfReferenceSize:{number:Ic},selfReference:{size:{number:Ic},angle:{number:Ic},renderBehindTheNode:{boolean:Dc},__type__:{object:Pc}},shadow:{enabled:{boolean:Dc},color:{string:Mc},size:{number:Ic},x:{number:Ic},y:{number:Ic},__type__:{object:Pc,boolean:Dc}},smooth:{enabled:{boolean:Dc},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:Ic},forceDirection:{string:["horizontal","vertical","none"],boolean:Dc},__type__:{object:Pc,boolean:Dc}},title:{string:Mc,undefined:"undefined"},width:{number:Ic},widthConstraint:{maximum:{number:Ic},__type__:{object:Pc,boolean:Dc,number:Ic}},value:{number:Ic,undefined:"undefined"},__type__:{object:Pc}},groups:{useDefaultGroups:{boolean:Dc},__any__:"get from nodes, will be overwritten below",__type__:{object:Pc}},interaction:{dragNodes:{boolean:Dc},dragView:{boolean:Dc},hideEdgesOnDrag:{boolean:Dc},hideEdgesOnZoom:{boolean:Dc},hideNodesOnDrag:{boolean:Dc},hover:{boolean:Dc},keyboard:{enabled:{boolean:Dc},speed:{x:{number:Ic},y:{number:Ic},zoom:{number:Ic},__type__:{object:Pc}},bindToWindow:{boolean:Dc},__type__:{object:Pc,boolean:Dc}},multiselect:{boolean:Dc},navigationButtons:{boolean:Dc},selectable:{boolean:Dc},selectConnectedEdges:{boolean:Dc},hoverConnectedEdges:{boolean:Dc},tooltipDelay:{number:Ic},zoomView:{boolean:Dc},zoomSpeed:{number:Ic},__type__:{object:Pc}},layout:{randomSeed:{undefined:"undefined",number:Ic},improvedLayout:{boolean:Dc},clusterThreshold:{number:Ic},hierarchical:{enabled:{boolean:Dc},levelSeparation:{number:Ic},nodeSpacing:{number:Ic},treeSpacing:{number:Ic},blockShifting:{boolean:Dc},edgeMinimization:{boolean:Dc},parentCentralization:{boolean:Dc},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:Pc,boolean:Dc}},__type__:{object:Pc}},manipulation:{enabled:{boolean:Dc},initiallyActive:{boolean:Dc},addNode:{boolean:Dc,function:"function"},addEdge:{boolean:Dc,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:Pc,boolean:Dc,function:"function"}},deleteNode:{boolean:Dc,function:"function"},deleteEdge:{boolean:Dc,function:"function"},controlNodeStyle:"get from nodes, will be overwritten below",__type__:{object:Pc,boolean:Dc}},nodes:{borderWidth:{number:Ic},borderWidthSelected:{number:Ic,undefined:"undefined"},brokenImage:{string:Mc,undefined:"undefined"},chosen:{label:{boolean:Dc,function:"function"},node:{boolean:Dc,function:"function"},__type__:{object:Pc,boolean:Dc}},color:{border:{string:Mc},background:{string:Mc},highlight:{border:{string:Mc},background:{string:Mc},__type__:{object:Pc,string:Mc}},hover:{border:{string:Mc},background:{string:Mc},__type__:{object:Pc,string:Mc}},__type__:{object:Pc,string:Mc}},fixed:{x:{boolean:Dc},y:{boolean:Dc},__type__:{object:Pc,boolean:Dc}},font:{align:{string:Mc},color:{string:Mc},size:{number:Ic},face:{string:Mc},background:{string:Mc},strokeWidth:{number:Ic},strokeColor:{string:Mc},vadjust:{number:Ic},multi:{boolean:Dc,string:Mc},bold:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},boldital:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},ital:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},mono:{color:{string:Mc},size:{number:Ic},face:{string:Mc},mod:{string:Mc},vadjust:{number:Ic},__type__:{object:Pc,string:Mc}},__type__:{object:Pc,string:Mc}},group:{string:Mc,number:Ic,undefined:"undefined"},heightConstraint:{minimum:{number:Ic},valign:{string:Mc},__type__:{object:Pc,boolean:Dc,number:Ic}},hidden:{boolean:Dc},icon:{face:{string:Mc},code:{string:Mc},size:{number:Ic},color:{string:Mc},weight:{string:Mc,number:Ic},__type__:{object:Pc}},id:{string:Mc,number:Ic},image:{selected:{string:Mc,undefined:"undefined"},unselected:{string:Mc,undefined:"undefined"},__type__:{object:Pc,string:Mc}},imagePadding:{top:{number:Ic},right:{number:Ic},bottom:{number:Ic},left:{number:Ic},__type__:{object:Pc,number:Ic}},label:{string:Mc,undefined:"undefined"},labelHighlightBold:{boolean:Dc},level:{number:Ic,undefined:"undefined"},margin:{top:{number:Ic},right:{number:Ic},bottom:{number:Ic},left:{number:Ic},__type__:{object:Pc,number:Ic}},mass:{number:Ic},physics:{boolean:Dc},scaling:{min:{number:Ic},max:{number:Ic},label:{enabled:{boolean:Dc},min:{number:Ic},max:{number:Ic},maxVisible:{number:Ic},drawThreshold:{number:Ic},__type__:{object:Pc,boolean:Dc}},customScalingFunction:{function:"function"},__type__:{object:Pc}},shadow:{enabled:{boolean:Dc},color:{string:Mc},size:{number:Ic},x:{number:Ic},y:{number:Ic},__type__:{object:Pc,boolean:Dc}},shape:{string:["ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},shapeProperties:{borderDashes:{boolean:Dc,array:"array"},borderRadius:{number:Ic},interpolation:{boolean:Dc},useImageSize:{boolean:Dc},useBorderWithImage:{boolean:Dc},__type__:{object:Pc}},size:{number:Ic},title:{string:Mc,dom:"dom",undefined:"undefined"},value:{number:Ic,undefined:"undefined"},widthConstraint:{minimum:{number:Ic},maximum:{number:Ic},__type__:{object:Pc,boolean:Dc,number:Ic}},x:{number:Ic},y:{number:Ic},__type__:{object:Pc}},physics:{enabled:{boolean:Dc},barnesHut:{gravitationalConstant:{number:Ic},centralGravity:{number:Ic},springLength:{number:Ic},springConstant:{number:Ic},damping:{number:Ic},avoidOverlap:{number:Ic},__type__:{object:Pc}},forceAtlas2Based:{gravitationalConstant:{number:Ic},centralGravity:{number:Ic},springLength:{number:Ic},springConstant:{number:Ic},damping:{number:Ic},avoidOverlap:{number:Ic},__type__:{object:Pc}},repulsion:{centralGravity:{number:Ic},springLength:{number:Ic},springConstant:{number:Ic},nodeDistance:{number:Ic},damping:{number:Ic},__type__:{object:Pc}},hierarchicalRepulsion:{centralGravity:{number:Ic},springLength:{number:Ic},springConstant:{number:Ic},nodeDistance:{number:Ic},damping:{number:Ic},avoidOverlap:{number:Ic},__type__:{object:Pc}},maxVelocity:{number:Ic},minVelocity:{number:Ic},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:Dc},iterations:{number:Ic},updateInterval:{number:Ic},onlyDynamicEdges:{boolean:Dc},fit:{boolean:Dc},__type__:{object:Pc,boolean:Dc}},timestep:{number:Ic},adaptiveTimestep:{boolean:Dc},wind:{x:{number:Ic},y:{number:Ic},__type__:{object:Pc}},__type__:{object:Pc,boolean:Dc}},autoResize:{boolean:Dc},clickToUse:{boolean:Dc},locale:{string:Mc},locales:{__any__:{any:"any"},__type__:{object:Pc}},height:{string:Mc},width:{string:Mc},__type__:{object:Pc}};Bc.groups.__any__=Bc.nodes,Bc.manipulation.controlNodeStyle=Bc.nodes;var zc={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],selfReference:{size:[20,0,200,1],angle:[Math.PI/2,-6*Math.PI,6*Math.PI,Math.PI/8],renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,.1,2,.1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01],wind:{x:[0,-10,10,.1],y:[0,-10,10,.1]}}},Nc=Object.freeze({__proto__:null,allOptions:Bc,configureOptions:zc}),Ac=function(){function e(){Ks(this,e)}return Qs(e,[{key:"getDistances",value:function(e,t,i){for(var o={},n=e.edges,s=0;s<t.length;s++){var r={};o[t[s]]=r;for(var a=0;a<t.length;a++)r[t[a]]=s==a?0:1e9}for(var h=0;h<i.length;h++){var d=n[i[h]];!0===d.connected&&void 0!==o[d.fromId]&&void 0!==o[d.toId]&&(o[d.fromId][d.toId]=1,o[d.toId][d.fromId]=1)}for(var l=t.length,c=0;c<l;c++)for(var u=t[c],p=o[u],f=0;f<l-1;f++)for(var v=t[f],g=o[v],y=f+1;y<l;y++){var m=t[y],b=o[m],w=Math.min(g[m],g[u]+p[m]);g[m]=w,b[v]=w}return o}}]),e}(),Rc=function(){function e(t,i,o){Ks(this,e),this.body=t,this.springLength=i,this.springConstant=o,this.distanceSolver=new Ac}return Qs(e,[{key:"setOptions",value:function(e){e&&(e.springLength&&(this.springLength=e.springLength),e.springConstant&&(this.springConstant=e.springConstant))}},{key:"solve",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=this.distanceSolver.getDistances(this.body,e,t);this._createL_matrix(o),this._createK_matrix(o),this._createE_matrix();for(var n=.01,s=1,r=0,a=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),h=5,d=1e9,l=0,c=0,u=0,p=0,f=0;d>n&&r<a;){r+=1;var v=this._getHighestEnergyNode(i),g=qa(v,4);for(l=g[0],d=g[1],c=g[2],u=g[3],p=d,f=0;p>s&&f<h;){f+=1,this._moveNode(l,c,u);var y=this._getEnergy(l),m=qa(y,3);p=m[0],c=m[1],u=m[2]}}}},{key:"_getHighestEnergyNode",value:function(e){for(var t=this.body.nodeIndices,i=this.body.nodes,o=0,n=t[0],s=0,r=0,a=0;a<t.length;a++){var h=t[a];if(!1===i[h].predefinedPosition||!0===i[h].isCluster&&!0===e||!0===i[h].options.fixed.x||!0===i[h].options.fixed.y){var d=this._getEnergy(h),l=qa(d,3),c=l[0],u=l[1],p=l[2];o<c&&(o=c,n=h,s=u,r=p)}}return[n,o,s,r]}},{key:"_getEnergy",value:function(e){var t=qa(this.E_sums[e],2),i=t[0],o=t[1];return[Math.sqrt(Math.pow(i,2)+Math.pow(o,2)),i,o]}},{key:"_moveNode",value:function(e,t,i){for(var o=this.body.nodeIndices,n=this.body.nodes,s=0,r=0,a=0,h=n[e].x,d=n[e].y,l=this.K_matrix[e],c=this.L_matrix[e],u=0;u<o.length;u++){var p=o[u];if(p!==e){var f=n[p].x,v=n[p].y,g=l[p],y=c[p],m=1/Math.pow(Math.pow(h-f,2)+Math.pow(d-v,2),1.5);s+=g*(1-y*Math.pow(d-v,2)*m),r+=g*(y*(h-f)*(d-v)*m),a+=g*(1-y*Math.pow(h-f,2)*m)}}var b=(t/s+i/r)/(r/s-a/r),w=-(r*b+t)/s;n[e].x+=w,n[e].y+=b,this._updateE_matrix(e)}},{key:"_createL_matrix",value:function(e){var t=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var o=0;o<t.length;o++){this.L_matrix[t[o]]={};for(var n=0;n<t.length;n++)this.L_matrix[t[o]][t[n]]=i*e[t[o]][t[n]]}}},{key:"_createK_matrix",value:function(e){var t=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var o=0;o<t.length;o++){this.K_matrix[t[o]]={};for(var n=0;n<t.length;n++)this.K_matrix[t[o]][t[n]]=i*Math.pow(e[t[o]][t[n]],-2)}}},{key:"_createE_matrix",value:function(){var e=this.body.nodeIndices,t=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<e.length;i++)this.E_matrix[e[i]]=[];for(var o=0;o<e.length;o++){for(var n=e[o],s=t[n].x,r=t[n].y,a=0,h=0,d=o;d<e.length;d++){var l=e[d];if(l!==n){var c=t[l].x,u=t[l].y,p=1/Math.sqrt(Math.pow(s-c,2)+Math.pow(r-u,2));this.E_matrix[n][d]=[this.K_matrix[n][l]*(s-c-this.L_matrix[n][l]*(s-c)*p),this.K_matrix[n][l]*(r-u-this.L_matrix[n][l]*(r-u)*p)],this.E_matrix[l][o]=this.E_matrix[n][d],a+=this.E_matrix[n][d][0],h+=this.E_matrix[n][d][1]}}this.E_sums[n]=[a,h]}}},{key:"_updateE_matrix",value:function(e){for(var t=this.body.nodeIndices,i=this.body.nodes,o=this.E_matrix[e],n=this.K_matrix[e],s=this.L_matrix[e],r=i[e].x,a=i[e].y,h=0,d=0,l=0;l<t.length;l++){var c=t[l];if(c!==e){var u=o[l],p=u[0],f=u[1],v=i[c].x,g=i[c].y,y=1/Math.sqrt(Math.pow(r-v,2)+Math.pow(a-g,2)),m=n[c]*(r-v-s[c]*(r-v)*y),b=n[c]*(a-g-s[c]*(a-g)*y);o[l]=[m,b],h+=m,d+=b;var w=this.E_sums[c];w[0]+=m-p,w[1]+=b-f}}this.E_sums[e]=[h,d]}}]),e}();function Lc(e,i,o){var n,s,r,a,h=this;if(!(this instanceof Lc))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:Gs,clickToUse:!1},t.extend(this.options,this.defaultOptions),this.body={container:e,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:ie(n=this.on).call(n,this),off:ie(s=this.off).call(s,this),emit:ie(r=this.emit).call(r,this),once:ie(a=this.once).call(a,this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}}},this.bindEventListeners(),this.images=new tr((function(){return h.body.emitter.emit("_requestRedraw")})),this.groups=new ir,this.canvas=new yl(this.body),this.selectionHandler=new Ol(this.body,this.canvas),this.interactionHandler=new El(this.body,this.canvas,this.selectionHandler),this.view=new kl(this.body,this.canvas),this.renderer=new fl(this.body,this.canvas),this.physics=new sl(this.body),this.layoutEngine=new Ec(this.body),this.clustering=new pl(this.body),this.manipulation=new Oc(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new pd(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new Xd(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new Rc(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(o),this.setData(i)}de(Lc.prototype),Lc.prototype.setOptions=function(e){var i=this;if(null===e&&(e=void 0),void 0!==e){!0===ld.validate(e,Bc)&&console.log("%cErrors have been found in the supplied options object.",dd);if(t.selectiveDeepExtend(["locale","locales","clickToUse"],this.options,e),e=this.layoutEngine.setOptions(e.layout,e),this.canvas.setOptions(e),this.groups.setOptions(e.groups),this.nodesHandler.setOptions(e.nodes),this.edgesHandler.setOptions(e.edges),this.physics.setOptions(e.physics),this.manipulation.setOptions(e.manipulation,e,this.options),this.interactionHandler.setOptions(e.interaction),this.renderer.setOptions(e.interaction),this.selectionHandler.setOptions(e.interaction),void 0!==e.groups&&this.body.emitter.emit("refreshNodes"),"configure"in e&&(this.configurator||(this.configurator=new Sc(this,this.body.container,zc,this.canvas.pixelRatio)),this.configurator.setOptions(e.configure)),this.configurator&&!0===this.configurator.options.enabled){var o={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};t.deepExtend(o.nodes,this.nodesHandler.options),t.deepExtend(o.edges,this.edgesHandler.options),t.deepExtend(o.layout,this.layoutEngine.options),t.deepExtend(o.interaction,this.selectionHandler.options),t.deepExtend(o.interaction,this.renderer.options),t.deepExtend(o.interaction,this.interactionHandler.options),t.deepExtend(o.manipulation,this.manipulation.options),t.deepExtend(o.physics,this.physics.options),t.deepExtend(o.global,this.canvas.options),t.deepExtend(o.global,this.options),this.configurator.setModuleOptions(o)}void 0!==e.clickToUse?!0===e.clickToUse?void 0===this.activator&&(this.activator=new Xs(this.canvas.frame),this.activator.on("change",(function(){i.body.emitter.emit("activate")}))):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},Lc.prototype._updateVisibleIndices=function(){var e=this.body.nodes,t=this.body.edges;for(var i in this.body.nodeIndices=[],this.body.edgeIndices=[],e)e.hasOwnProperty(i)&&(this.clustering._isClusteredNode(i)||!1!==e[i].options.hidden||this.body.nodeIndices.push(e[i].id));for(var o in t)if(t.hasOwnProperty(o)){var n=t[o],s=e[n.fromId],r=e[n.toId],a=void 0!==s&&void 0!==r;!this.clustering._isClusteredEdge(o)&&!1===n.options.hidden&&a&&!1===s.options.hidden&&!1===r.options.hidden&&this.body.edgeIndices.push(n.id)}},Lc.prototype.bindEventListeners=function(){var e=this;this.body.emitter.on("_dataChanged",(function(){e.edgesHandler._updateState(),e.body.emitter.emit("_dataUpdated")})),this.body.emitter.on("_dataUpdated",(function(){e.clustering._updateState(),e._updateVisibleIndices(),e._updateValueRange(e.body.nodes),e._updateValueRange(e.body.edges),e.body.emitter.emit("startSimulation"),e.body.emitter.emit("_requestRedraw")}))},Lc.prototype.setData=function(e){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),e&&e.dot&&(e.nodes||e.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(e&&e.options),e&&e.dot){console.log("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var t=Oo.DOTToGraph(e.dot);this.setData(t)}else if(e&&e.gephi){console.log("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=Fo(e.gephi);this.setData(i)}else this.nodesHandler.setData(e&&e.nodes,!0),this.edgesHandler.setData(e&&e.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},Lc.prototype.destroy=function(){for(var e in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)this.body.nodes.hasOwnProperty(e)&&delete this.body.nodes[e];for(var i in this.body.edges)this.body.edges.hasOwnProperty(i)&&delete this.body.edges[i];t.recursiveDOMDelete(this.body.container)},Lc.prototype._updateValueRange=function(e){var t,i=void 0,o=void 0,n=0;for(t in e)if(e.hasOwnProperty(t)){var s=e[t].getValue();void 0!==s&&(i=void 0===i?s:Math.min(s,i),o=void 0===o?s:Math.max(s,o),n+=s)}if(void 0!==i&&void 0!==o)for(t in e)e.hasOwnProperty(t)&&e[t].setValueRange(i,o,n)},Lc.prototype.isActive=function(){return!this.activator||this.activator.active},Lc.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},Lc.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},Lc.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},Lc.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},Lc.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},Lc.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},Lc.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},Lc.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},Lc.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},Lc.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},Lc.prototype.updateClusteredNode=function(){return this.clustering.updateClusteredNode.apply(this.clustering,arguments)},Lc.prototype.getClusteredEdges=function(){return this.clustering.getClusteredEdges.apply(this.clustering,arguments)},Lc.prototype.getBaseEdge=function(){return this.clustering.getBaseEdge.apply(this.clustering,arguments)},Lc.prototype.getBaseEdges=function(){return this.clustering.getBaseEdges.apply(this.clustering,arguments)},Lc.prototype.updateEdge=function(){return this.clustering.updateEdge.apply(this.clustering,arguments)},Lc.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},Lc.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},Lc.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},Lc.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},Lc.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},Lc.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},Lc.prototype.editNodeMode=function(){return console.log("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},Lc.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},Lc.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},Lc.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},Lc.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},Lc.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},Lc.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},Lc.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},Lc.prototype.getConnectedNodes=function(e){return void 0!==this.body.nodes[e]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},Lc.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},Lc.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},Lc.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},Lc.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},Lc.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},Lc.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},Lc.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodes.apply(this.selectionHandler,arguments)},Lc.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdges.apply(this.selectionHandler,arguments)},Lc.prototype.getNodeAt=function(){var e=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==e&&void 0!==e.id?e.id:e},Lc.prototype.getEdgeAt=function(){var e=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==e&&void 0!==e.id?e.id:e},Lc.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},Lc.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},Lc.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.redraw()},Lc.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},Lc.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},Lc.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},Lc.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},Lc.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},Lc.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},Lc.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},Lc.prototype.getOptionsFromConfigurator=function(){var e={};return this.configurator&&(e=this.configurator.getOptions.apply(this.configurator)),e};var jc=Eo;e.Network=Lc,e.NetworkImages=tr,e.networkDOTParser=Co,e.networkGephiParser=Bo,e.networkOptions=Nc,e.parseDOTNetwork=jc,e.parseGephiNetwork=Fo,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-network.min.js.map
